<?php


/* START //COMMENT_REFERRER// */
require_once ($GLOBALS['abdj_file_licensea']);
/* END //COMMENT_REFERRER// */

class Abdj_Common {

	/*
	This function initializes class variables
	*/
	function Abdj_Common() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";
	} // function Abdj_Common()

	/*
	This checks filepermissions (readable, executeable, writeable)
	for given file/folder and returns an error message.
	*/
	function Check_Filepermissions($check, $file) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($check, $file) <br>";
		$checked = ARRAY ();
		$return_checked = ARRAY ();
		$return_checked['success'] = '';
		$return_checked['msg'] = '';

		if (strtoupper($check) == 'WRITEABLE') {
			$checked = $this->File_Is_Writeable(TRUE, $file);
		}

		$return_checked['success'] = $checked['success'];

		if ($checked['success'] == FALSE) {
			$return_checked['msg'] = '<font class="abdjerror"><u>'.$GLOBALS['abdj_lang']['admin_title_filepermissions'].':</u><br><br>'.$checked['msg'].'<br><br></font>';
		}

		return $return_checked;

	} // function Abdj_Common()

	/*
	This function sets the language used within this class
	*/
	function SetLanguage($language) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$language) <br>";
		$this->lang = $language;

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->lang['status_file_writeable_no']=".$this->lang['status_file_writeable_no']." <br>";

	} // function SetLanguage()

	/*
	This function converts a int variable that is empty or zero to string "0".
	*/
	function FatalError($scriptname, $type, $desc, $para, $die) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($scriptname, $type, $desc, $para, $die) <br>";

		$fatal_msg .= "<html><body bgcolor=white><center>";

		$fatal_msg .= "<br><br><div style=\"padding:20px; background-color:whitesmoke; border:1px solid black; font-family: Verdana, Tahoma, Arial; font-size:14px; color:black; text-align:left; \" >";
		$fatal_msg .= "<b>!! Error in ".$scriptname." !!</b><hr><br>";

		if ($type == "include") {
			$fatal_msg .= "<u><b>Inlude error:</b></u><br><br>".$desc."-file not found for inclusion.<br>file=".$para;
		}

		$fatal_msg .= "</div>";

		$fatal_msg .= "</center></body></html>";

		if ($die == TRUE) {
			die($fatal_msg);
		} else {
			return $fatal_msg;
		}

	} // function FatalError()

	function LanguageArray2Text($lang_array) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($file, $name) <br>";
		$lang_text = " |";
		foreach ($lang_array AS $lang) {
			$lang_text .= $lang."|";
		}
		return $lang_text;
	} // function LanguageArray2Text()

	function Choose2Language() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": <br>";

		global $cf;

		$language_form = "<form method=\"post\" action=\"\">\n";
		$language_form .= "<font class=\"abdjadminformfield\">".$GLOBALS['abdj_lang']['g_field_language']."</font><br>";
		$language_form .= "<select class=\"abdjcfg\" name=\"abdj_post_editlanguage\" size=\"1\" onchange=\"this.form.submit()\" >";
		$language_form .= "<option value=\"\" selected>&nbsp;</option>";
		$language_form .= "<option value=\"".$cf['language']['default']."\">".$cf['language']['default']."</option>";
		if (!empty ($GLOBALS['abdj_config']['2lang_array'][0])) {
			foreach ($GLOBALS['abdj_config']['2lang_array'] AS $lang2) {
				$language_form .= "<option value=\"".$lang2."\">".$lang2."</option>";
			} // foreach
		}

		$language_form .= "</select>";

		$language_form .= "\n</form>\n";

		return $language_form;
	} // function Choose2Language()

	function ChooseEditAddonLanguage($mode, $action) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": <br>";

		$choose_language = '';
		$abdj_admin_panel_flags = '';
		$style = '';

		if ($mode == 'select') {
			$choose_language .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang']['g_field_language_select'].':<hr><br></font>';
		}
		foreach ($GLOBALS['abdj_config']['lang_array'] AS $lang) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$lang=".$lang." <br>";
			if (!empty ($_SESSION[$GLOBALS['abdj_config']['session_name']]['lang_current_editlanguage']) AND $_SESSION[$GLOBALS['abdj_config']['session_name']]['lang_current_editlanguage'] == $lang) {
				$style = 'class="abdjflagselected"';
			} else {
				$style = 'class="abdjflagnotselected"';
			}
			$choose_language .= ' <a href="'.$GLOBALS['abdj_url'][$action].$GLOBALS['abdj_url_amp'].'abdj_get_editlanguage='.$lang.'"><img src="'.$GLOBALS['abdj_path_cmsimple_images_flags'].$lang.'.gif" '.$style.' alt="language flag ('.$lang.')"></a>';
		}
		return $choose_language;
	} // function ChooseEditAddonLanguage()

	// This function is used for creating a select-box with values TRUE/FALSE for
	// Settings of AddOns by djot in admin section
	function Adminconfig_Selectbox_Boolean($alias, $variable) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias, \$variable=$variable) <br>";

		$selected_true = "";
		$selected_false = "";

		if ($variable == TRUE) {
			$selected_true = "selected";
		} else {
			$selected_false = "selected";
		}
		$select_box = "<select class=\"abdjcfg\" name=\"abdj_cfg_var[".$alias."] size=\"1\">";
		$select_box .= "<option value=\"TRUE\" ".$selected_true.">TRUE</option>";
		$select_box .= "<option value=\"FALSE\" ".$selected_false.">FALSE</option>";
		$select_box .= "</select>\n";
		return $select_box;
	} // function Adminconfig_Selectbox_Boolean()

	// This function is used for creating a select-box with
	// populated with values given for
	// Settings of AddOns by djot in admin section
	function Adminconfig_Selectbox_Data($alias, $data, $selected) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias, \$variable=$variable) <br>";

		$select_box = "<select class=\"abdjcfg\" name=\"abdj_cfg_var[".$alias."] size=\"1\">";
		foreach ($data AS $key => $value) {
			if ($value == $selected) {
				$is_selected = "selected";
			} else {
				$is_selected = "";
			}
			$select_box .= "<option value=\"".$key."\" ".$is_selected.">".$value."</option>";
		}
		$select_box .= "</select>\n";
		return $select_box;
	} // function Adminconfig_Selectbox_Data()

	function TimestampToHumanReadable($timestamp) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($file, $name) <br>";

		$time = ARRAY ();

		if ($timestamp > 0) {
			$timestamp = $timestamp + $GLOBALS['abdj_config']['time_difference'];
			//var_dump($GLOBALS['abdj_admin_call']);
			if ($GLOBALS['abdj_admin_call'] == TRUE) {
				$time['date'] = date($GLOBALS['abdj_config']['admin_date_format_numbers'], $timestamp);
				$time['time'] = date($GLOBALS['abdj_config']['admin_time_format_numbers'], $timestamp);
			}
			else {
				$time['date'] = date($GLOBALS['abdj_config']['date_format_numbers'], $timestamp);
				$time['time'] = date($GLOBALS['abdj_config']['time_format_numbers'], $timestamp);
			}
			$time['datetime'] = $time['date'].' '.$time['time'];
		} // if ($timestamp > 0)

		return $time;

	} // function TimestampToHumanReadable()

	function BooleanToInteger($input) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($input=\$input) <br>";

		$bool = 0;
		if (($input == TRUE) OR ($input == 1) OR ($input == "1")) {
			$bool = 1;
		} else {
			$bool = 0;
		}

		return $bool;

	} // function BooleanToInteger()

	// This function removes double quotes, if register_globals is TRUE
	// or adds slashes if register_globals is FALSE
	// So data could be writte to a file like $test = "foo".$filedata."bar";
	// E.g. used for newsletter.queue.php .
	function PostStringTofileString($input) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($input=\$input) <br>";

		$register_globals = ini_get('register_gobals');
		$magic_quotes = get_magic_quotes_gpc();
		if (($register_globals == TRUE) OR ($magic_quotes == TRUE)) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": register_globals==TRUE <br>";

			// nothing to do 
			//$input = stripslashes($input);
		} else {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": register_globals==FALSE <br>";
			$input = addslashes($input);
		}
		return $input;
	} // function BooleanToBoolean()

	function BooleanToBoolean($input) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($input=\$input) <br>";

		if (($input == TRUE) OR ($input == 1) OR ($input == "1")) {
			$bool = TRUE;
		} else {
			$bool = FALSE;
		}

		return $bool;

	} // function BooleanToBoolean()
	function BooleanToString($input) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$input=$input) <br>";

		if ($input == TRUE) {
			$string_bool = "TRUE";
		} else {
			$string_bool = "FALSE";
		}

		return $string_bool;
	} // function BooleanToString()
	function BooleanToStringYesNo($input) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$input=$input) <br>";

		if ($input == TRUE) {
			$string_bool = $GLOBALS['abdj_lang']['yes'];
		} else {
			$string_bool = $GLOBALS['abdj_lang']['no'];
		}

		return $string_bool;
	} // function BooleanToStringYesNo()

	/*
	    This function converts a int variable that is empty or zero to string "0".
	*/
	function ZeroToString($number) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$number=$number) <br>";

		if ((empty ($number)) OR ($number == 0)) {
			$number = "0";
		}

		return $number;

	} // function ZeroToString()

	function CarriageReturnToLinebrake($string) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($action, $string, $replace) <br>";
		$string = preg_replace("/(\r\n|\r|\n)/", "\n", $string);
		return $string;
	} // function CarriageReturnToLinebrake()

	function CarriageReturnToHTML($string) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($action, $string, $replace) <br>";
		$string = preg_replace("/(\r\n|\r|\n)/", "<br>", $string);
		return $string;
	} // function CarriageReturnToHTML()

	function BRtoCarriageReturn($string) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($action, $string, $replace) <br>";
		$string = str_replace("<br>", "\r\n", $string);
		return $string;
	} // function BRtoCarriageReturn()

	function SpacestoHTML($string) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($action, $string, $replace) <br>";
		$string = str_replace("   ", "&nbsp;&nbsp;&nbsp;", $string);
		$string = str_replace("  ", "&nbsp;&nbsp;", $string);
		return $string;
	} // function SpacestoHTML()

	function FilesizeToByte($filesize) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($action, $string, $replace) <br>";
		$filesize = trim($filesize);
		$last = strtolower($filesize {
			strlen($filesize) - 1});
		switch ($last) {
			// The 'G' modifier is available since PHP 5.1.0
			case 'g' :
				$filesize *= 1024;
			case 'm' :
				$filesize *= 1024;
			case 'k' :
				$filesize *= 1024;
		}
		return $filesize;
	} // function FilesizeToByte()

	function File_Exists($file, $type) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$exists['success'] = FALSE;
		$exists['msg'] = "";

		if (!file_exists($file)) {
			$exists['success'] = FALSE;
			if (strtoupper($type) == "FILE") {
				$exists['msg'] = $this->lang['status_file_exists_no'].": ".$file;
			}
			if (strtoupper($type) == "DIRECTORY") {
				$exists['msg'] = $this->lang['status_dir_exists_no'].": ".$file;
			}
		} else {
			$exists['success'] = TRUE;
			if (strtoupper($type) == "FILE") {
				$exists['msg'] = $this->lang['status_file_exists'].": ".$file;
			}
			if (strtoupper($type) == "DIRECTORY") {
				$exists['msg'] = $this->lang['status_dir_exists'].": ".$file;
			}
		}

		return $exists;

	} // function File_Exists()

	function Is_File($file) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$file=$file) <br>";

		$is_file['success'] = FALSE;
		$is_file['msg'] = "";

		$exists['success'] = $this->File_Exists($file, 'FILE');
		if ($exists['success'] == FALSE) {
			$is_file['success'] = FALSE;
			$is_file['msg'] = $this->lang['status_file_exists_no'].": ".$file;

		} else {

			if (!is_file($file)) {
				$is_file['success'] = FALSE;
				$is_file['msg'] = $this->lang['status_file_is_no'].": ".$file;
			} else {
				$is_file['success'] = TRUE;
				$is_file['msg'] = $this->lang['status_file_is'].": ".$file;
			}
		}

		return $is_file;

	} // function Is_File()

	function Is_Dir($dir) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$dir=$dir) <br>";

		$is_dir['success'] = FALSE;
		$is_dir['msg'] = "";

		$exists = $this->File_Exists($dir, 'DIRECTORY');
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." File_Exists: \$exists['success']=".$exists['success']." - \$exists['msg']=".$exists['msg']." <br>";
		if ($exists['success'] == FALSE) {
			$is_dir['success'] = FALSE;
			$is_dir['msg'] = $this->lang['status_dir_exists_no'].": ".$dir;

		} else {

			if (!is_dir($dir)) {
				$is_dir['success'] = FALSE;
				$is_dir['msg'] = $this->lang['status_dir_is_no'].": ".$dir;
			} else {
				$is_dir['success'] = TRUE;
				$is_dir['msg'] = $this->lang['status_dir_is'].": ".$dir;
			}
		}
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." is_dir: \$is_dir['success']=".$is_dir['success']." - \$is_dir['msg']=".$is_dir['msg']." <br>";

		return $is_dir;

	} // function Is_Dir()

	function Is_Readable($file, $type) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$file=$file, \$type=$type) <br>";

		$is_readable['success'] = FALSE;
		$is_readable['msg'] = "";

		$is_readable = $this->File_Exists($file, $type);
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." File_Exists: \$is_readable['success']=".$is_readable['success']." - \$is_readable['msg']=".$is_readable['msg']." <br>";

		if ($is_readable['success'] == TRUE) {
			if (is_readable($file)) {
				$is_readable['success'] = TRUE;
				if (strtoupper($type) == "FILE") {
					$is_readable['msg'] = $this->lang['status_file_readable'].": ".$file;
				}
				if (strtoupper($type) == "DIRECTORY") {
					$is_readable['msg'] = $this->lang['status_dir_readable'].": ".$file;
				}
			} else {
				$is_readable['success'] = FALSE;
				if (strtoupper($type) == "FILE") {
					$is_readable['msg'] = $this->lang['status_file_readable_no'].": ".$file;
				}
				if (strtoupper($type) == "DIRECTORY") {
					$is_readable['msg'] = $this->lang['status_dir_readable_no'].": ".$file;
				}
			}
		}

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." return: \$is_readable['success']=".$is_readable['success']." - \$is_readable['msg']=".$is_readable['msg']." <br>";

		return $is_readable;
	} // function Is_Readable()

	function Is_Writeable($file, $type) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$file=$file, \$type=$type) <br>";

		$is_writeable['success'] = FALSE;
		$is_writeable['msg'] = "";

		$is_writeable = $this->File_Exists($file, $type);
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." File_Exists: \$is_writeable['success']=".$is_writeable['success']." - \$is_writeable['msg']=".$is_writeable['msg']." <br>";

		if ($is_writeable['success'] == TRUE) {
			if (is_writeable($file)) {
				$is_writeable['success'] = TRUE;
				if (strtoupper($type) == "FILE") {
					$is_writeable['msg'] = $this->lang['status_file_writeable'].": ".$file;
				}
				if (strtoupper($type) == "DIRECTORY") {
					$is_writeable['msg'] = $this->lang['status_dir_writeable'].": ".$file;
				}
			} else {
				$is_writeable['success'] = FALSE;
				if (strtoupper($type) == "FILE") {
					$is_writeable['msg'] = $this->lang['status_file_writeable_no'].": ".$file;
				}
				if (strtoupper($type) == "DIRECTORY") {
					$is_writeable['msg'] = $this->lang['status_dir_writeable_no'].": ".$file;
				}
			}
		}

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." return: \$is_writeable['success']=".$is_writeable['success']." - \$is_writeable['msg']=".$is_writeable['msg']." <br>";

		return $is_writeable;
	} // function Is_Writeable()

	function Is_Dir_Writeable($dir, $mode = '') {
			//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$dir=$dir) <br>";

	$is_writeable['success'] = FALSE;
		$is_writeable['msg'] = "";

		$is_writeable = $this->File_Exists($dir, 'DIRECTORY');
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." File_Exists: \$is_writeable['success']=".$is_writeable['success']." - \$is_writeable['msg']=".$is_writeable['msg']." <br>";
		if ($is_writeable['success'] == TRUE) {
			$is_writeable = $this->Is_Dir($dir, 'DIRECTORY');
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Is_Dir: \$is_writeable['success']=".$is_writeable['success']." - \$is_writeable['msg']=".$is_writeable['msg']." <br>";

			if ($is_writeable['success'] == TRUE) {
				$is_writeable = $this->Is_Writeable($dir, 'DIRECTORY');
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Is_Writeable: \$is_writeable['success']=".$is_writeable['success']." - \$is_writeable['msg']=".$is_writeable['msg']." <br>";
			}
		}

		if ($is_writeable['success'] == FALSE) {
			if ($mode == "die") {
				die($is_writeable['msg']);
			}
			if ($mode == "print") {
				echo $is_writeable['msg'];
			}
		} // if ($is_writeable['success'] == FALSE) {

		return $is_writeable;
	} // function Is_Dir_Writeable(

	function Is_File_Writeable($file) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$file=$file) <br>";

		$is_writeable['success'] = FALSE;
		$is_writeable['msg'] = "";

		$is_writeable = $this->File_Exists($file, 'FILE');
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$is_writeable['success']=".$is_writeable['success']." - \$is_writeable['msg']=".$is_writeable['msg']." <br>";

		if ($is_writeable['success'] == TRUE) {
			$is_writeable = $this->Is_File($file, 'FILE');
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$is_writeable['success']=".$is_writeable['success']." - \$is_writeable['msg']=".$is_writeable['msg']." <br>";

			if ($is_writeable['success'] == TRUE) {
				$is_writeable = $this->Is_Writeable($file, 'FILE');
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$is_writeable['success']=".$is_writeable['success']." - \$is_writeable['msg']=".$is_writeable['msg']." <br>";
			}
		}

		return $is_writeable;

	} // function Is_File_Writeable()

	function File_Is_Writeable($check_exists, $file) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$check_exists=$check_exists, \$file=$file) <br>";

		$is_writeable['success'] = FALSE;
		$is_writeable['msg'] = "";

		$pos_last_slash = strrpos($file, "/");
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$pos_last_slash=$pos_last_slash <br>";

		if ($pos_last_slash == FALSE) {
			// no slash found, is a single file without path
			$is_writeable = $this->Is_File_Writeable($file);
		} else {
			//$this_dir = substr($file, 0, $pos_last_slash +1);

			$is_writeable = $this->Is_Dir($file);

			if ($is_writeable['success'] == TRUE) {
				$is_writeable = $this->Is_Dir_Writeable($file);
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Is_Dir_Writeable: \$is_writeable['success']=".$is_writeable['success']." - \$is_writeable['msg']=".$is_writeable['msg']." <br>";
			} else {
				$is_writeable['success'] = TRUE;
			}

			$is_writeable = $this->Is_File($file);
			if ($is_writeable['success'] == TRUE) {
				$is_writeable = $this->Is_File_Writeable($file);
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Is_File_Writeable : \$is_writeable['success']=".$is_writeable['success']." - \$is_writeable['msg']=".$is_writeable['msg']." <br>";
			}
			//else {
			//$is_writeable['success'] = FALSE;
			//}

			/*
			if ( (!file_exists($file)) AND ($check_exists == FALSE)) {
				$is_file_writeable['success'] = TRUE;
				$is_file_writeable['msg'] = $this->lang['status_file_create'].": ".$file;
			}
			*/

		}

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." return: \$is_writeable['success']=".$is_writeable['success']." - \$is_writeable['msg']=".$is_writeable['msg']." <br>";

		return $is_writeable;

	} // function File_Is_Writeable()

	/*
	    This function reads a given file into a STRING or ARRAY.
	    $format = "string" reads file as STRING
	    $format = "array" reads file as ARRAY
	    $file   = "fullpathtofile/filename" filename
	*/
	function Read_File($format, $check_exists, $file) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($format, $check_exists, $file) <br>";

		$format = strtolower($format);
		$file_array = FALSE;

		if (!@ file_exists($file)) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": guestbook data file does not exist! <br>";
			if ($check_exists == TRUE) {
				die("file $file does not exist");
			}
		} else {
			if ($fp = @ fopen($file, "rb")) {
				@ flock($fp, LOCK_SH);
				$file_data = @ fread($fp, filesize($file) + 100);
				@ flock($fp, LOCK_UN);
				@ fclose($fp);

				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$file_data=$file_data <br>";

				if ((strtoupper($format) == "ARRAY") OR (strtoupper($format) == "DATAARRAY")) {
					if (strtoupper($format) == "DATAARRAY") {
						if (ereg($GLOBALS['abdj_config']['data_end'], $file_data)) {
							$file_array = split($GLOBALS['abdj_config']['data_end'], $file_data);
							$count_index = 0;
							foreach ($file_array AS $item) {
								$file_array[$count_index] = str_replace($GLOBALS['abdj_config']['data_end'], '', $item);
								$count_index ++;
							}
						}
					} else {
						$file_array = split("\n", $file_data);
					}
				}
				if (strtoupper($format) == "STRING") {
					$file_array = $file_data;
				}

				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$file_data=$file_data <br>";

			} // if ($fp = @ fopen($file, "rb"))
		}

		return $file_array;

	} // function Read_File()

	/*
	    This function writes data given as STRING or ARRAY into a file.
	    $format = "string" reads file as STRING
	    $format = "array" reads file as ARRAY
	    $check_exists = TRUE/FALSE | if set to TRUE file has to exist, if false file will be created if needed
	  $file   = "fullpathtofile/filename" filename
	    $data   = "DATA" in either STRING or ARRAY format
	*/
	function Write_File($file, $check_exists, $pointer, $format, $data) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($file, $check_exists, $pointer, $format, $data) <br>";

		$format = strtoupper($format);
		$write_data = "";

		$write_file['success'] = FALSE;
		$write_file['msg'] = FALSE;

		if (strtoupper($format) == "STRING") {
			// data is in string format
			$write_data = $data;
		} else {
			// data is in array format

			$row_count = 0;
			$data_count = count($data);

			foreach ($data AS $row) {
				$row_count ++;
				$row = trim($row);
				if (!empty ($row)) {
					//echo "File ".$_SERVER["SCRIPT_FILENAME"]." Class ".__CLASS__." Function ".__FUNCTION__.": \$row=$row <br>";

					// add Carriage Return, except when writing the last line of php files with closing php tag
					if ($row_count == $data_count AND ereg("\?>", $row)) {
						//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": last index \$row_count=".$row_count." (".$data_count."), that contains closing php tag: \$row=".$row." <br>";
						$line_return = "";
						$row = trim($row);
						$row = trim($row);
					} else {
						$line_return = "\n";
					}

					$write_data .= $row;

					if (strtoupper($format) == "ARRAY") {
						$write_data .= $line_return;
					}
					if (strtoupper($format) == "DATAARRAY") {
						$write_data .= $GLOBALS['abdj_config']['data_end'].$line_return;
						//$write_data .= $line_return;
					}
				} // if (!empty ($row))
			} // foreach
		} // if (strtoupper($format) == "STRING")

		$does_exists = $write_file = $this->File_Exists($file, 'FILE');

		if (($check_exists == TRUE) AND ($does_exists['success'] == FALSE)) {
			// Checked for existance of file, but file does not exist!
			//$die_msg = "file ".$file." does not exist";
			//die($die_msg);
		} else {
			$is_writeable = $write_file = $this->File_Is_Writeable($check_exists, $file);
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$is_writeable['success']=".$is_writeable['success']." - \$is_writeable['msg']=".$is_writeable['msg']." <br>";

			if (($is_writeable['success'] == FALSE) AND ($does_exists['success'] == TRUE)) {
				// File exists, but is not writeable.
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": File $file should exist for writing, but does not! <br>";
				//$die_msg = $this->lang['status_file_writeable_no']."<br>".$is_writeable['msg'];
				//die($die_msg);
			} else {
				if (strtoupper($pointer) == "APPEND") {
					$file_pointer = "a+b";
				} else {
					$file_pointer = "w+b";
				}

				if ($fp = @ fopen($file, $file_pointer)) {
					$write_file['success'] = TRUE;
					$write_file['msg'] = $this->lang['status_file_write'].": ".$file;
					@ flock($fp, LOCK_EX);
					@ fwrite($fp, $write_data);
					@ flock($fp, LOCK_UN);
					@ fclose($fp);
				} else {
					$write_file['success'] = FALSE;
					$write_file['msg'] = $this->lang['status_file_write_no'].": ".$file;
				}
			} // else if ($is_writeable['success'] == FALSE)
		} // else if (($check_exists == TRUE) AND (!@ file_exists($file)))

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": return... <br>";
		return $write_file;

	} // function Write_File()

	function Delete_File($file, $type) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$file=$file, \$type=$type) <br>";

		$delete['success'] = FALSE;
		$delete['msg'] = "";

		$delete = $this->File_Exists($file, $type);

		if ($delete['success'] == TRUE) {
			if (strtoupper($type) == "FILE") {
				$unlink_success = @ unlink($file);
			}
			if (strtoupper($type) == "DIRECTORY") {
				$unlink_success = @ rmdir($file);
			}

			if ($unlink_success == FALSE) {
				$delete['success'] = FALSE;
				if (strtoupper($type) == "FILE") {
					$delete['msg'] = $this->lang['action_file_delete_failed'].": ".$file;
				}
				if (strtoupper($type) == "DIRECTORY") {
					$delete['msg'] = $this->lang['action_dir_delete_failed'].": ".$file;
				}
			} else {
				$delete['success'] = TRUE;
				if (strtoupper($type) == "FILE") {
					$delete['msg'] = $this->lang['action_file_deleted'].": ".$file;
				}
				if (strtoupper($type) == "DIRECTORY") {
					$delete['msg'] = $this->lang['action_dir_deleted'].": ".$file;
				}
			}
		}

		return $delete;

	} // function Delete_File()

	function Delete_DirectoryContent($directory) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$directory=$directory, \$type=$type) <br>";

		$delete['success'] = FALSE;
		$delete['msg'] = "";
		$delete['msg_all'] = "";

		$delete = $this->File_Exists($directory, "DIRECTORY");

		if ($delete['success'] == TRUE) {

			$files = $this->CollectDir($directory, '');
			if (!empty ($files['this_files'][0])) {

				foreach ($files['this_files'] AS $file) {
					$file_deleted = $this->Delete_File($file, "FILE");
					if ($file_deleted['success'] == FALSE) {
						$delete['success'] = FALSE;
					}
					$delete['msg_all'] = $file_deleted['msg'];
				} // foreach
			} // if (!empty($files['this_files'][0])
			if ($delete['success'] == FALSE) {
				$delete['msg'] = $this->lang['action_dir_delete_failed'].": ".$directory;
			} else {
				$delete['msg'] = $this->lang['action_dir_deleted'].": ".$directory;
			}
		} // if ($delete['success'] == TRUE)

		return $delete;

	} // function Delete_DirectoryContent()

	/*
	    This function collects all files, directories of a given directory/path
	    $action = "" just returns the ARRAY
	    $action = "show" outputs the dir/file tree directly
	*/
	function CollectDir($dir, $action, $pos = 2) {
			//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($dir, $action, \$pos=2) <br>";

	if (!isset ($durchlauf_count)) {
			$durchlauf_count = 1;
		} else {
			$durchlauf_count ++;
		}

		if ($durchlauf_count == 1) {
			$all_array = ARRAY ();

			$all_files_array = ARRAY ();
			$all_dirs_array = ARRAY ();

			$this_all_array = ARRAY ();
			$this_files_all_array = ARRAY ();
			$this_dirs_array = ARRAY ();

			$this_filesnames_array = ARRAY ();
		}

		if (($action == "show") AND ($pos == 2)) {
			//echo "<hr><pre>";
			echo "<pre>";
		}

		$handle = opendir($dir);

		while ($file = readdir($handle)) {
			if (eregi("^\.{1,2}$", $file)) {
				continue;
			}

			//echo $dir.$file."<br>";

			if (is_dir("$dir$file")) {
				if ($action == "show") {
					printf("% ".$pos."s <b>%s</b>\n", "|-", $file);
				}

				array_push($all_array, "$dir$file");
				array_push($all_dirs_array, "$dir$file");
				array_push($this_all_array, "$dir$file");
				array_push($this_dirs_array, "$dir$file");

				$this->CollectDir("$dir$file", $pos +3);

			} else {
				if ($action == "show") {
					printf("% ".$pos."s %s\n", "|-", $file);
					//echo "$dir$file - $file<br>";
				}

				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$dir\$file=$dir$file <br>";

				array_push($all_array, "$dir$file");
				array_push($all_files_array, "$dir$file");
				array_push($this_all_array, "$dir$file");
				array_push($this_files_all_array, "$dir$file");
				array_push($this_filesnames_array, $file);

			}
		} // while

		@ closedir($handle);

		if (($action == "show") AND ($pos == 2)) {
			echo "</pre><hr>";
		}

		$directory['all'] = $all_array;
		$directory['all_dirs'] = $all_dirs_array;
		$directory['all_files'] = $all_files_array;
		$directory['this_all'] = $this_all_array;
		$directory['this_dirs'] = $this_dirs_array;
		$directory['this_files'] = $this_files_all_array;
		$directory['this_filenames'] = $this_filesnames_array;

		return $directory;

	} // function CollectDir()

	function CollectDirRemoveForbidden($files_array, $unwanted_array) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$files_array, \$unwanted_array) <br>";

		/* START //COMMENT_REFERRER// */
		$forbidden_array = ARRAY (".", "./", "..", "../", ".htaccess", ".htpasswd", "htaccess.txt", "_vti_cnf", "c_productzz.txt", "newsletter.template999.txt", "voting.websitezz.txt");
		/* END //COMMENT_REFERRER// */

		if (is_array($unwanted_array)) {
			foreach ($unwanted_array AS $unwanted) {
				array_push($forbidden_array, $unwanted);
			}
		}

		$removed_array = ARRAY ();

		if (is_array($files_array) AND !empty ($files_array[0])) {
			foreach ($files_array AS $file) {
				if (!eregi("/", $file)) {
					$filename = $file;
				} else {
					$filename_start = strrpos($file, "/");
					$filename = substr($file, $filename_start +1);
				}
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$filename=$filename <br>";

				if (!in_array($filename, $forbidden_array)) {
					array_push($removed_array, $file);
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$filename=$filename allowed <br>";
				} else {
					// forbidden
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$filename=$filename forbidden <br>";
				}

			} // foreach
		} // if (!empty($files_array[0])) {

		return $removed_array;

	} // function CollectDirRemoveForbidden()

	function SetupReplace($mode, $file, $variable_array) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($mode, $file, $variable_array) <br>";

		$mode = strtolower($mode);
		$new_file = ARRAY ();

		$work_file = $GLOBALS['abdj_obj_common']->Read_File("array", TRUE, $file);
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": ReadFile \$file=$file <br>";

		foreach ($work_file AS $line) {

			$variable_found = FALSE;
			$new_line = "";

			//$current_line++;

			if ($mode == "line") {
				foreach ($variable_array AS $variable) {
					$variable_key = str_replace("*", "\*", $variable['key']);
					if (ereg($variable_key, $line)) {
						$variable_found = TRUE;
						$new_line = $variable['key'].$variable['value'];
						break;
					}
				} // foreach variable_array
			} // if ($mode == "line")

			if ($mode == "var") {
				foreach ($variable_array AS $variable) {
					$variable_name = str_replace("[", "\[", $variable['variable']);
					$variable_name = str_replace("]", "\]", $variable_name);
					$variable_key = str_replace("*", "\*", $variable['key']);

					$ereg_string = $variable_key."\\\$".$variable_name;
					//echo $current_line.": ".$ereg_string." - ".$line."";

					if (ereg($ereg_string, $line)) {
						$variable_found = TRUE;
						$new_line = $variable['key']."\$".$variable['variable']." = ";

						$variable['type'] = strtoupper($variable['type']);

						if ($variable['type'] == "INTEGER") {
							$variable['value'] = $GLOBALS['abdj_obj_common']->ZeroToString($variable['value']);
							$new_line .= $variable['value'].";";
						}
						if ($variable['type'] == "BOOLEAN") {
							if (strtolower($variable['value']) == "yes") {
								$new_line .= "TRUE;";
							} else {
								$new_line .= "FALSE;";
							}
						}
						if ($variable['type'] == "STRING") {
							$new_line .= "\"".$variable['value']."\";";
						}

						//$new_line .= "\n";

						break;
					}
				} // foreach variable_array

			} // if ($mode == "var")

			if ($variable_found == TRUE) {
				//echo "<font color=green>variable found.</font><br>";
				$new_file[] = $new_line;
			} else {
				//echo "<font color=maroon>not found.</font><br>";
				$new_file[] = $line;
			}

		} // foreach $work_file

		$write_succes = $GLOBALS['abdj_obj_common']->Write_File($file, TRUE, "begin", "array", $new_file);

		return $write_succes;

	} // function SetupReplace()

	function CollectDirRecursivly($dir, $file_array) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$dir=$dir) <br>";
		$this->file_array = ARRAY ();
		$this->file_array = $file_array;
		if ($handle = opendir($dir)) { // open the directory
			while (false !== ($file = readdir($handle))) {
				if (!empty ($file) && $file != "." && $file != ".." && !is_link($file)) {
					if (is_dir($dir.$file)) {
						$this->CollectDirRecursivly($dir.$file.'/', $this->file_array); // if the file is a directory, do a recursive call
					} else {
						$filename = $dir.$file;
						//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$filename=$filename <br>";
						$this->file_array[] = $filename;
					}
				}
			}
			closedir($handle);

			if (is_array($this->file_array) AND !empty ($this->file_array[0])) {
				asort($this->file_array);
			}
		}

		/*
		foreach($this->file_array AS $file) {
			print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$file=$file <br>";
		}
		print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": <hr>";
		*/

		return $this->file_array;
	} // function CollectDirRecursivly()

	/*
	This function sends email through PHPs mailer	if sending email is turned on (TRUE).
	*/
	function SimpleMail($to, $subject, $message, $header) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($to, $subject, \$message, \$header) <br>";
		if ($GLOBALS['abdj_config']['feature_send_email'] == TRUE) {
			@mail($to, $subject, $message, $header);
		}
	} // function SimpleMail()

	/*
	This function shows email messages for debugging.
	*/
	function SimpleMailDebug($to, $subject, $message, $header) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($to, $subject, \$message, \$header) <br>";
		if ($GLOBALS['abdj_config']['feature_simplemaildebug'] == TRUE) {
			$debug = '<form>';
			$debug .= '<textarea style="width: 600px; height: 150px;" rows="0" cols="0">';
			$debug .= 'header: '.$header."\n\n\n\n";
			$debug .= 'to: '.$to."\n";
			$debug .= 'subject: '.$subject."\n\n\n\n";
			$debug .= $message."\n";
			$debug .= '</textarea>';
			$debug .= '</form>';
			print $debug;
		}
	} // function SimpleMailDebug()

	/*
	This function is for development/debugging.
	It outputs the contents of a given array.
	*/
	function Dev_ShowArray($data=ARRAY(), $mode='RETURN') {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$data, \$mode=$mode) <br>";
		
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": var_dump() <br>";
		//var_dump($data); print '<hr>';
		
		$show='';
		if (is_array($data) AND count($data) > 0) {
		foreach ($data AS $key => $row) {
			
			if (is_array($row) AND count($row) > 0) {
				foreach ($row AS $key => $value) {
					$show .= ' - '.$key.' => '.$value;
				}
			}
			else {
				$show .= $row;
			}
			$show.='<br>';
		}
		} // if (count($data) > 0)
		
		if (strtoupper($mode) == 'SHOW') {
			echo $show;
		}
		else {
			return $show;
		}

	} // function Dev_ShowArray()

} // class Abdj_Common

?>