<?php
class Abdj_Counter {

	function Abdj_Counter() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

	} // function Abdj_Counter()

	function SetLanguage($language_array) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$language_array) <br>";
		$this->lang = $language_array;
	} // function SetLanguage()

	function SetParameter($parameter_array) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$parameter_array) <br>";
		$this->parameter = ARRAY ('path_counter_data' => '', 'path_counter_data_2lang' => '', 'lang_current_editlanguage' => '');

		foreach ($parameter_array AS $key => $value) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": $key => $value <br>";
			$this->parameter["$key"] = $value;
		}

	} // function SetParameter()

	function IsCMSimpleFunction() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		//  Call counter for non h1, h2, h3 pages ///////////////////////////////////////////////////////////////////////////////////

		global $function, $sitemap, $mailform, $guestbook, $print, $login;
		global $tx;

		$is_cmsimplefunction['success'] = FALSE;
		$is_cmsimplefunction['pagename'] = FALSE;

		if (($sitemap) OR ($mailform) OR ($guestbook) OR ($print) OR ($login) OR ($function == 'guestbook') OR ($function == 'mailform') OR ($function == 'search')) {
			$is_cmsimplefunction['success'] = TRUE;

			if ($sitemap) {
				$is_cmsimplefunction['pagename'] = $tx['menu']['sitemap'];
			}
			if ($print) {
				$is_cmsimplefunction['pagename'] = $tx['menu']['print'];
			}
			if ($login) {
				$is_cmsimplefunction['pagename'] = $tx['menu']['login'];
			}
			if ($function == 'search') {
				$is_cmsimplefunction['pagename'] = $tx['title']['search'];
			}
			if (($mailform) OR ($function == 'mailform')) {
				$is_cmsimplefunction['pagename'] = $tx['menu']['mailform'];
			}
			if (($guestbook) OR ($function == 'guestbook')) {
				$is_cmsimplefunction['pagename'] = $tx['menu']['guestbook'];
			}

			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$is_cmsimplefunction['pagename']=".$is_cmsimplefunction['pagename']." <br>";

		}

		return $is_cmsimplefunction;
	} // function IsCMSimpleFunction()

	/*
	    This function is called to count page views for a page
	
	  To count page (e.g. "Testpage") call
	  Count_Page($pagename)
	  
	  where $pagename is
			  <h1>Testpage</h1>
			  <h2>Testpage</h2>
			  <h3>Testpage</h3>
			in CMSimple content.htm
			
			respectively index.php?guestbook = guestbook
			respectively index.php?stitemap  = sitemap
	
	*/
	function Count_Page($pagename) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$pagename=$pagename) <br>";

		//if (empty($pagename)) { $pagename = $GLOBALS['abdj_config_counter']['home_name']; } 
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$GLOBALS['abdj_config_counter']['home_name']=".$GLOBALS['abdj_config_counter']['home_name']." <br>";
		
		$page_count=0;
		
		abdj_ExistsPage($pagename);
		
		$feature_donotcount_admin = FALSE;

		// Execute UniqueCount() if admin is not online
		if ($feature_donotcount_admin == FALSE) {

			$is_cmsimplefunction = $this->IsCMSimpleFunction();

			if ($is_cmsimplefunction['success'] == TRUE) {
				$pagename = $is_cmsimplefunction['pagename'];
			}

			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$pagename=$pagename <br>";
			$filename = $this->Format_Counterfile($pagename);
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$filename=$filename <br>";

			$page_count = $this->Read_Count($filename);

			$page_count++;

			$this->Write_Counter($filename, $page_count);

		} // if ($feature_donotcount_admin == TRUE)
		
		return $page_count;

	} // function Count_Page()

	/*
	    This function returns the page views of the given pagename.
	*/
	function Page_Views($pagename, $mode) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$pagename=$pagename, \$mode=$mode) <br>";

		$is_cmsimplefunction = $this->IsCMSimpleFunction();

		if ($is_cmsimplefunction['success'] == TRUE) {
			$pagename = $is_cmsimplefunction['pagename'];
		}

		$filename = $this->Format_Counterfile($pagename);

		$page_count = $this->Read_Count($filename);

		if ($page_count == 0) {
			$page_count = "0";
		}

		return $page_count;

	} // function Page_Views()

	/*
	      This function prepares the pagetitle to
				- lowercase
				- strips out uri-seperator
				- spaces, special chars
	
				returns an array:
				$var['filename'] = the filename of the counter file according to the pagetitle ("<h1>Testpage</h1>")
				$var['pagename'] = the pagetitle shown in counter table according to the pagetitle ("testpage")
	
	*/
	function Format_Counterfile($pagename) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$pagename=$pagename) <br>";

		global $cf;

		$counter_pagename = $pagename;

		if (isset ($GLOBALS['cfg_is_cmsimple_function'])) {
			$this_cfg_is_cmsimple_function = $GLOBALS['cfg_is_cmsimple_function'];
		} else {
			$this_cfg_is_cmsimple_function = FALSE;
		}
		if (($counter_pagename == "") AND ($this_cfg_is_cmsimple_function == FALSE)) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": pagename=\"\" and function=FALSE <br>";
			$counter_pagename = $GLOBALS['abdj_config_counter']['home_name'];
		}

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$counter_pagename=$counter_pagename <br>";
		$counter_pagename = str_replace($cf['uri']['seperator'], "--", $counter_pagename);
		$counter_pagename = str_replace(" ", "_", $counter_pagename);
		$counter_pagename = str_replace("%", "", $counter_pagename);
		$counter_pagename = urlencode($counter_pagename);
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$counter_pagename=$counter_pagename <br>";
		$counter_pagename = str_replace("%", "", $counter_pagename);
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$counter_pagename=$counter_pagename <br>";
		$counter_pagename = strtolower($counter_pagename);


		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$counter_pagename=$counter_pagename <br>";

		if (!empty ($counter_pagename)) {
			$counter_filename = $GLOBALS['abdj_config_counter']['datafile_prefix'].$counter_pagename.$GLOBALS['abdj_config_counter']['datafile_extension'];
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$counter_filename=$counter_filename <br>";
		}

		return $counter_filename;

	} // function Format_Counterfile()

	/*
	    This function reads counter file "$filename"
	    returns number of page views (INTEGER)
	*/
	function Read_Counter($filename) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$filename=$filename) <br>";

		$counter = ARRAY ('page_uri' => '', 'page_count' => 0);

		$file = $this->parameter['path_counter_data_2lang'].$filename;
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$file=$file <br>";

		$count_data = $GLOBALS['abdj_obj_common']->Read_File("ARRAY", FALSE, $file);
		if (isset ($count_data[0])) {
			$counter['page_uri'] = $count_data[0];
		}
		if (isset ($count_data[1])) {
			$counter['page_count'] = $count_data[1];
		}

		return $counter;

	} // function Counter()

	/*
	    This function reads counter file "$filename"
	    returns number of page views (INTEGER)
	*/
	function Read_Count($filename) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$filename=$filename) <br>";

		$page_count = 0;

		$file = $this->parameter['path_counter_data_2lang'].$filename;

		$count_data = $GLOBALS['abdj_obj_common']->Read_File("ARRAY", FALSE, $file);
		$page_count = $count_data[1];

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$page_count=$page_count <br>";

		return $page_count;

	} // function Read_Count()

	/*
	    This function reads file "$filename"
	    returns file contents
	*/
	function Read_File($filename, $format) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$filename=$filename) <br>";

		$file_data = $GLOBALS['abdj_obj_common']->Read_File($format, FALSE, $filename);

		return $file_data;

	} // function Read_File()

	/*
	    this function writes page views to counter file, where
	    - $filename is the filename of the counter file
	    - $count is the number (INTEGER) of page views
	*/
	function Write_File($filename, $check, $pointer, $format, $data) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$filename=$filename, \$count=$count) <br>";

		$filename = strtolower($filename);

		$GLOBALS['abdj_obj_common']->Write_File($filename, $check, $pointer, $format, $data);
	} // function Write_File()

	/*
	    this function writes page views to counter file, where
	    - $filename is the filename of the counter file
	    - $count is the number (INTEGER) of page views
	*/
	function Write_Counter($filename, $count) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$filename=$filename, \$count=$count) <br>";

		global $su;
		$write_data = ARRAY ();
        //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$su=$su <br>";
		if (empty ($su)) {
			$write_data[0] = $GLOBALS['abdj_config_counter']['home_name'];
		} else {
			$write_data[0] = $su;
		}
		$write_data[1] = $count;

		$filename = strtolower($filename);

		$file = $this->parameter['path_counter_data_2lang'].$filename;

		$GLOBALS['abdj_obj_common']->Write_File($file, FALSE, "begin", "ARRAY", $write_data);
	} // function Write_Counter()

	/*
	    This function collects all counter files inside the counter directory
	    and then creates a table of all counts.
	    - $depth_array contains numbers 1, 2 or 3 for menulevel 1, 2 or 3
	    - $file_array contains the filenames of all counter files
	    
	    returns the table of page views in plain html as "<table>...</table>"
	*/
	function Summary($format = '') {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$format=$format) <br>";

		global $cf;
		$summary_table = '';
		$summary_rows['total_page_views'] = 0;

		$page_array = ARRAY ();
		$array_page_uris = ARRAY ();
		$array_page_headings = ARRAY ();

		$array_non_existent_pages = ARRAY ();

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->parameter['lang_current_editlanguage']=".$this->parameter['lang_current_editlanguage']." <br>";


		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": call abdj_CMSimple_rfc('uri', ".$this->parameter['lang_current_editlanguage'].", ".$GLOBALS['abdj_admin_call']."); <br>";
		$array_page_uris = abdj_CMSimple_rfc('uri', $this->parameter['lang_current_editlanguage'], $GLOBALS['abdj_admin_call']);
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": call abdj_CMSimple_rfc('heading', ".$this->parameter['lang_current_editlanguage'].", ".$GLOBALS['abdj_admin_call']."); <br>";
		$array_page_headings = abdj_CMSimple_rfc('heading', $this->parameter['lang_current_editlanguage'], $GLOBALS['abdj_admin_call']);

		foreach ($array_page_uris AS $uri) {
			$array_filenames[] = $this->Format_Counterfile($uri);
		}

		$array_index = 0;
		$filenames_menu = ARRAY ();
		
		foreach ($array_page_uris AS $uri) {
			$page_array["$array_index"] = ARRAY ("filename" => $array_filenames["$array_index"], "page_name" => $array_page_headings["$array_index"], "page_uri" => $array_page_uris["$array_index"]);
			array_push($filenames_menu, $array_filenames["$array_index"]);
			$array_index ++;
		}
		

		/* Counter.ForbiddenFiles - START //COMMENT_VERSION_BASIC// */
		if ($GLOBALS['abdj_config']['version'] == 'basic') {
		$forbidden_array = ARRAY (".htaccess", ".htpasswd");
		}
		/* END //COMMENT_VERSION_BASIC// Counter.ForbiddenFiles */



		
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": show forbidden files <br>";
		//$GLOBALS['abdj_obj_common']->Dev_ShowArray($forbidden_array, 'SHOW');

		$file_array = $GLOBALS['abdj_obj_common']->CollectDir($this->parameter['path_counter_data_2lang'], "", $pos = 2);
		$file_array = $GLOBALS['abdj_obj_common']->CollectDirRemoveForbidden($file_array['this_filenames'], $forbidden_array);
		//$file_array = $file_array['this_files'];

		sort($file_array);
		
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": show files <br>";
		//$GLOBALS['abdj_obj_common']->Dev_ShowArray($file_array, 'SHOW');


		$summary_table .= "\n".'<table width="90%" bgcolor="white" cellspacing="2" cellpadding="2" border="0">'."\n";
		$summary_table .= '<tr class="abdjcaption"><td class="abdjcaption" width="65%" valign="top">'.$GLOBALS['abdj_lang_counter']['summary_page_title'].'</td><td class="abdjcaption" width="15%" align="right" valign="top">'.$GLOBALS['abdj_lang_counter']['summary_pv'].' (%)</td><td class="abdjcaption" width="15%" align="right" valign="top">'.$GLOBALS['abdj_lang_counter']['summary_pv'].' (#)</td><td class="abdjcaption" width="5%" valign="top">(c)</td></tr>'."\n";

		$summary_rows_array = ARRAY ();
		$pageviews_array = ARRAY ();
		$row_count = 0;

		foreach ($page_array AS $page) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": foreach \$page['filename']=".$page['filename']." - \$page['page_name'] = ".$page['page_name']." <br>";

			$exists_page = FALSE;
			$page_uri = "";
			$page_name = $page['page_name'];
			$page_filename = $page['filename'];

			$counter_data = $this->Read_Counter($page_filename);

			$page_uri = $counter_data['page_uri'];
			$page_count = $counter_data['page_count'];

			if (empty ($page_name)) {
				$page_name = $page_uri;
			}
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$page_name=".$page_name." <br>";

			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$page_filename=$page_filename - \$page_name=$page_name - \$page_uri=$page_uri - \$page_count=$page_count <br>";
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$page_filename=$page_filename - \$page_uri=$page_uri <br>";

			// Check wether stored URIs in Counter-Data file exists in content ($c)
			if (!empty ($page_uri)) {
				$exists_page = abdj_ExistsPage($page_uri);
			} else {
				$exists_page = TRUE;
			}

			$row_count ++;
			$index_array = $row_count -1;

			$summary_rows['total_page_views'] += $page_count;

			$page_title_work = str_replace($GLOBALS['abdj_config_counter']['datafile_extension'], "", $page_name);

			// counter-file-prefix rausnehmen
			if (substr($page_title_work, 0, strlen($GLOBALS['abdj_config_counter']['datafile_prefix'])) == $GLOBALS['abdj_config_counter']['datafile_prefix']) {
				$page_title_work = substr($page_title_work, strlen($GLOBALS['abdj_config_counter']['datafile_prefix']), strlen($page_title_work));
			}
			// zz_ fr CMSimple-Links rausnehmen
			if (substr($page_title_work, 0, strlen($GLOBALS['abdj_config_counter']['datafile_prefix_cmsimplefunctions'])) == $GLOBALS['abdj_config_counter']['datafile_prefix_cmsimplefunctions']) {
				$page_title_work = strtoupper(substr($page_title_work, strlen($GLOBALS['abdj_config_counter']['datafile_prefix_cmsimplefunctions']), strlen($page_title_work)));
			}

			if ($GLOBALS['abdj_config_counter']['summary_current_uri'] == TRUE) {
				$page_title_work_array = explode($cf['uri']['seperator'], $page_title_work);
				if (!empty ($page_title_work_array[2])) {
					$page_title_work = $page_title_work_array[2];
				}
				elseif (!empty ($page_title_work_array[1])) {
					$page_title_work = $page_title_work_array[1];
				}
				elseif (!empty ($page_title_work_array[0])) {
					$page_title_work = $page_title_work_array[0];
				}
			}

			$para_2lang = $GLOBALS['abdj_url_amp']."abdj_get_editlanguage=".$this->parameter['lang_current_editlanguage'];

			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": foreach \$filename=$filename - \$page_name=$page_name - \$page_count=$page_count <br>";
			if (empty ($format)) {
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$format is empty. <br>";
				$page_title_padding = "<font style=\"margin-left:";
				$page_title_padding .= substr_count($page_name, $cf['uri']['seperator']) * $GLOBALS['abdj_config_counter']['summary_margin'];
				$page_title_padding .= "px;\">";

				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$exists_page=".$exists_page." - \$GLOBALS['abdj_config_counter']['feature_marknonexistentpages']=".$GLOBALS['abdj_config_counter']['feature_marknonexistentpages']." <br>";
				if (($exists_page == TRUE) OR ($GLOBALS['abdj_config_counter']['feature_marknonexistentpages'] == FALSE)) {
					$page_title_padding .= $page_title_work;
				}

				$page_title_padding .= "</font>";

				$page_title = $page_title_padding;
			} // if (empty ($format))
			else {
				// "plain"
				// no margin for table display
				if (($exists_page == TRUE) OR ($GLOBALS['abdj_config_counter']['feature_marknonexistentpages'] == FALSE)) {
					$page_title = $page_title_work;
				}

			} // else if (empty ($format))

			$summary_rows_array[$row_count] = ARRAY ("pagename" => $page_name, "pagetitle" => $page_title, "pagecount" => $page_count);


			// store page counts to get hightest count
			// do not store page count of "home" page
			if ($page_title != $GLOBALS['abdj_config_counter']['home_name']) {
				$pageviews_array[] = $page_count;
			}

		} // foreach ($page_array as $filename)

		//array_multisort($summary_rows_array, SORT_ASC);
		



		// get highest page count
		rsort($pageviews_array);
		$pagecount_hightest = $pageviews_array[0];
		if ($pagecount_hightest == 0) {
			$pagecount_hightest = 1;
		}
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$pagecount_hightest=".$pagecount_hightest." <br>";




		$tr_style = '';
		foreach ($summary_rows_array AS $row) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$row['pagename']=".$row['pagename']." - \$row['pagetitle']=".$row['pagetitle']." - \$row['pagecount']=".$row['pagecount']." <br>";


			if (!empty ($row['pagetitle'])) {
				if ($tr_style == "class=\"abdjddark\"") {
					$tr_style = "class=\"abdjdlight\"";
				} else {
					$tr_style = "class=\"abdjddark\"";
				}

				if (($row['pagecount'] == 0) OR (empty ($row['pagecount']))) {
					$row['pagepercent'] = "0.00";
				} else {
					$row['pagepercent'] = $row['pagecount'] / ($summary_rows['total_page_views'] / 100);
					$row['pagepercent'] = round($row['pagepercent'], 2);

					if (!eregi(".", $row['pagepercent'])) {
						$row['pagepercent'] = $row['pagepercent'].".00";
					}
					if (eregi("\.[0-9]{1}$", $row['pagepercent'])) {
						$row['pagepercent'] = $row['pagepercent']."0";
					}

				}
				$bgcolor_wichte = 0;
				$hightest_1percent = $pagecount_hightest / 255;

				$bgcolor_adjust = 12;

				$bgcolor_wichte = $row['pagecount'] / $hightest_1percent;
				$bgcolor_wichte = round($bgcolor_wichte, 0);
				$bgcolor_wichte = 255 - ($bgcolor_wichte + $bgcolor_adjust);

				if ($bgcolor_wichte < 0) {
					$bgcolor_wichte = 0;
				}

				$hex_count = dechex($bgcolor_wichte);
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$hex_count=$hex_count <br>";

				if (strlen($hex_count) < 2) { $hex_count = "0${hex_count}"; }
				//$bgcolor_marker = "bgcolor=#${hex_count}ffff";
				$bgcolor_marker = 'bgcolor="#'.$hex_count.$hex_count.$hex_count.'"';

				/*if ($row['pagecount'] == $pagecount_hightest)
				{
					  $bgcolor_marker = "bgcolor=black";
				}
				*/

				$summary_table .= "<tr ".$tr_style."><td ".$tr_style.">".$row['pagetitle']."</td><td ".$tr_style." align=right>".$row['pagepercent']."%</td><td ".$tr_style." align=right>".$row['pagecount']."</td><td ".$tr_style." ".$bgcolor_marker.">&nbsp;</td></tr>\n";
			}
		} // foreach ($summary_rows_array AS $row)

		$summary_table .= '<tr class="abdjdark"><td class="abdjdark">'.$GLOBALS['abdj_lang_counter']['total_pv'].'</td><td class="abdjdark" colspan="2" align="right">'.$summary_rows['total_page_views'].'</td><td class="abdjdark"><p class="abdjvcba23counter" style="display:inline;">&nbsp;</p></td></tr>'."\n";

		/* Script.Copyright - START //COMMENT_VERSION_BASIC// */

/* WARNING: Addonsbydjot - License
 * 
 * It is not allowed to remove the links from my Addonsbydjot-Script
 * unless you have a license for Addonsbydjot advanced.
 * (Owners of advanced license see Admin-Panel -> Addonsbydjot -> Settings for removing the link)!
 * 
 * It is hard work to program such a script. The script is free,
 * so it's not a tall order to leave the links intact.
 * 
 * If you illegaly remove the link,
 * I post your name, email and website on my website,
 * the CMSimple-Forum and other websites that are related to license violators.
 * Also I may contact your internet provider
 * and ask him to close your website using my script illegally.
 * 
 * I hope that has not to happen!
 *
 * WARNING: Addonsbydjot - License */
 		if (($GLOBALS['abdj_config']['version'] == 'basic') OR ($GLOBALS['abdj_config']['feature_script_ad'] == TRUE)) {
			if ($GLOBALS['abdj_admin_call'] == FALSE) {
				$summary_table .= "<tr class=\"abdjdark\"><td class=\"abdjdark\">";
				$summary_table .= $GLOBALS['abdj_url_copyright_light'];
				$summary_table .= "&nbsp;</td><td class=\"abdjdark\" colspan=2 align=right>&nbsp;</td><td class=\"abdjdark\">&nbsp;</td></tr>\n";
			}
		}
		/* END //COMMENT_VERSION_BASIC// Script.Copyright */

		$summary_table .= "</table>\n";

		return $summary_table;

	} // function )

} // class Abdj_Counter()
?>