<?php
class Abdj_Guestbook {

	function Abdj_Guestbook() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";
	} // Abdj_Guestbook()

	function Guestbook($mode) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$mode=$mode) <br>";

		$form_action = '';
		$form_error = FALSE;
		$error_msg = '';
		$gb_sent = FALSE;
		$abdj_guestbook_form = '';
		$abdj_guestbook_items='';
		$abdj_guestbook_sent='';


		if (isset ($_POST['abdj_gb']['name'])) {
			$guestbook['name'] = trim($_POST['abdj_gb']['name']);
		} else {
			$guestbook['name'] = '';
		}
		if (isset ($_POST['abdj_gb']['email'])) {
			$guestbook['email'] = trim($_POST['abdj_gb']['email']);
		} else {
			$guestbook['email'] = '';
		}
		if (isset ($_POST['abdj_gb']['showemail'])) {
			$guestbook['showemail'] = trim($_POST['abdj_gb']['showemail']);
		} else {
			$guestbook['showemail'] = '';
		}
		
		if (empty($guestbook['email'])) { $guestbook['showemail']=''; }
		
		
		if ($GLOBALS['abdj_config_guestbook']['feature_captcha'] == TRUE) {			
			if (isset ($_POST['abdj_gb']['captcha'])) {
				$guestbook['captcha'] = trim($_POST['abdj_gb']['captcha']);
			} else {
				$guestbook['captcha'] = '';
			}
		}
		
		if (isset ($_POST['abdj_gb']['message'])) {
			$guestbook['message'] = trim($_POST['abdj_gb']['message']);
		} else {
			$guestbook['message'] = '';
		}
		if (isset ($_POST['abdj_gb']['submit'])) {
			$guestbook['submit'] = trim($_POST['abdj_gb']['submit']);
		} else {
			$guestbook['submit'] = '';
		}

		$guestbook['name'] = htmlentities($guestbook['name'], ENT_QUOTES);
		$guestbook['email'] = htmlentities($guestbook['email'], ENT_QUOTES);
		$guestbook['showemail'] = htmlentities($guestbook['showemail'], ENT_QUOTES);
		if ($GLOBALS['abdj_config_guestbook']['feature_captcha'] == TRUE) {			
		$guestbook['captcha'] = htmlentities($guestbook['captcha'], ENT_QUOTES);
		}
		$guestbook['message'] = htmlentities($guestbook['message'], ENT_QUOTES);
		$guestbook['submit'] = htmlentities($guestbook['submit'], ENT_QUOTES);

		if (empty ($guestbook['submit'])) {
			if ($GLOBALS['abdj_config_guestbook']['feature_show_form'] == TRUE) {
				if ($GLOBALS['abdj_config_guestbook']['feature_first_show_form'] == TRUE  OR isset($_GET['abdj_get_guestbook_show_form'])) {
					$form_action = 'show';
				}
			}
		}
		else {
			$form_action = '';

			if (($GLOBALS['abdj_config_guestbook']['field_show_name'] == TRUE) AND ($GLOBALS['abdj_config_guestbook']['field_mandatory_name'] == TRUE) AND (empty ($guestbook['name']))) {
				$form_error = TRUE;
				$error_msg .= '<dt class="abdjgbdterrormsg">'.$GLOBALS['abdj_lang']['g_field_name'].':</dt><dd class="abdjgbdderrormsg">'.$GLOBALS['abdj_lang']['g_error_empty_name'].'</dd>';
			}


			if ($GLOBALS['abdj_config_guestbook']['feature_captcha'] == TRUE) {
				if (!isset($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_code'])) { $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_code'] = FALSE; }
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": ".$guestbook['captcha']." <br>";
				if (empty($guestbook['captcha']) OR $guestbook['captcha'] != $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_code']) {			
					$form_error = TRUE;
					$error_msg .= '<dt class="abdjgbdterrormsg">'.$GLOBALS['abdj_lang']['g_field_captcha'].':</dt><dd class="abdjgbdderrormsg">'.$GLOBALS['abdj_lang']['g_error_captcha'].'</dd>';
				}
			}


			if ($GLOBALS['abdj_config_guestbook']['field_mandatory_message'] == TRUE) {
				if (($GLOBALS['abdj_config_guestbook']['field_mandatory_message'] == TRUE) AND (empty ($guestbook['message']))) {
					$form_error = TRUE;
					$error_msg .= '<dt class="abdjgbdterrormsg">'.$GLOBALS['abdj_lang']['g_field_message'].':</dt><dd class="abdjgbdderrormsg">'.$GLOBALS['abdj_lang']['g_error_empty_message'].'</dd>';
				} else {
					if (strlen($guestbook['message']) > $GLOBALS['abdj_config_guestbook']['maxlength']) {
						$form_error = TRUE;
						$error_msg .= '<dt class="abdjgbdterrormsg" type="circle">'.$GLOBALS['abdj_lang']['g_field_message'].':</dt><dd class="abdjgbdderrormsg">'.$GLOBALS['abdj_lang_guestbook']['error_maxlength'].'<dd>';
					}
				}
			}

			if ($form_error == FALSE) {
				$guestbook['ip'] = getenv("REMOTE_ADDR");
				$guestbook['date'] = $GLOBALS['abdj_config']['date'];
				$guestbook['time'] = $GLOBALS['abdj_config']['time'];
				$guestbook['datetime'] = $GLOBALS['abdj_config']['datetime'];
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$guestbook['datetime']=".$guestbook['datetime']." <br>";

				// write new guestbook entry to file
				// to not write file for testing purposes, set config to FALSE
				if ($GLOBALS['abdj_config_guestbook']['feature_save_entries'] == FALSE) {
					$gb_sent = TRUE;
				}
				else {

					$add_entry = $this->AddGuestbookEntry($guestbook);

					if ($add_entry['success'] == TRUE) {
						$gb_sent = TRUE;
					}
				} // if ($GLOBALS['abdj_config_guestbook']['feature_save_entries'] == TRUE) {
			}
		} // if(!empty($guestbook['submit']))

		if ($gb_sent == TRUE) {
			$guestbook_html = $guestbook;
			$guestbook_html['message'] = '<div class="abdjgbsentmsg">'.$GLOBALS['abdj_obj_common']->CarriageReturnToHTML($guestbook_html['message']).'</div>';

			if ($GLOBALS['abdj_config_guestbook']['feature_verify_entries'] == TRUE) {
				$guestbook_html['sent_verify'] = $GLOBALS['abdj_lang_guestbook']['sent_verify'];
			}
			else {
				$guestbook_html['sent_verify']='';
			}

			$abdj_guestbook_sent .= '<div class="abdjgbsenthint">'.$this->ReplacePlaceholders($GLOBALS['abdj_lang_guestbook']['sent_text'], $guestbook_html).'</div>';

			if ($GLOBALS['abdj_config_guestbook']['feature_backlink'] == TRUE) {
				$abdj_guestbook_sent .= '<p>'.$GLOBALS['abdj_lang_guestbook']['backlink'].'</p>';
			}
			if ($GLOBALS['abdj_config_guestbook']['feature_backlink_show_entries'] == TRUE) {
				$abdj_guestbook_sent .= '<p>'.$GLOBALS['abdj_lang_guestbook']['backlink_show_entries'].'</p>';
			}

		} // if ($gb_sent == TRUE)

		if ($form_error == TRUE OR $form_action == "show") {
			$mandatory_keys = ARRAY ("name", "email", "message");
			if ($GLOBALS['abdj_config_guestbook']['feature_captcha'] == TRUE) {
				array_push($mandatory_keys, 'captcha');
				$GLOBALS['abdj_config_guestbook']['field_mandatory_captcha'] = TRUE;
			}			
			
			foreach ($mandatory_keys AS $key) {
				if ($GLOBALS['abdj_config_guestbook']['field_mandatory_'.$key] == TRUE) {
					$GLOBALS['abdj_lang']['g_field_'.$key] = $GLOBALS['abdj_lang']['g_field_'.$key].'<div class="abdjgbmandatorysign">'.$GLOBALS['abdj_lang']['g_fieldtext_mandatory_sign'].'</div>';
				}
			} // foreach

			if (!empty ($GLOBALS['abdj_lang_guestbook']['text_gb_desc'])) {
				$abdj_guestbook_form .= '<div class="abdjgbhint">'.$GLOBALS['abdj_lang_guestbook']['text_gb_desc'].'</div>';
			}
			$abdj_guestbook_form .= '<div class="abdjgbdiv">';
			$abdj_guestbook_form .= '<form class="abdjgbform" action="" method="post">';
			
			$abdj_guestbook_form .= '<input type="hidden" name="function" value="';
			if ($mode=='cms') { $abdj_guestbook_form .= 'guestbook'; }
			else { $abdj_guestbook_form .= 'addonsybdjot';	}
			$abdj_guestbook_form .= '">';


			$abdj_guestbook_form .= '<table class="abdjgbtable" cellspacing="0" cellpadding="0" border="0">';

			if ($form_error == TRUE) {
				$abdj_guestbook_form .= '<tr><td class="abdjgbtderrormsg" colspan="2"><dl compact><dt class="abdjgbdterrormsg">'.$GLOBALS['abdj_lang']['g_error_hint'].'</dt><dd class="abdjgbdderrormsg">&nbsp;</dd>'.$error_msg.'</dl></td></tr>';
			}

			if ($GLOBALS['abdj_config_guestbook']['field_show_mandatory'] == TRUE) {
				$abdj_guestbook_form .= '<tr><td class="abdjgbtdmandatory" colspan="2"><div class="abdjgbmandatory">'.$GLOBALS['abdj_lang']['g_fieldtext_mandatory'].'</div><div class="abdjgbmandatorysign">'.$GLOBALS['abdj_lang']['g_fieldtext_mandatory_sign'].'</div></td></tr>';
			}

			if ($GLOBALS['abdj_config_guestbook']['field_show_name'] == TRUE) {
				$abdj_guestbook_form .= '<tr><td class="abdjgbtdfieldname"><div class="abdjgbfieldname">'.$GLOBALS['abdj_lang']['g_field_name'].'</div></td><td class="abdjgbtdinputname"><input class="abdjgbinputname" type="text" name="abdj_gb[name]" value="'.$guestbook['name'].'" alt="name" maxlength="80"></td></tr>';
			}

			if ($GLOBALS['abdj_config_guestbook']['feature_captcha'] == TRUE) {			

				if (!isset($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_code'])) { $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_code'] = FALSE; }
				
				if (empty($guestbook['captcha']) OR (!empty($guestbook['captcha']) AND $guestbook['captcha'] != $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_code'])) {
				
					require_once($GLOBALS['abdj_file_common_captcha']);				
					$lucky_bgcolor='';
					$lucky_fontcolor='';
					$obj_captcha = new MyCaptcha();
					$obj_captcha->SetImageSize($GLOBALS['abdj_config_guestbook']['captcha_width'], $GLOBALS['abdj_config_guestbook']['captcha_height']);
					$obj_captcha->CreateImage();
					$captcha_code = $obj_captcha->GetRandomCode($GLOBALS['abdj_config_guestbook']['captcha_chars'], $GLOBALS['abdj_config_guestbook']['captcha_amount']);
					
					if (strtoupper($GLOBALS['abdj_config_guestbook']['captcha_background_mode']) == 'SINGLE') {
						$lucky_bgcolor = $GLOBALS['abdj_config_guestbook']['captcha_background_color'];
						$lucky_fontcolor = $GLOBALS['abdj_config_guestbook']['captcha_font_color'];
					}
					else {
						$obj_captcha->SetRandomColors($GLOBALS['abdj_config_guestbook']['captcha_background_colors']);
						$lucky_bgcolor = $obj_captcha->GetRandomColor();
						$lucky_fontcolor = $obj_captcha->GetRandomColor($lucky_bgcolor);
					}

					if (strtoupper($GLOBALS['abdj_config_guestbook']['captcha_background_mode']) == 'SINGLE' OR strtoupper($GLOBALS['abdj_config_guestbook']['captcha_background_mode']) == 'RANDOMSINGLE') {
						$obj_captcha->FillBackground(0, 0, $lucky_bgcolor);
						$obj_captcha->AddText($GLOBALS['abdj_config_guestbook']['captcha_fontsize'], $GLOBALS['abdj_config_guestbook']['captcha_font_angle'], $GLOBALS['abdj_config_guestbook']['captcha_font_position_x'], $GLOBALS['abdj_config_guestbook']['captcha_font_position_y'], $lucky_fontcolor, $GLOBALS['abdj_path_common_data'].$GLOBALS['abdj_config_guestbook']['captcha_fontfamily'], $captcha_code);
					}
					if (strtoupper($GLOBALS['abdj_config_guestbook']['captcha_background_mode']) == 'RANDOM') {
						$obj_captcha->FillRandomBackground(10, 0);
						$obj_captcha->AddRandompositionText($GLOBALS['abdj_config_guestbook']['captcha_fontsize'], $GLOBALS['abdj_config_guestbook']['captcha_font_angle'], $lucky_fontcolor, $GLOBALS['abdj_path_common_data'].$GLOBALS['abdj_config_guestbook']['captcha_fontfamily'], $captcha_code);	
					}
					//$obj_captcha->AddText($fontsize, $angle, $x, $y, $color, $fontpath, $text);
					//$obj_captcha->AddText(20, 0, 20, 40, $lucky_bgcolor, 'weird.ttf', 'ABCDEFGH 1234567890');
					//$obj_captcha->AddText(20, 0, 20, 40, $lucky_bgcolor, 'weltron_2001.ttf', 'ABCDEFGH 1234567890');
					//$obj_captcha->AddText($GLOBALS['abdj_config_guestbook']['captcha_fontsize'], 0, 10, 10, '111111', $GLOBALS['abdj_path_common_data'].$GLOBALS['abdj_config_guestbook']['captcha_fontfamily'], $captcha_code);
					$obj_captcha->ShowCaptcha();
				}
				else { $captcha_code = $guestbook['captcha']; }
				
				$abdj_guestbook_form .= '<tr><td class="abdjgbtdfieldcode"><div class="abdjgbfieldcode">'.$GLOBALS['abdj_lang']['g_field_captcha'].'</div></td><td class="abdjgbtdinputcode"><div class="abdjgbdivinputcode"><input class="abdjgbinputcode" type="text" name="abdj_gb[captcha]" value="'.$guestbook['captcha'].'" alt="captcha_code" maxlength="80"></div>';
				$abdj_guestbook_form .= '<div class="abdjgbdivcodeimg"><img class="abdjgbcodeimg" src="'.$GLOBALS['abdj_url_captcha_show'].'" alt="captcha_code"></div>';
				$abdj_guestbook_form .= '<div class="abdjgbdivcodehint">'.$GLOBALS['abdj_lang']['g_field_captcha_hint'].'</div>';
				$abdj_guestbook_form .= '</td></tr>';
			} // if ($GLOBALS['abdj_config_guestbook']['feature_captcha'] == TRUE)

			if ($GLOBALS['abdj_config_guestbook']['field_show_message'] == TRUE) {
				$abdj_guestbook_form .= '<tr><td class="abdjgbtdfieldmsg" colspan="2"><div class="abdjgbfieldmsg">'.$GLOBALS['abdj_lang']['g_field_message'].'</div></td></tr>';
				$abdj_guestbook_form .= '<tr><td class="abdjgbtdinputmsg" colspan="2"><textarea class="abdjgbinputmsg" name="abdj_gb[message]" rows="0" cols="0">'.$guestbook['message'].'</textarea><p class="abdjvcba23guestbook" style="display:inline;"></p></td></tr>';
			}

			$div_copyright='';
			/* Script.Copyright - START //COMMENT_VERSION_BASIC// */
			if (($GLOBALS['abdj_config']['version'] == 'basic') OR ($GLOBALS['abdj_config']['feature_script_ad'] == TRUE)) {
				$div_copyright = '<div class="abdjgbdivcopyright">'.$GLOBALS['abdj_url_copyright_dark'].'</div>';
			}
			/* END //COMMENT_VERSION_BASIC// Script.Copyright */
			$abdj_guestbook_form .= '<tr><td class="abdjgbtdsubmit" colspan="2">'.$div_copyright.'<div class="abdjgbdivreset"><input class="abdjgbreset" type="reset" value="'.$GLOBALS['abdj_lang']['g_action_reset'].'"></div><div class="abdjgbdivsubmit"><input class="abdjgbsubmit" type="submit" name="abdj_gb[submit]" value="'.$GLOBALS['abdj_lang']['g_action_send'].'"></div></td></tr>';


			$abdj_guestbook_form .= '</table>';
			$abdj_guestbook_form .= '</form>';
			$abdj_guestbook_form .= '</div>';
		} // else if ($gb_sent == TRUE)

		if (empty ($guestbook['submit']) AND !isset($_GET['abdj_get_guestbook_show_form']) AND $mode != 'user_guestbookform') {
			if ($GLOBALS['abdj_config_guestbook']['feature_first_show_entries'] == TRUE AND $GLOBALS['abdj_config_guestbook']['feature_show_entries'] == TRUE) {
				$abdj_guestbook_items .= $this->ShowGuestbook('first_show_entries');
			}
		}
		if (!empty($guestbook['submit']) AND $form_error == FALSE) {
			$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_code'] = NULL;
			$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_image'] = NULL;

			if ($GLOBALS['abdj_config_guestbook']['feature_sent_show_entries'] == TRUE AND $GLOBALS['abdj_config_guestbook']['feature_show_entries'] == TRUE) {
				$abdj_guestbook_items .= $this->ShowGuestbook();
			}
		}
		
		if (!empty($abdj_guestbook_items)) {
			$abdj_guestbook_items = '<div class="abdjgbdivitems">'.$abdj_guestbook_items.'</div>';
		}

		return $abdj_guestbook_sent.$abdj_guestbook_form.$abdj_guestbook_items;

	} // function Guestbook()




	function ShowGuestbook($mode='') {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$mode=$mode) <br>";

		$guestbook = "";

		$gb_array = $this->ReadGuestbook("PAGEDARRAY");

		if ($mode == 'public_show_entries' OR $mode == 'first_show_entries') {
			$guestbook .= '<div class="abdjgbadditem">'.$GLOBALS['abdj_lang_guestbook']['backlink_add_entry'].'</div>';

			if ($gb_array == FALSE) {
				$guestbook .= $GLOBALS['abdj_lang_guestbook']['no_guestbook_items'];
			}
		}

		if ($gb_array != FALSE) {
			if (@ file_exists($GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook_template'])) {
				$gb_template_data = $GLOBALS['abdj_obj_common']->Read_File("STRING", TRUE, $GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook_template']);
			} else {
				$gb_template_data = $GLOBALS['abdj_obj_common']->Read_File("STRING", TRUE, $GLOBALS['abdj_path_guestbook_data'].$GLOBALS['abdj_config_guestbook']['filename_guestbook_template_default']);
			}
			$gb_template_array = split($GLOBALS['abdj_config']['data_spacer'], $gb_template_data);
			$gb_template = trim($gb_template_array[0]);
	
			if ($GLOBALS['abdj_config_guestbook']['feature_show_pages'] == TRUE) {
				//global $su;
				$gb_pager = $this->GetGuestbookPager("active", 'index.php?&guestbook', $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'], $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage'], $GLOBALS['abdj_config_guestbook']['feature_show_pages_type'], '');
			} // if ($GLOBALS['abdj_config_guestbook']['feature_show_pages'] == TRUE)

			if ($GLOBALS['abdj_config_guestbook']['feature_show_pages'] == TRUE) {
				
				if ($GLOBALS['abdj_config_guestbook']['feature_show_entries_descending'] == TRUE) {
					//$gb_count = $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage'] * $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'] - $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'];
					$count_gb_items = $this->CountGuestbookEntries('ALL');
					$gb_count = $count_gb_items - ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage'] - 1) * $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'];
					$gb_count++;
				}
				else {
					$gb_count = $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage'] * $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'] - $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'];
				}
			} // if ($GLOBALS['abdj_config_guestbook']['feature_show_pages'] == TRUE) {
			
			$count_gb_items = count($gb_array);
			//$count_gb_items = CountGuestbookEntries($type);
			
			$row_count=0;

			foreach ($gb_array AS $row) {
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$row['id']=".$row['id']." <br>";
				if (($row['id'] > 0) AND ($row['show'] == TRUE)) {
					
					$row_count++;

					if ($GLOBALS['abdj_config_guestbook']['feature_show_entries_descending'] == TRUE) {
						$gb_count--;
					}
					else {
						$gb_count++;
					}

					$row['count'] = $gb_count;
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$row['id']=".$row['id']." - \$row['show']=".$row['show']." - \$row['name']=".$row['name']." - \$row['email']=".$row['email']." - \$row['message']=".$row['message']." - \$row['ip']=".$row['ip']." - \$row['timestamp']=".$row['timestamp']." <br>";
					//$guestbook .= "\$row['id']=".$row['id']." - \$row['show']=".$row['show']." - \$row['name']=".$row['name']." - \$row['email']=".$row['email']." - \$row['message']=".$row['message']." - \$row['ip']=".$row['ip']." - \$row['timestamp']=".$row['timestamp']." <br>";
					// do not show users email address
					if ($row['showemail'] == FALSE) {
						$row['email'] = "";
					}
					$row['message'] = $GLOBALS['abdj_obj_common']->CarriageReturnToHTML($row['message']);

					if ($GLOBALS['abdj_config_guestbook']['feature_masklast3digitsofip'] == TRUE) {
						$row['ip'] = substr($row['ip'], 0, strrpos($row['ip'], '.')).".xxx";
					}

					$guestbook .= $this->ReplacePlaceholders($gb_template, $row);
					if	(
							($count_gb_items < $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'] AND $row_count < $count_gb_items) OR 
							($count_gb_items > $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'] AND $row_count < $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'])
							) {
						$guestbook .= '<div class="abdjgbitemspacer">&nbsp;</div>';
					}

				} // if ($row['id'] > 0) {
			} // foreach

			if ($GLOBALS['abdj_config_guestbook']['feature_show_pages'] == TRUE) {
				abdj_CSS('FILE', $GLOBALS['abdj_file_common_pager_css']);
				$pager_index = "0";
				if ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage'] >= 1) {
					$pager_index = $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage'];
				}

				$guestbook .= '<div class="abdjgbpagerspacer">&nbsp;</div>';
				$guestbook .= $gb_pager;
			} // if ($GLOBALS['abdj_config_guestbook']['feature_show_pages'] == TRUE) {
		} // if ($gb_array != FALSE)

		return $guestbook;
	} // function ShowGuestbook()




	function ShowGuestbookSingleId($single_id='') {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$single_id=".$single_id.") <br>";

		$guestbook = '';
		
		if (!empty($single_id)) {		
			$gb_array = $this->ReadGuestbook('ID', $single_id);
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": var_dump() <br>";
			//print '<hr>'; var_dump($gb_array); print '<hr>';
		}
		if (isset($gb_array) AND is_array($gb_array) AND count($gb_array) > 0) {
			$gb_array['count'] = 1;
		
			if (@ file_exists($GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook_template'])) {
				$gb_template_data = $GLOBALS['abdj_obj_common']->Read_File("STRING", TRUE, $GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook_template']);
			} else {
				$gb_template_data = $GLOBALS['abdj_obj_common']->Read_File("STRING", TRUE, $GLOBALS['abdj_path_guestbook_data'].$GLOBALS['abdj_config_guestbook']['filename_guestbook_template_default']);
			}
			$gb_template_array = split($GLOBALS['abdj_config']['data_spacer'], $gb_template_data);
			$gb_template = trim($gb_template_array[0]);
		
			$gb_array['message'] = $GLOBALS['abdj_obj_common']->CarriageReturnToHTML($gb_array['message']);
			$guestbook = $this->ReplacePlaceholders($gb_template, $gb_array);
		} // if (is_array($gb_array) AND count($gb_array) > 0) {

		return $guestbook;
	} // function ShowGuestbookSingleId()




	function ReplacePlaceholders($text, $gb) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$gb_indexes = ARRAY ('count', 'date', 'datetime', 'email', 'id', 'ip', 'message', 'token', 'name', 'sent_verify', 'time');
		
		if (!is_array($gb)) { $gb=ARRAY(); }
		
		foreach ($gb_indexes AS $item) {
			if (!isset ($gb[$item])) {
				$gb[$item] = '';
			}
		}
		

		$template = $text;
		$template = str_replace("{{COUNT}}", $gb['count'], $template);
		$template = str_replace("{{DATE}}", $gb['date'], $template);
		$template = str_replace("{{DATETIME}}", $gb['datetime'], $template);
		$template = str_replace("{{EMAIL}}", $gb['email'], $template);
		$template = str_replace("{{ID}}", $gb['id'], $template);
		$template = str_replace("{{IP}}", $gb['ip'], $template);
		$template = str_replace("{{MESSAGE}}", $gb['message'], $template);
		$template = str_replace("{{NAME}}", $gb['name'], $template);
		$template = str_replace("{{SENTVERIFY}}", $gb['sent_verify'], $template);
		$template = str_replace("{{TIME}}", $gb['time'], $template);
		$template = str_replace("{{URLWEBSITE}}", $GLOBALS['abdj_url_cmsimple_index'], $template);
		$template = str_replace("{{URLGUESTBOOK}}", $GLOBALS['abdj_url_guestbook'], $template);
		$template = str_replace("{{WEBSITETITLE}}", $GLOBALS['abdj_lang_guestbook']['website_title'], $template);


		return $template;

	} // function ReplacePlaceholders()

	function ReadGuestbook($action, $search = "") {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action, \$search=$search) <br>";
		
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage']." <br>";

		$guestbook = FALSE;

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": GB file = ".$GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook']." <br>";



		if (strtoupper($action) == "STRING") {
			$file_data = $GLOBALS['abdj_obj_common']->Read_File("STRING", FALSE, $GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook']);
		} // if (strtoupper($action) == "STRING")

		if ((strtoupper($action) == "ARRAY") OR (strtoupper($action) == "ID")) {
			$file_array = ARRAY ();
			$file_array = $GLOBALS['abdj_obj_common']->Read_File("DATAARRAY", FALSE, $GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook']);

			if (empty ($file_array[0])) {
				$guestbook = FALSE;
			} else {
				//$guestbook = ARRAY ();
				foreach ($file_array AS $rows) {
					$row = split($GLOBALS['abdj_config']['data_spacer'], $rows);
					if (!empty ($row['8'])) {
						//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$row['0']=".$row['0']." - \$row['8']=".$row['8']." <br>";
						$human_timestamp = $GLOBALS['abdj_obj_common']->TimestampToHumanReadable(trim($row[8]));
						$gb['date'] = $human_timestamp['date'];
						$gb['time'] = $human_timestamp['time'];
						$gb['datetime'] = $human_timestamp['datetime'];

						if (strtoupper($action) == "ID") {
							$guestbook = FALSE;
							if (trim($row[0]) == $search) {
								$guestbook = ARRAY ("id" => trim($row[0]), "show" => trim($row[1]), "name" => trim($row[2]), "showemail" => trim($row[3]), "email" => trim($row[4]), "message" => trim($row[5]), "token" => trim($row[6]), "ip" => trim($row[7]), "timestamp" => trim($row[8]), "date" => $gb['date'], "time" => $gb['time'], "datetime" => $gb['datetime']);
								break;
							}
						} else {
							$guestbook[] = ARRAY ("id" => trim($row[0]), "show" => trim($row[1]), "name" => trim($row[2]), "showemail" => trim($row[3]), "email" => trim($row[4]), "message" => trim($row[5]), "token" => trim($row[6]), "ip" => trim($row[7]), "timestamp" => trim($row[8]), "date" => $gb['date'], "time" => $gb['time'], "datetime" => $gb['datetime']);
						}

					} // if (!empty($row['8'])) {
				} // foreach

			} // else if (empty($file_array[0])) {
		} // if (strtoupper($action) == "ARRAY")

		if ((strtoupper($action) == "PAGEDARRAY") OR (strtoupper($action) == "PAGEDFULLARRAY")) {
			$file_array = ARRAY ();
			$file_array = $GLOBALS['abdj_obj_common']->Read_File("DATAARRAY", FALSE, $GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook']);
			
			/*
			foreach ($file_array AS $gb) {
				print $gb.'<br>';
			}
			
			print $file_array[0].'<br>';
			print $file_array[1].'<br>';
			*/

			if (empty ($file_array[0])) {
				$guestbook = FALSE;
			} else {
				$file_array = array_reverse($file_array);

				$row_count = 0;
				$guestbook = ARRAY ();

				foreach ($file_array AS $rows) {
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$rows=".$rows." <br>";
					$row = split($GLOBALS['abdj_config']['data_spacer'], $rows);
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$row['1']=".$row['1']." <br>";

					if ((!empty ($row['8'])) AND (((strtoupper($action) == "PAGEDARRAY") AND ($row['1'] == TRUE)) OR (strtoupper($action) == "PAGEDFULLARRAY"))) {
						//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$row['1']=".$row['1']." <br>";
						$row_count ++;
						$human_timestamp = $GLOBALS['abdj_obj_common']->TimestampToHumanReadable(trim($row[8]));
						$gb['date'] = $human_timestamp['date'];
						$gb['time'] = $human_timestamp['time'];
						$gb['datetime'] = $human_timestamp['datetime'];

						if ($GLOBALS['abdj_config_guestbook']['feature_show_pages'] == TRUE) {

							// stop reading through data, if current_page is fully read
							//if ($row_count > $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage'] * $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'] - $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'] + 1) {
							if ($row_count > $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage'] * $GLOBALS['abdj_config_guestbook']['feature_show_pages_count']) {
								//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": stopped - stop reading through data, if current_page is fully read. <br>";
								break;
							}

							if (($row_count >= $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage'] * $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'] - $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'] + 1) AND ($row_count <= $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage'] * $GLOBALS['abdj_config_guestbook']['feature_show_pages_count'])) {
								//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": show paged <br>";
								$guestbook[] = ARRAY ("id" => trim($row[0]), "show" => trim($row[1]), "name" => trim($row[2]), "showemail" => trim($row[3]), "email" => trim($row[4]), "message" => trim($row[5]), "token" => trim($row[6]), "ip" => trim($row[7]), "timestamp" => trim($row[8]), "date" => $gb['date'], "time" => $gb['time'], "datetime" => $gb['datetime']);
							}
						} // if ($GLOBALS['abdj_config_guestbook']['feature_show_pages'] == TRUE)
						else {
							$guestbook[] = ARRAY ("id" => trim($row[0]), "show" => trim($row[1]), "name" => trim($row[2]), "showemail" => trim($row[3]), "email" => trim($row[4]), "message" => trim($row[5]), "token" => trim($row[6]), "ip" => trim($row[7]), "timestamp" => trim($row[8]), "date" => $gb['date'], "time" => $gb['time'], "datetime" => $gb['datetime']);
						} // else if ($GLOBALS['abdj_config_guestbook']['feature_show_pages'] == TRUE)

					} // if (!empty($row['8'])) {
				} // foreach

			} // else if (empty($file_array[0])) {
		} // if (strtoupper($action) == "PAGEDARRAY")

		return $guestbook;

	} // function ReadGuestbook()




	function AddGuestbookEntry($guestbook) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$file_data = $GLOBALS['abdj_obj_common']->Read_File("DATAARRAY", FALSE, $GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook']);
		$last_id = $GLOBALS['abdj_obj_common']->Read_File("STRING", FALSE, $GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook_id']);

		$guestbook['id'] = $last_id +1;
		$guestbook['token'] = abdj_GenerateToken(8);
		
		$GLOBALS['abdj_obj_common']->Write_File($GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook_id'], FALSE, "BEGIN", "STRING", $guestbook['id']);


		// show! in basic version
		if ($GLOBALS['abdj_config']['version'] == 'basic') {
			$guestbook['show'] = TRUE;
		}

		$guestbook['timestamp'] = $GLOBALS['abdj_config']['timestamp'];

		$file_data[] = $guestbook['id'].$GLOBALS['abdj_config']['data_spacer'].$guestbook['show'].$GLOBALS['abdj_config']['data_spacer'].$guestbook['name'].$GLOBALS['abdj_config']['data_spacer'].$guestbook['showemail'].$GLOBALS['abdj_config']['data_spacer'].$guestbook['email'].$GLOBALS['abdj_config']['data_spacer'].$guestbook['message'].$GLOBALS['abdj_config']['data_spacer'].$guestbook['token'].$GLOBALS['abdj_config']['data_spacer'].$guestbook['ip'].$GLOBALS['abdj_config']['data_spacer'].$guestbook['timestamp'];
		$write_success = $GLOBALS['abdj_obj_common']->Write_File($GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook'], FALSE, "BEGIN", "DATAARRAY", $file_data);

		$give_back=ARRAY();
		$give_back = $write_success;
		$give_back['id'] = $guestbook['id'];
		$give_back['token'] = $guestbook['token'];

		return $give_back;

	} // function AddGuestbookEntry()

	function CountGuestbookEntries($type) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$gb_all_count = 0;
		$gb_active_count = 0;

		$gb_array = $this->ReadGuestbook("ARRAY");

		if ($gb_array == FALSE) {
			$gb_count = 0;
		} // if ($gb_count == FALSE)
		else {
			foreach ($gb_array AS $row) {
				if (strtoupper($type) == "ALL") {
					$gb_all_count ++;
				}
				if ((strtoupper($type) == "ACTIVE") AND ($row['show'] == TRUE)) {
					$gb_active_count ++;
				}
			}
			if (strtoupper($type) == "ALL") {
				$gb_count = $gb_all_count;
			}
			if (strtoupper($type) == "ACTIVE") {
				$gb_count = $gb_active_count;
			}
		}

		return $gb_count;

	} // function CountGuestbookEntries()

	function GetGuestbookPager($mode, $url, $items_per_page, $current_page, $type, $url_para) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$gb_pager = FALSE;
		$gb_count = $this->CountGuestbookEntries($mode);
        //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$gb_count=$gb_count <br>";
		
		if ($gb_count > 0) {
			$pager_css=ARRAY();
			$pager_css['div'] = ' class="'.$GLOBALS['abdj_config_guestbook']['feature_show_pages_cssclass'].'div" ';
			$pager_css['a'] = ' class="'.$GLOBALS['abdj_config_guestbook']['feature_show_pages_cssclass'].'a" ';
			$pager_css['a_current'] = ' class="'.$GLOBALS['abdj_config_guestbook']['feature_show_pages_cssclass'].'acurrent" ';
			$pager_css['a_next'] = ' class="'.$GLOBALS['abdj_config_guestbook']['feature_show_pages_cssclass'].'anext" ';
			$pager_css['a_prev'] = ' class="'.$GLOBALS['abdj_config_guestbook']['feature_show_pages_cssclass'].'aprev" ';
			$gb_pager = $GLOBALS['abdj_obj_pager']->GetPager($url.$url_para, $gb_count, $items_per_page, $current_page, $type, $pager_css);
		}

		return $gb_pager;

	} // function GetGuestbookPager()

	function EditEntry($id, $action, $data) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$id=$id, \$action=$action, \$data=$data) <br>";

		$action = strtoupper($action);
		$edit_success=ARRAY();
		$edit_success['success']=TRUE;
		$edit_success['msg']='';
		
		$gb_data = '';
		$gb_edited = ARRAY();

		$gb_array = $this->ReadGuestbook("ARRAY");

		if ($gb_array == FALSE) {
			$edit_success['success'] = FALSE;
		} // if ($gb_array == FALSE)
		else {
			foreach ($gb_array AS $gb) {

				if ($id != $gb['id']) {
					$gb_edited[] = $gb['id'].$GLOBALS['abdj_config']['data_spacer'].$gb['show'].$GLOBALS['abdj_config']['data_spacer'].$gb['name'].$GLOBALS['abdj_config']['data_spacer'].$gb['showemail'].$GLOBALS['abdj_config']['data_spacer'].$gb['email'].$GLOBALS['abdj_config']['data_spacer'].$gb['message'].$GLOBALS['abdj_config']['data_spacer'].$gb['token'].$GLOBALS['abdj_config']['data_spacer'].$gb['ip'].$GLOBALS['abdj_config']['data_spacer'].$gb['timestamp'];
				} // if ($id != $gb['id'])
				else {
					if ($action == "DELETE") {
						//
					}
					if ($action == "EDIT") {
						$gb_edited[] = $gb['id'].$GLOBALS['abdj_config']['data_spacer'].$data['show'].$GLOBALS['abdj_config']['data_spacer'].$data['name'].$GLOBALS['abdj_config']['data_spacer'].$data['showemail'].$GLOBALS['abdj_config']['data_spacer'].$data['email'].$GLOBALS['abdj_config']['data_spacer'].$data['message'].$GLOBALS['abdj_config']['data_spacer'].$data['token'].$GLOBALS['abdj_config']['data_spacer'].$gb['ip'].$GLOBALS['abdj_config']['data_spacer'].$gb['timestamp'];
					}
					if ($action == "SHOW") {
						$gb_edited[] = $gb['id'].$GLOBALS['abdj_config']['data_spacer'].$data.$GLOBALS['abdj_config']['data_spacer'].$gb['name'].$GLOBALS['abdj_config']['data_spacer'].$gb['showemail'].$GLOBALS['abdj_config']['data_spacer'].$gb['email'].$GLOBALS['abdj_config']['data_spacer'].$gb['message'].$GLOBALS['abdj_config']['data_spacer'].$gb['token'].$GLOBALS['abdj_config']['data_spacer'].$gb['ip'].$GLOBALS['abdj_config']['data_spacer'].$gb['timestamp'];
					}
				} // else if ($id != $gb['id'])

			} // foreach
			
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Write_File(".$GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook'].", TRUE,  \"BEGIN\", \"DATAARRAY\", \$gb_edited); <br>";
			$write_success = $GLOBALS['abdj_obj_common']->Write_File($GLOBALS['abdj_path_guestbook_data_2lang'].$GLOBALS['abdj_config_guestbook']['filename_guestbook'], TRUE, "BEGIN", "DATAARRAY", $gb_edited);
			if ($write_success['success'] == FALSE) {
				$edit_success['success'] = FALSE;
				$edit_success['msg'] = $write_success['msg'];
			}
			
		} // else if ($gb_array == FALSE)
		
		return $edit_success;

	} // function EditEntry()



	function GetIDbyToken($token='') {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$token=$token) <br>";

		$gb_id=FALSE;
		$found_token=FALSE;
		
		foreach ($GLOBALS['abdj_config_guestbook']['available_languages_array'] AS $gb_lang) {

			$GLOBALS['abdj_path_guestbook_data_2lang'] = $GLOBALS['abdj_path_guestbook'].$GLOBALS['abdj_dir_guestbook_data'].$gb_lang.'/';

			$gb_array = $this->ReadGuestbook("ARRAY");

			if ($gb_array == FALSE) {
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$gb_array == FALSE <br>";
			} // if ($gb_array == FALSE)
			else {
				foreach ($gb_array AS $gb) {
					if ($token == $gb['token']) {
						$found_token = TRUE;
						$gb_id = $gb['id'];
						break;
					} // if ($id != $gb['id'])
				} // foreach
			} // else if ($gb_array == FALSE)
			
			if ($found_token == TRUE) { break; }
		
		} // foreach GB file
		
		return $gb_id;
		
	} // function GetIDbyToken()


} // class Abdj_Guestbook

?>