<?php


/*
Addonsbydjot basic version 2.3
released January 1st 2007

copyright 2003-2007 by Jan Neugebauer
cmsimple2007@internet-setup.de

homepage:
http://www.internet-setup.de/cmsimple/index.php

support forum:
http://www.cmsimple.dk/forum/


Copyright:
You are allowed to use this software.
The code itself is copyrighted by the author of this software.
You do not acquire any property on the code.
Reverse engineering of the code violates the license.

Copyright link:
You are not allowed to remove or to edit the copyright link.

License key:
Licensed versions of Addonsbydjot may be used for one CMSimple
installation only. If you have more than one installation of CMSimple,
you will need additional licenses of Addonsbydjot.

Distribution:
It is strictly forbidden, twice-prohibited
to sell or distribute this software or even parts of it!

Warranties:
No warranties at all! Use at your own risk!

Freelance:
If you want to ...
- sell this software or parts of it,
- need additional features or customization of CMSimple or addons
- need a programmer for other projects,
... contact me. I may work as freelancer for you.

Invalid Clauses:
The inoperativeness of one or several provisions of said General Conditions
does not affect the validity of the remaining provisions.
In such case a provision is applicable which meets best the legal and
economic aim of the inoperative provision. This does not apply in case
complying with the terms of the Contract would constitute unreasonable
hardship for one or both of the Parties.
*/

ignore_user_abort(TRUE);

class Addonsbydjot {

	function Addonsbydjot() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";
	} // function Addonsbydjot()

	function abdj_kernel($caller, $addon, $action, $para) {

		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$caller=$caller, \$addon=$addon, \$action=$action, \$para=".$para.") <br>";

		$this->caller = $caller;
		$this->addon = $addon;
		$this->action = $action;
		$this->para = $para;
		
		// Set CMSimples $adm to global
		global $adm;
		

		$GLOBALS['abdj_admin_call'] = FALSE;

		$abdj_admin_panel = '';
		$abdj_admin_lang_title = '';
		$abdj_admin_title = '';
		$abdj_admin_task = '';
		
		if (!isset($_GET['abdj_get_caller'])) { $_GET['abdj_get_caller']=''; }

		if (isset ($_GET['abdj_get_addon']) AND $_GET['abdj_get_addon'] == 'showcaptcha') {
			require_once($GLOBALS['abdj_file_common_captcha']);
			exit;
		}

		if (isset ($_GET['abdj_x'])) {
			//nlactlink - newsletter activation link is clicked
			$x_paras = split('_', $_GET['abdj_x']);


			// Counter: do not count admin link

			if ($x_paras[0] == 'cadmcount') {
				$_GET['abdj_get_addon'] = 'counter';
				$_GET['abdj_get_caller'] = 'admin_extern';
				if (strtolower($x_paras[1]) == 'no') {
					$_GET['abdj_get_addon_task'] = 'admin_counter_donotcountadmin_do_extern';
					$_GET['abdj_get_donotcountadmin'] = TRUE;
				}
				if (strtolower($x_paras[1]) == 'ag') {
					$_GET['abdj_get_addon_task'] = 'admin_counter_donotcountadmin';
					$_GET['abdj_get_donotcountadminanymore'] = TRUE;
				}
			}
			
			// preview guestbook item out of admin email (external link)
			if (
				$x_paras[0] == 'gbexprev' OR $x_paras[0] == 'gbexshow' OR
				$x_paras[0] == 'gbexhide' OR $x_paras[0] == 'gbexdel'
			) {
				$_GET['abdj_get_addon'] = 'guestbook';
				$_GET['abdj_get_caller'] = 'admin_extern';
				$_GET['abdj_get_addon_task'] = 'admin_guestbook_edit_do_extern';
				switch ($x_paras[0]) {
					case 'gbexprev': $_GET['abdj_get_editgbaction'] = 'preview'; break;
					case 'gbexshow': $_GET['abdj_get_editgbaction'] = 'show'; break;
					case 'gbexhide': $_GET['abdj_get_editgbaction'] = 'hide'; break;
					case 'gbexdel': $_GET['abdj_get_editgbaction'] = 'delete'; break;
				}
				$_GET['abdj_get_token'] = $x_paras[1];
			}

			// activation link out of email was clicked
			if ($x_paras[0] == 'nlactli') {
				$_GET['abdj_get_addon'] = 'newsletter';
				$_GET['abdj_get_caller'] = 'addon_extern';
				$_GET['abdj_get_addon_task'] = 'admin_newsletter_activationlink';
				$_GET['abdj_token'] = $x_paras[1];
			}

			// unsubscribe link out of email was clicked
			if ($x_paras[0] == 'nlunli') {
				$_GET['abdj_get_addon'] = 'newsletter';
				$_GET['abdj_get_caller'] = 'addon_extern';
				$_GET['abdj_get_addon_task'] = 'admin_newsletter_unsubscribelink';
				$_GET['abdj_token'] = $x_paras[1];
			}
		} // if (isset ($_GET['abdj_x'])) {




		if (!empty($_GET['abdj_get_caller'])) {
			$this->caller = $_GET['abdj_get_caller'];
			if ($this->caller == "adminstart") {
				$this->caller = "cms";
			}
		}


		if	(	
				($adm AND $this->caller != "function" AND isset($_GET['abdj_get_admin']))
				OR
				($adm AND $this->caller == 'cms' AND empty($this->addon))
				OR
				$_GET['abdj_get_caller'] == 'admin_extern'
			)
		{
			// Set current language to language admin in config of addonsbydjot 
			$GLOBALS['abdj_config']['lang_current_language'] = $GLOBALS['abdj_config']['language_admin'];
			
			// require admin language
			$abdj_require = $GLOBALS['abdj_path_addonsbydjot'].$GLOBALS['abdj_dir_lang'].$GLOBALS['abdj_config']['language_admin'].'.php';
			abdj_ErrorRequire($abdj_require);			
			require($abdj_require);

		}


		if ($this->caller != "function" AND isset($_GET['abdj_get_admin']) AND $adm) {
			$abdj_get['abdj_get_admin'] = $_GET['abdj_get_admin'];
			$GLOBALS['abdj_admin_call'] = TRUE;
			$this->caller = "adminpanel";
		} // if ($this->caller != "function")

		
		if ($this->caller == "function" AND isset($_GET['abdj_get_admin']) AND $adm) {
			$GLOBALS['abdj_admin_call'] = TRUE;
		}
		//
		// $this->caller == "admin_extern" in case of calling donotcountadmin without being logged in
		// via link $GLOBALS['abdj_url_para_admin_counter_donotcountadmin_do_extern']
		//
		if (($this->caller == "adminpanel") OR ($this->caller == "admin_extern") OR ($this->caller == "addon_extern")) {

			if (isset ($_GET['abdj_get_addon'])) {
				$this->addon = $_GET['abdj_get_addon'];
			}

			if (isset ($_GET['abdj_get_addon_task'])) {
				$this->action = $_GET['abdj_get_addon_task'];
			}

		} // if ($this->caller == "adminpanel")
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->caller=".$this->caller.", \$this->addon=".$this->addon.", \$this->action=".$this->action." <br>";


		// require Admin Language
		require ($GLOBALS['abdj_path_admin'].$GLOBALS['abdj_dir_lang'].$GLOBALS['abdj_config']['lang_current_language'].'.php');
		
		// Show admin start if no addons is selected (and logged in into CMSimple)
		$abdj_admin_do_start = FALSE;
		if ($this->caller == 'cms' AND empty($this->addon) AND $adm) {
			$this->caller = "adminpanel";
			$abdj_admin_do_start = TRUE;
		}


		if (($this->caller == "adminpanel") OR ($this->caller == "admin_extern")) {
			// add admin CSS
			abdj_CSS('FILE', $GLOBALS['abdj_file_css_addonsbydjot_admin']);
		}

		/* START //COMMENT_REFERRER// */
		//if ($GLOBALS['abdj_admin_exit_is_set'] == TRUE) {
		//
		//}
		/* END //COMMENT_REFERRER// */

		if ($GLOBALS['abdj_admin_call'] == FALSE) {
			if (isset ($GLOBALS['abdj_cf_head_SET'])) {
				if ($GLOBALS['abdj_cf_head_SET'] == FALSE) {
					$GLOBALS['abdj_cf_head_SET'] = TRUE;
					$abdj_meta = "\n".'<meta name="author" content="Jan Neugebauer">'."\n";
					$abdj_meta .= '<meta name="keywords" content="addon, addonsbydjot, cmsimple, counter, editor, guestbook, mailform, newsletter, voting, djot, jan, neugebauer">'."\n";
					abdj_Head($abdj_meta);
				}
			}
		}

		if (($this->caller == "adminpanel") OR ($this->caller == "admin_extern")) {
			// require Addonsbydjot-Admin Language
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$GLOBALS['abdj_lang_common']['status_file_writeable_no']=".$GLOBALS['abdj_lang_common']['status_file_writeable_no']." <br>";
			// require Admin Language
			require ($GLOBALS['abdj_path_admin'].$GLOBALS['abdj_dir_lang'].$GLOBALS['abdj_config']['lang_current_language'].'.php');
		}

		if ($this->caller == "adminpanel") {

			$abdj_admin_panel_highlight_addon = ARRAY ('config' => '', 'counter' => '', 'guestbook' => '', 'license' => '', 'newsletter' => '', 'version' => '', 'voting' => '');
			$abdj_admin_panel_highlight_addon["$this->addon"] = 'id="high"';
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$abdj_admin_panel_highlight_addon['config']=".$abdj_admin_panel_highlight_addon['config']."<br>";

			$abdj_admin_panel = '<table cellspacing="0" cellpadding="0" border="1" class="edit_abdj">';

			/*
			global $sn;
			$abdj_admin_panel .= '<tr><td align="center" colspan="3"><a href="'.$sn.'?'.amp().'addonsbydjot'.amp().'abdj_get_caller=adminstart">'.$GLOBALS['abdj_lang']['admin_title_addonsbydjot'].'</a></td></tr>';
			*/

			$abdj_admin_panel .= '<tr><td '.$abdj_admin_panel_highlight_addon['config'].'><a '.$abdj_admin_panel_highlight_addon['config'].' href="'.$GLOBALS['abdj_url_admin_config'].'">'.$GLOBALS['abdj_lang']['admin_title_config'].'</a></td><td '.$abdj_admin_panel_highlight_addon['license'].'><a '.$abdj_admin_panel_highlight_addon['license'].' href="'.$GLOBALS['abdj_url_admin_license'].'">'.$GLOBALS['abdj_lang']['admin_title_license'].'</a></td><td '.$abdj_admin_panel_highlight_addon['version'].'><a '.$abdj_admin_panel_highlight_addon['version'].' href="'.$GLOBALS['abdj_url_admin_version'].'">'.$GLOBALS['abdj_lang']['admin_title_version'].'</a></td></tr></table>';

			$abdj_admin_panel .= '<table cellspacing="0" cellpadding="0" border="1" class="edit_abdjaddon"><tr>';
			$abdj_admin_panel .= '<td '.$abdj_admin_panel_highlight_addon['counter'].'><a '.$abdj_admin_panel_highlight_addon['counter'].' href="'.$GLOBALS['abdj_url_admin_counter'].'">'.$GLOBALS['abdj_lang']['admin_title_counter'].'</a></td>';

			/* Guestbook.Edit - START //COMMENT_VERSION_ADVANCED// */
			$abdj_admin_panel .= '<td '.$abdj_admin_panel_highlight_addon['guestbook'].'><a '.$abdj_admin_panel_highlight_addon['guestbook'].' href="'.$GLOBALS['abdj_url_admin_guestbook'].'">'.$GLOBALS['abdj_lang']['admin_title_guestbook'].'</a></td>';
			//$abdj_admin_panel .= '<td '.$abdj_admin_panel_highlight_addon['guestbook'].'><a '.$abdj_admin_panel_highlight_addon['guestbook'].' href="'.$GLOBALS['abdj_url']['admin_guestbook_edit'].'">'.$GLOBALS['abdj_lang']['admin_title_guestbook'].'</a></td>';
			/* END //COMMENT_VERSION_ADVANCED// Guestbook.Edit */

			$abdj_admin_panel .= '<td '.$abdj_admin_panel_highlight_addon['newsletter'].'><a '.$abdj_admin_panel_highlight_addon['newsletter'].' href="'.$GLOBALS['abdj_url_admin_newsletter'].'">'.$GLOBALS['abdj_lang']['admin_title_newsletter'].'</a></td>';
			$abdj_admin_panel .= '<td '.$abdj_admin_panel_highlight_addon['voting'].'><a '.$abdj_admin_panel_highlight_addon['voting'].' href="'.$GLOBALS['abdj_url_admin_voting'].'">'.$GLOBALS['abdj_lang']['admin_title_voting'].'</a></td>';
			$abdj_admin_panel .= '</tr></table>';

			if (!empty ($this->addon)) {
				$abdj_admin_panel .= '<table cellspacing="0" cellpadding="0" border="1" class="edit_abdjaddontask">';

				$abdj_admin_panel_highlight_task = ARRAY ('admin_counter_showsummary' => '', 'admin_counter_showonlinevisitors' => '', 'admin_counter_donotcountadmin' => '', 'admin_counter_editfiles' => '', 'admin_guestbook_edit' => '', 'admin_guestbook_editfiles' => '', 'admin_newsletter_send' => '', 'admin_newsletter_editsubscribers' => '', 'admin_newsletter_editfiles' => '', 'admin_voting_showvotings' => '', 'admin_voting_onoffreset' => '', 'admin_voting_editfiles' => '');

				if (!empty ($this->action)) {
					$abdj_admin_panel_highlight_task["$this->action"] = 'id="high"';
				}

				switch ($this->addon) {
					case 'counter' :
						$abdj_admin_panel .= '<tr><td '.$abdj_admin_panel_highlight_task['admin_counter_showsummary'].'><a '.$abdj_admin_panel_highlight_task['admin_counter_showsummary'].' href="'.$GLOBALS['abdj_url']['admin_counter_showsummary'].'">'.$GLOBALS['abdj_lang']['admin_title_counter_showsummary'].'</a></td>';

						/* Editor - START //COMMENT_VERSION_ADVANCED// */
						$abdj_admin_panel .= '<td '.$abdj_admin_panel_highlight_task['admin_counter_editfiles'].'><a '.$abdj_admin_panel_highlight_task['admin_counter_editfiles'].' href="'.$GLOBALS['abdj_url']['admin_counter_editfiles'].'">'.$GLOBALS['abdj_lang']['admin_title_counter_editfiles'].'</a></td>';
						/* END //COMMENT_VERSION_ADVANCED// Editor */
						$abdj_admin_panel .= '</tr>';
						break;

					/* Guestbook.Edit - START //COMMENT_VERSION_ADVANCED// */
					case 'guestbook' :
						$abdj_admin_panel .= '<tr><td '.$abdj_admin_panel_highlight_task['admin_guestbook_edit'].'><a '.$abdj_admin_panel_highlight_task['admin_guestbook_edit'].' href="'.$GLOBALS['abdj_url']['admin_guestbook_edit'].'">'.$GLOBALS['abdj_lang']['admin_title_guestbook_edit'].'</a></td>';
						/* Editor - START //COMMENT_VERSION_ADVANCED// */
						$abdj_admin_panel .= '<td '.$abdj_admin_panel_highlight_task['admin_guestbook_editfiles'].'><a '.$abdj_admin_panel_highlight_task['admin_guestbook_editfiles'].' href="'.$GLOBALS['abdj_url_admin_guestbook_editfiles'].'">'.$GLOBALS['abdj_lang']['admin_title_guestbook_editfiles'].'</a></td>';
						/* END //COMMENT_VERSION_ADVANCED// Editor */
						$abdj_admin_panel .= '</tr>';
						break;
					/* END //COMMENT_VERSION_ADVANCED// Guestbook.Edit */

					case 'newsletter' :
						$abdj_admin_panel .= '<tr><td '.$abdj_admin_panel_highlight_task['admin_newsletter_send'].'><a '.$abdj_admin_panel_highlight_task['admin_newsletter_send'].' href="'.$GLOBALS['abdj_url']['admin_newsletter_send'].'">'.$GLOBALS['abdj_lang']['admin_title_newsletter_send'].'</a></td><td '.$abdj_admin_panel_highlight_task['admin_newsletter_editsubscribers'].'><a '.$abdj_admin_panel_highlight_task['admin_newsletter_editsubscribers'].' href="'.$GLOBALS['abdj_url']['admin_newsletter_editsubscribers'].'">'.$GLOBALS['abdj_lang']['admin_title_newsletter_editsubscribers'].'</a></td>';
						/* Editor - START //COMMENT_VERSION_ADVANCED// */
						$abdj_admin_panel .= '<td '.$abdj_admin_panel_highlight_task['admin_newsletter_editfiles'].'><a '.$abdj_admin_panel_highlight_task['admin_newsletter_editfiles'].' href="'.$GLOBALS['abdj_url_admin_newsletter_editfiles'].'">'.$GLOBALS['abdj_lang']['admin_title_newsletter_editfiles'].'</a></td>';
						/* END //COMMENT_VERSION_ADVANCED// Editor */
						$abdj_admin_panel .= '</tr>';
						break;

					case 'voting' :
						$abdj_admin_panel .= '<tr><td '.$abdj_admin_panel_highlight_task['admin_voting_showvotings'].'><a '.$abdj_admin_panel_highlight_task['admin_voting_showvotings'].' href="'.$GLOBALS['abdj_url_admin_voting_showvotings'].'">'.$GLOBALS['abdj_lang']['admin_title_voting_showvotings'].'</a></td><td '.$abdj_admin_panel_highlight_task['admin_voting_onoffreset'].'><a '.$abdj_admin_panel_highlight_task['admin_voting_onoffreset'].' href="'.$GLOBALS['abdj_url_admin_voting_onoffreset'].'">'.$GLOBALS['abdj_lang']['admin_title_voting_onoffreset'].'</a></td>';
						/* Editor - START //COMMENT_VERSION_ADVANCED// */
						$abdj_admin_panel .= '<td '.$abdj_admin_panel_highlight_task['admin_voting_editfiles'].'><a '.$abdj_admin_panel_highlight_task['admin_voting_editfiles'].' href="'.$GLOBALS['abdj_url_admin_voting_editfiles'].'">'.$GLOBALS['abdj_lang']['admin_title_voting_editfiles'].'</a></td>';
						/* END //COMMENT_VERSION_ADVANCED// Editor */
						$abdj_admin_panel .= '</tr>';
						break;

					case 'config' : //
						break;
					case 'filepermissions' : //
						break;

					case 'license' : //
						break;

					case 'version' : //
						break;
				} // switch


				$abdj_admin_panel .= '</table>';
				$abdj_admin_panel .= '<div class="edit_abdj_spacer"></div>';

				/*
				global $o;
				$o .= $abdj_admin_panel;
				$abdj_admin_panel='';
				*/

			} // if (!empty ($this->addon))

			$abdj_admin_title = '';
		} // if ($this->caller == "adminpanel") {


//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->addon=".$this->addon." <br>";
//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->action=".$this->action." <br>";


		if (isset ($_GET['abdj_cfg_addon'])) { $abdj_get['abdj_cfg_addon'] = $_GET['abdj_cfg_addon']; }
		else { $abdj_get['abdj_cfg_addon'] = ''; }
		
		if	($this->addon == 'counter' OR $abdj_admin_do_start == TRUE OR $this->addon == 'filepermissions' OR ($this->addon == 'config' AND $abdj_get['abdj_cfg_addon'] == 'counter')	) {
			// require Counter Config
			require ($GLOBALS['abdj_file_counter_config']);
			// require Counter Language
			require ($GLOBALS['abdj_path_counter'].$GLOBALS['abdj_dir_lang'].$GLOBALS['abdj_config']['lang_current_language'].'.php');
			if ($this->addon == 'counter') {
				if (!empty ($this->action)) {	$abdj_admin_task = $this->Counter($this->action, $this->para); }
			}
		}


/* Editor - START //COMMENT_VERSION_ADVANCED// */
		$editor_call_actions = ARRAY('admin_counter_editfiles', 'admin_guestbook_editfiles', 'admin_newsletter_editfiles', 'admin_voting_editfiles');
		if	($this->addon == 'editor' OR in_array($this->action, $editor_call_actions) OR $abdj_admin_do_start == TRUE OR $this->addon == 'filepermissions' OR ($this->addon == 'config' AND $abdj_get['abdj_cfg_addon'] == 'editor')	) {
			// require Editor Config
			require ($GLOBALS['abdj_file_editor_config']);
			// require Editor Language
			require ($GLOBALS['abdj_path_editor'].$GLOBALS['abdj_dir_lang'].$GLOBALS['abdj_config']['lang_current_language'].'.php');
		
			if	($this->addon == 'editor') {
				if (!empty ($this->action)) { $abdj_admin_task = $this->Editor($this->action, $this->para);	}
			}
		}
/* END //COMMENT_VERSION_ADVANCED// Editor */




		if	($this->addon == 'guestbook' OR $abdj_admin_do_start == TRUE OR $this->addon == 'filepermissions' OR ($this->addon == 'config' AND $abdj_get['abdj_cfg_addon'] == 'guestbook')	) {
			// require Guestbook Config
			require ($GLOBALS['abdj_file_guestbook_config']);
			// require Guestbook Language
			require ($GLOBALS['abdj_path_guestbook'].$GLOBALS['abdj_dir_lang'].$GLOBALS['abdj_config']['lang_current_language'].'.php');
			if ($this->addon == 'guestbook') {
				if (!empty ($this->action)) {	$abdj_admin_task = $this->Guestbook($this->action, $this->para); }
			}
		}


		if ($this->addon == 'license') {
			// required, if called out of Common Functions
			// require Admin Language
			require ($GLOBALS['abdj_path_admin'].$GLOBALS['abdj_dir_lang'].$GLOBALS['abdj_config']['lang_current_language'].'.php');
			$abdj_admin_task = $this->License();
		}


		if	($this->addon == 'mailform' OR $abdj_admin_do_start == TRUE OR $this->addon == 'filepermissions' OR ($this->addon == 'config' AND $abdj_get['abdj_cfg_addon'] == 'mailform')	) {
			// require Mailform Config
			require ($GLOBALS['abdj_file_mailform_config']);
			// require Mailform Language
			require ($GLOBALS['abdj_path_mailform'].$GLOBALS['abdj_dir_lang'].$GLOBALS['abdj_config']['lang_current_language'].'.php');
			if ($this->addon == 'mailform') {
				if (!empty ($this->action)) {	$abdj_admin_task = $this->Mailform($this->action, $this->para); }
			}
		}


		if	($this->addon == 'newsletter' OR $abdj_admin_do_start == TRUE OR $this->addon == 'filepermissions' OR ($this->addon == 'config' AND $abdj_get['abdj_cfg_addon'] == 'newsletter')	) {
			// require Newsletter Config
			require ($GLOBALS['abdj_config_newsletter']['filename_config']);
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Newsletter config file included <br>";
			// require Newsletter Language
			require ($GLOBALS['abdj_path_newsletter'].$GLOBALS['abdj_dir_lang'].$GLOBALS['abdj_config']['lang_current_language'].'.php');
			if ($this->addon == 'newsletter') {
				if (!empty ($this->action)) {	$abdj_admin_task = $this->Newsletter($this->action, $this->para); }
			}
		}


		if ($this->addon == 'version') {
			$abdj_admin_task = $this->Version($this->action);
		}


		if	($this->addon == 'voting' OR $abdj_admin_do_start == TRUE OR $this->addon == 'filepermissions' OR ($this->addon == 'config' AND $abdj_get['abdj_cfg_addon'] == 'voting')	) {
			// require Voting Config
			$abdj_thiscfg_voting_lang_user = ARRAY ();
			$abdj_thiscfg_voting = ARRAY ();
			require ($GLOBALS['abdj_file_voting_config']);
			$para['cfg_voting'] = $abdj_thiscfg_voting ;
			$para['cfg_voting_lang_user'] = $abdj_thiscfg_voting_lang_user;
			// require Voting Language
			require ($GLOBALS['abdj_path_voting'].$GLOBALS['abdj_dir_lang'].$GLOBALS['abdj_config']['lang_current_language'].'.php');
			if ($this->addon == 'voting') {
				if (!empty ($this->action)) {	$abdj_admin_task = $this->Voting($this->action, $this->para); }
			}
		}


		if ($this->addon == 'config') {
			$abdj_admin_task = $this->Config($this->action, $this->para);
		}


		if ($this->addon == 'filepermissions') {
			$abdj_admin_task = $this->Filepermissions();
		}
		if ($abdj_admin_do_start == TRUE) {
			$abdj_admin_start_fp_success = $this->Filepermissions();
			$abdj_admin_task = require ($GLOBALS['abdj_file_admin_start']);
		}




		if ($this->caller == "adminpanel") {
			$abdj_output = $abdj_admin_panel.$abdj_admin_title.$abdj_admin_task;
		} else {
			$abdj_output = $abdj_admin_task;
		}

		return $abdj_output;

	} // function abdj_kernel()









	function Config($action, $para) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action, \$para=$para) <br>";

		// require Config Language
		//require_once ($GLOBALS['abdj_path_lang'].$GLOBALS['abdj_filename_language_config']);

		// Do Config
		$config = require ($GLOBALS['abdj_file_admin_config']);

		return $config;
	} // function Config()




	function Counter($action, $para) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action) <br>";
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$GLOBALS['abdj_admin_call']=".$GLOBALS['abdj_admin_call']." <br>";

		$counter = "";

		// require Counter Class
		if (!class_exists("Abdj_Counter")) {
			require_once ($GLOBALS['abdj_file_counter_class']);
		}
		$obj_counter = new Abdj_Counter();
		$obj_counter->SetLanguage($GLOBALS['abdj_lang_counter']);
		$abdj_para['path_counter'] = $GLOBALS['abdj_path_counter'];
		$abdj_para['path_counter_data'] = $GLOBALS['abdj_path_counter_data'];
		$abdj_para['path_counter_data_2lang'] = $GLOBALS['abdj_path_counter_data_2lang'];
		$obj_counter->SetParameter($abdj_para);



		if ($action == "admin_counter_editfiles") {
			$editor_files['this_files'] = $GLOBALS['abdj_obj_common']->CollectDirRecursivly($GLOBALS['abdj_path_counter_data'], '');
			$editor_files['this_files'] = $GLOBALS['abdj_obj_common']->CollectDirRemoveForbidden($editor_files['this_files'], "");
			if (empty ($editor_files['this_files'][0])) {
				$counter = "<fieldset class=\"abdjadminform\"><legend class=\"abdjadminform\">".$GLOBALS['abdj_lang']['admin_title_counter_editfiles']."</legend><div class=\"abdjadminform\">".$GLOBALS['abdj_lang_editor']['no_files_counter']."</div></fieldset>";
			} else {
				$counter = $this->Editor($editor_files);
			}
		} // if ($action == "admin_counter_editfiles")

		if ($action == "admin_counter_showsummary") {
			$counter = require_once ($GLOBALS['abdj_file_admin_counter_showsummary']);
		}

		if (($action == "show_summary") OR ($action == "admin_show_summary")) {
			if ($action == "admin_show_summary") {
				$GLOBALS['abdj_admin_call'] = TRUE;
				$abdj_para['lang_current_editlanguage'] = $GLOBALS['abdj_config']['lang_current_editlanguage'];
				$obj_counter->SetParameter($abdj_para);
			}
			$counter = $obj_counter->Summary();
		}

		if ($action == "page_views") {
			$counter = $obj_counter->Page_Views($para['pagename'], $para['mode']);
		}

		if ($action == "count_page") {
			$counter = $obj_counter->Count_Page($para['pagename']);
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$counter=".$counter." <br>";
		}

		return $counter;
	} // function Counter()




/* Editor - START //COMMENT_VERSION_ADVANCED// */
	function Editor($files) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$files=$files) <br>";
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$files['this_files']=".$files['this_files'].") <br>";
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$files['this_files'][0]=".$files['this_files'][0].") <br>";

		$editor = "";

		// require Editor Config
		require ($GLOBALS['abdj_file_editor_config']);
		// require Editor Language
		require ($GLOBALS['abdj_path_editor'].$GLOBALS['abdj_dir_lang'].$GLOBALS['abdj_config']['lang_current_language'].'.php');

		//require Editor Class
		if (!class_exists("Abdj_Editor")) {
			require ($GLOBALS['abdj_file_editor_class']);
			$obj_editor = new Abdj_Editor();
		}

		$files['this_files'] = $GLOBALS['abdj_obj_common']->CollectDirRemoveForbidden($files['this_files'], "");
		asort($files['this_files']);
		foreach ($files['this_files'] AS $filename) {
			$files[] = ARRAY ("path" => dirname($filename)."/", "filename" => basename($filename), "readable" => "1", "writeable" => "1", "deleteable" => "1");
		}

		$obj_editor->SetLanguage($GLOBALS['abdj_lang_editor']);
		$obj_editor->Set_Files_Allowed_Array($files);
		$editor = $obj_editor->Editor_Kernel();

		return $editor;
	} // function Editor()
/* END //COMMENT_VERSION_ADVANCED// Editor */




	function Filepermissions() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action, \$para=$para) <br>";

		$filepermissions = "";

		// require Config Language
		//require_once ($GLOBALS['abdj_path_lang'].$GLOBALS['abdj_filename_language_config']);

		$filepermissions = require ($GLOBALS['abdj_file_admin_filepermissions']);

		return $filepermissions;
	} // function Filepermissions()




	function Guestbook($action, $para) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action, \$para) <br>";
		//var_dump($para); print '<hr>';

		$guestbook = "";

		abdj_CSS('FILE', $GLOBALS['abdj_file_guestbook_css']);

		// require Pager Class
		if (!class_exists("Abdj_Pager")) {
			require ($GLOBALS['abdj_file_common_pager']);
		}
		$GLOBALS['abdj_obj_pager'] = new Abdj_Pager();

		// require Guestbook Class
		if (!class_exists("Abdj_Guestbook")) {
			require ($GLOBALS['abdj_file_guestbook_class']);
		}
		$obj_guestbook = new Abdj_Guestbook();

		if ($action == "admin_guestbook_edit") {
			$guestbook = require_once ($GLOBALS['abdj_file_admin_guestbook_edit']);
		}

		if ($action == "admin_guestbook_editfiles") {
			$editor_files['this_files'] = $GLOBALS['abdj_obj_common']->CollectDirRecursivly($GLOBALS['abdj_path_guestbook_data'], '');
			$editor_files['this_files'] = $GLOBALS['abdj_obj_common']->CollectDirRemoveForbidden($editor_files['this_files'], "");
			//foreach ($editor_files['this_files'] AS $file) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$file=$file <br>";
			//}
			if (empty ($editor_files['this_files'][0])) {
				$guestbook = "<fieldset class=\"abdjadminform\"><legend class=\"abdjadminform\">".$GLOBALS['abdj_lang']['admin_title_voting_editfiles']."</legend><div class=\"abdjadminform\">".$GLOBALS['abdj_lang_editor']['no_files_voting']."</div></fieldset>";
			} else {
				$guestbook = $this->Editor($editor_files);
			}
		} // if ($action == "admin_guestbook_editfiles")

		/* Guestbook.Edit - START //COMMENT_VERSION_ADVANCED// */
		if ($action == "edit" OR $action == "admin_guestbook_edit_do_extern") {
			$guestbook = $obj_guestbook->EditEntry($para['id'], $para['action'], $para['data']);
		}
		/* END //COMMENT_VERSION_ADVANCED// Guestbook.Edit */

		if ($action == "read_guestbook") {
			$guestbook = $obj_guestbook->ReadGuestbook($para['action'], $para['search']);
		}

		if ($action == "replace_placeholders") {
			$guestbook = $obj_guestbook->ReplacePlaceholders($para['text'], $para['gb']);
		}

		if ($action == "pager") {
			$guestbook = $obj_guestbook->GetGuestbookPager($para['mode'], $para['url'], $para['items_per_page'], $para['current_page'], $para['type'], $para['url_para']);
		}

		if ($action == 'public_guestbookform') {
			$guestbook = $obj_guestbook->Guestbook($para['caller']);
		}

		if ($action == "public_show_entries") {
			$guestbook = $obj_guestbook->ShowGuestbook($action);
		}

		return $guestbook;
	} // function Guestbook()




	function License() {
		//COMMENT_FUNCTION// //	print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action) <br>";
		$license = require ($GLOBALS['abdj_file_admin_license']);
		return $license;
	} // function License()




	function Mailform() {
		//COMMENT_FUNCTION// //	print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action) <br>";
		//$mailform = require ($GLOBALS['abdj_file_admin_version']);

		abdj_CSS('FILE', $GLOBALS['abdj_file_mailform_css']);

		// require Mailform Class
		if (!class_exists("Abdj_Mailform")) {
			require ($GLOBALS['abdj_file_mailform_class']);
		}
		$obj_mailform = new Abdj_Mailform();
		$mailform = $obj_mailform->Mailform();

		return $mailform;
	} // function Mailform()




	function Newsletter($action, $para) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action, \$para=$para) <br>";

		$newsletter = '';
		$abdj_admin_newsletter = '';

		// require Newsletter Class
		if (!class_exists("Abdj_Newsletter")) {
			require ($GLOBALS['abdj_config_newsletter']['filename_class']);
		}
		$obj_newsletter = new Abdj_Newsletter();



		// require Pager Class
		if ($action == "admin_newsletter_editsubscribers" OR $action == "editsubscribers") {
			if (!class_exists("Abdj_Pager")) {
				require ($GLOBALS['abdj_file_common_pager']);
			}
			$GLOBALS['abdj_obj_pager'] = new Abdj_Pager();
		}

		if ($action == "admin_newsletter_editfiles") {
			$editor_files['this_files'] = $GLOBALS['abdj_obj_common']->CollectDirRecursivly($GLOBALS['abdj_path_newsletter_data'], '');
			$editor_files['this_files'] = $GLOBALS['abdj_obj_common']->CollectDirRemoveForbidden($editor_files['this_files'], "");
			if (empty ($editor_files['this_files'][0])) {
				$newsletter = "<fieldset class=\"abdjadminform\"><legend class=\"abdjadminform\">".$GLOBALS['abdj_lang_editor']['no_files_newsletter']."</legend><div class=\"abdjadminform\">".$GLOBALS['abdj_lang_editor']['no_files_counter']."</div></fieldset>";
			} else {
				$newsletter = $this->Editor($editor_files);
			}
		} // if ($action == "admin_newsletter_editfiles")

		if ($action == "admin_newsletter_editsubscribers") {
			$newsletter = require_once ($GLOBALS['abdj_file_admin_newsletter_editsubscribers']);
		} // if ($action == "admin_newsletter_editsubscribers")

		if ($action == "admin_newsletter_send") {
			$newsletter = require_once ($GLOBALS['abdj_file_admin_newsletter_send']);
		} // if ($action == "admin_newsletter_send")

		if ($action == "admin_newsletter_queue") {
			global $hjs;

			$abdj_admin_newsletter_queue = $obj_newsletter->Newsletter_Queue();
			$hjs = $abdj_admin_newsletter_queue['meta_refresh'];
			$abdj_admin_newsletter .= "<html><head>".head()."</head><body class=\"retrieve\">";
			$abdj_admin_newsletter .= $abdj_admin_newsletter_queue['msg'];
			$abdj_admin_newsletter .= "</body></html>";

			$abdj_admin_newsletter = abdj_XHTML_endtags($abdj_admin_newsletter);
			echo $abdj_admin_newsletter;
			exit;
		} // if ($action == "admin_newsletter_queue")

		if ($action == "editsubscribers") {
			$newsletter = $obj_newsletter->Edit_Subscriber($para['action'], $para['subsid']);
		}

		if ($action == "pager") {
			$newsletter = $obj_newsletter->Get_Edit_Subscriber_Pager($para['alias'], $para['url'], $para['items_per_page'], $para['current_page'], $para['type'], $para['url_para']);
		}

		if ($action == "subscribe") {
			$newsletter = $obj_newsletter->Subscribe($para['alias'], 'subscribe');
		}
		if ($action == "unsubscribe") {
			$newsletter = $obj_newsletter->Subscribe($para['alias'], 'unsubscribe');
		}
		if ($action == "previous_newsletters_link") {
			$newsletter = $obj_newsletter->Previous_Newsletters_Link($para['alias']);
		}
		if ($action == "show_newsletters") {
			$newsletter = $obj_newsletter->Show_Newsletter($para['alias'], $para['linked']);
		}

		if ($action == "admin_newsletter_placeholders") {
			$newsletter = require ($GLOBALS['abdj_file_admin_newsletter_placeholders']);
		} // if ($action == "admin_newsletter_placeholders")

		return $newsletter;
	} // function Newsletter()




	function Version($action) {
		//COMMENT_FUNCTION// //	print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action) <br>";
		if (!isset($action) OR empty($action)) {
			$version = require_once ($GLOBALS['abdj_file_admin_version']);
		}
		else {
			if (strtolower($action) == 'comparison') {
				$version = require_once ($GLOBALS['abdj_file_admin_version_comparison']);
			}
		}
		return $version;
	} // function Version()




	function Voting($action, $para) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action, \$para=$para) <br>";
		//var_dump($para);

		$voting = "";
		settype($para['alias'], "string");
		
		if (!isset($para['alias'])) {	$para['alias'] = '';	}
		if (!isset($para['cfg_voting'])) {	$para['cfg_voting'] = '';	}
		if (!isset($para['cfg_voting_lang_user'])) {	$para['cfg_voting_lang_user'] = '';	}
		$abdj_thiscfg_voting = $para['cfg_voting'];
		$abdj_thiscfg_voting_lang_user = $para['cfg_voting_lang_user'];
		
		// require Voting Class
		if (!class_exists("Abdj_Voting")) {	require ($GLOBALS['abdj_file_voting_class']);	}
		if (isset($para['alias']) AND !empty($para['alias'])) { require($GLOBALS['abdj_path_voting'].$para['alias'].".php"); }
		if ($action == "admin_show") { $abdj_thiscfg_voting['status_show'] = TRUE; }

		$abdj_thiscfg_voting['alias'] = $para['alias'];
		$obj_voting = new Abdj_Voting();
		$obj_voting->SetLanguage($GLOBALS['abdj_lang_voting']);
		$obj_voting->Set_Votes($abdj_thiscfg_voting, $abdj_thiscfg_voting_lang_user);

		if ($action == "admin_voting_editfiles") {
			$editor_files['this_files'] = $GLOBALS['abdj_obj_common']->CollectDirRecursivly($GLOBALS['abdj_path_voting_data'], '');
			$editor_files['this_files'] = $GLOBALS['abdj_obj_common']->CollectDirRemoveForbidden($editor_files['this_files'], "");
			if (empty ($editor_files['this_files'][0])) {
				$voting = "<fieldset class=\"abdjadminform\"><legend class=\"abdjadminform\">".$GLOBALS['abdj_lang']['admin_title_voting_editfiles']."</legend><div class=\"abdjadminform\">".$GLOBALS['abdj_lang_editor']['no_files_voting']."</div></fieldset>";
			} else {
				$voting = $this->Editor($editor_files);
			}
		} // if ($action == "admin_voting_editfiles")

		if ($action == "admin_voting_onoffreset") {	$voting = require_once ($GLOBALS['abdj_file_admin_voting_onoffreset']);	}

		if ($action == "admin_voting_showvotings") { $voting = require_once ($GLOBALS['abdj_file_admin_voting_showvotings']); }

		if ($action == "show" OR $action == "admin_show") {
			//if ($action == "admin_show") { $GLOBALS['abdj_admin_call'] = TRUE; }
			$voting = $obj_voting->Show();
		}
		if ($action == "vote") { $voting = $obj_voting->Kernel(''); }

		return $voting;
	} // function Voting()


} // class Addonsbydjot()

?>