<?php

function abdj_Counter_Summary() {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$pagename=$pagename) <br>";
	$obj_adbj = new Addonsbydjot();
	$summary = $obj_adbj->abdj_kernel('function', 'counter', 'show_summary', '');
	return $summary;
} // function abdj_Counter_Summary()

function abdj_Counter_CountPage($pagename) {
	global $su;
	if (empty($pagename)) { $pagename = $su; }
	$kernel_para['pagename'] = $pagename;
	$obj_adbj = new Addonsbydjot();
	$count = $obj_adbj->abdj_kernel('function', 'counter', 'count_page', $kernel_para);
	return $count;
} // abdj_Counter_CountPage()

function abdj_Counter_PageViews($pagename, $mode) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$pagename=$pagename) <br>";
	global $su;
	if (empty($pagename)) { $pagename = $su; }
	$kernel_para['pagename'] = $pagename;
	$kernel_para['mode'] = $mode;
	$obj_adbj = new Addonsbydjot();
	$count = $obj_adbj->abdj_kernel('function', 'counter', 'page_views', $kernel_para);
	$count = abdj_Counter_Tag_Title($count);
	return $count;
} // function abdj_Counter_PageViews()

// Same as abdj_Counter_PageViews(), but with text. 
function abdj_Counter_PageViews_Text($pagename='', $mode='') {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$pagename=$pagename) <br>";
	global $su;
	if (empty($pagename)) { $pagename = $su; }
	$kernel_para['pagename'] = $pagename;
	$kernel_para['mode'] = $mode;
	$obj_adbj = new Addonsbydjot();
	$count = $obj_adbj->abdj_kernel('function', 'counter', 'page_views', $kernel_para);
	$count = str_replace("{{COUNT}}", $count, $GLOBALS['abdj_lang_counter']['pv']);
	$count = abdj_Counter_Tag_Title($count);
	return $count;
} // function abdj_Counter_PageViews_Text()

// Same as abdj_Counter_PageViews_Text(), but with your own text. 
function abdj_Counter_PageViews_UserText($pagename, $mode, $text) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$pagename=$pagename, \$mode=$mode, \$text=$text) <br>";
	global $su;
	if (empty($pagename)) { $pagename = $su; }
	$kernel_para['pagename'] = $pagename;
	$kernel_para['mode'] = $mode;
	$obj_adbj = new Addonsbydjot();
	$count = $obj_adbj->abdj_kernel('function', 'counter', 'page_views', $kernel_para);
	if (empty ($text)) {
		$text = $GLOBALS['abdj_lang_counter']['pv'];
	}
	$count = str_replace("{{COUNT}}", $count, $text);
	$count = abdj_Counter_Tag_Title($count);
	return $count;
} // function abdj_Counter_PageViews_UserText()

// Add title tag 
function abdj_Counter_Tag_Title($text) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$text=$text) <br>";
	if ($GLOBALS['abdj_config']['version'] == 'basic' OR $GLOBALS['abdj_config']['feature_script_ad'] == TRUE) {
		$text = '<span title="'.$GLOBALS['abdj_config']['addonsbydjot_by_jn'].' - '.$GLOBALS['abdj_config']['addonsbydjot_url_website'].'">'.$text.'</span>';
	}
	return $text;
} // function abdj_Counter_Tag_Title() {



/* abdj_Guestbook - START //COMMENT_VERSION_ADVANCED// */
// This shows the form of Guestbook, if config variable $GLOBALS['abdj_config_guestbook']['feature_first_show_entries'] is set to FALSE;
// If $GLOBALS['abdj_config_guestbook']['feature_first_show_entries'] is set to TRUE
// or the GET variable is set, Guestbook Entries are shown instead of Guestbook form.
function abdj_Guestbook($caller='') {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";
	$kernel_para = ARRAY();
	
	if (!empty($caller)) { $kernel_para['caller'] = $caller; }
	else { $kernel_para['caller'] = 'user_guestbookform'; }
	
	$obj_adbj = new Addonsbydjot();
	if (isset($_GET['abdj_get_guestbook_show_entries'])) {
		$guestbook = abdj_Guestbook_Show_Entries();
	}
	else {
		$guestbook = $obj_adbj->abdj_kernel('function', 'guestbook', 'public_guestbookform', $kernel_para);
	}
	
	return $guestbook;

} // function abdj_Guestbook()


// This shows Guestbook Entries.
function abdj_Guestbook_Show_Entries() {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";
	$kernel_para = '';
	$obj_adbj = new Addonsbydjot();
	$guestbook = $obj_adbj->abdj_kernel('function', 'guestbook', 'public_show_entries', $kernel_para);
	return $guestbook;

} // function abdj_Guestbook()

/* END //COMMENT_VERSION_ADVANCED// abdj_Guestbook */









/* abdj_Mailform - START //COMMENT_VERSION_ADVANCED// */
function abdj_Mailform() {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";
	$obj_adbj = new Addonsbydjot();
	$mailform = $obj_adbj->abdj_kernel('function', 'mailform', 'public', '');
	return $mailform;
} // function abdj_Mailform()
/* END //COMMENT_VERSION_ADVANCED// abdj_Mailform */

function abdj_Newsletter_Subscribe($alias) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias) <br>";

	//$GLOBALS['abdjf_addon'] = "newsletter";
	//include ($GLOBALS['abdj_config']['2lang_current_root'].$GLOBALS['abdj_filename_addonsbydjot']);
	//$newsletter = $GLOBALS['abdj_obj_newsletter']->Subscribe($alias, 'subscribe');

	$kernel_para['alias'] = $alias;
	$obj_adbj = new Addonsbydjot();
	$newsletter = $obj_adbj->abdj_kernel('function', 'newsletter', 'subscribe', $kernel_para);
	return $newsletter;
} // function abdj_Newsletter_Subscribe()

function abdj_Newsletter_Unsubscribe($alias) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias) <br>";
	$kernel_para['alias'] = $alias;
	$obj_adbj = new Addonsbydjot();
	$newsletter = $obj_adbj->abdj_kernel('function', 'newsletter', 'unsubscribe', $kernel_para);
	return $newsletter;
} // function abdj_Newsletter_Subscribe()

function abdj_Newsletter_PreviousNewslettersLink($alias='', $linked=FALSE) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias) <br>";
	if ($_GET['abdj_get_showpreviousnewsletters'] == FALSE) {
		$kernel_para['alias'] = $alias;
		$obj_adbj = new Addonsbydjot();
		$newsletter = $obj_adbj->abdj_kernel('function', 'newsletter', 'previous_newsletters_link', $kernel_para);
	} else {
		$newsletter = abdj_Newsletter_PreviousNewsletters($_GET['abdj_get_alias'], $linked);
	}
	return $newsletter;
} // function abdj_Newsletter_PreviousNewslettersLink()

function abdj_Newsletter_PreviousNewsletters($alias, $linked) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias) <br>";
	$kernel_para['alias'] = $alias;
	$kernel_para['linked'] = $linked;
	$obj_adbj = new Addonsbydjot();
	$newsletter = $obj_adbj->abdj_kernel('function', 'newsletter', 'show_newsletters', $kernel_para);
	return $newsletter;
} // function abdj_Newsletter_PreviousNewsletters()

//Just show previous votings.
function abdj_Voting_Results($alias) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias) <br>";
	//$GLOBALS['abdjf_addon'] = "voting";
	$kernel_para['alias'] = $alias;
	$obj_adbj = new Addonsbydjot();
	$voting = $obj_adbj->abdj_kernel('function', 'voting', 'show', $kernel_para);
	return $voting;
} // function abdj_Voting_Results()

/*
Do votings.
*/
function abdj_Voting_Vote($alias) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias) <br>";
	$kernel_para['alias'] = $alias;
	$obj_adbj = new Addonsbydjot();
	$voting = $obj_adbj->abdj_kernel('function', 'voting', 'vote', $kernel_para);
	return $voting;
} // function abdj_Voting_Vote()


function abdj_License() {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($window, $link, $to_cmsimple) <br>";
	$kernel_para=ARRAY();
	$obj_adbj = new Addonsbydjot();
	$license = $obj_adbj->abdj_kernel('function', 'license', '', $kernel_para);
	return $license;
} // function abdj_License()



function abdj_VersionComparison() {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($window, $link, $to_cmsimple) <br>";
	$kernel_para=ARRAY();
	$obj_adbj = new Addonsbydjot();
	$version = $obj_adbj->abdj_kernel('function', 'version', 'comparison', $kernel_para);
	return $version;
} // function abdj_VersionComparison()

function abdj_Head($meta='') {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($window, $link, $to_cmsimple) <br>";
	if (!isset($hjs)) { $hjs=''; }
	global $hjs;
	$hjs .= $meta;
	return $meta;
} // function abdj_Head()

function abdj_CSS($mode, $code='') {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$mode=$mode, \$code=$code) <br>";

	if (!isset($hjs)) { $hjs=''; }
	global $hjs;
	$css='';
	$mode=strtoupper($mode);
	if ($mode == 'FILE') {
		$css = '<style type="text/css">'."\n".'@import "'.$code.'";'."\n".'</style>'."\n";
		$hjs .= $css;
	}
	if ($mode == 'STYLESHEET') {
		$css = '<style type="text/css">'."\n".$code."\n".'</style>'."\n";
		$hjs .= $css;
	}
	return $css;
} // function abdj_CSS()

function abdj_ErrorRequire($file='') {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$file=$file) <br>";
	if (empty($file)) { print '<hr>'; $backtrace = debug_backtrace(); var_dump($backtrace); die('<hr>Required file (filename) is empty!<hr>'); }
	else { if (!@file_exists($file)) { print '<hr>'; $backtrace = debug_backtrace(); var_dump($backtrace); die('<hr>Required file ('.$file.') does not exist!<hr>'); } }
}	// function abdj_ErrorRequire()

function abdj_ExistsPage($pagename='', $language='') {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$pagename=$pagename, \$language=$language) <br>";

	//global $c, $cf, $h, $l, $tx;
	global $c, $cf, $tx;

	$empty = 0;
	$exists = FALSE;

	if ((!empty ($language)) AND ($language != $cf['language']['default'])) {
		$file = "./".$language."/".$GLOBALS['abdj_dir_cmsimple_content'].$GLOBALS['abdj_filename_cmsimple_content'];
		$c = explode('', preg_replace("/(<h[1-3][^>]*>)/i", "\\1", str_replace('', '&#167;', rf("./".$language."/".$GLOBALS['abdj_dir_cmsimple_content'].$GLOBALS['abdj_filename_cmsimple_content']))));
	}

	for ($i = 0; $i < count($c); $i ++) {
		if (!isset($c[$i])) { $heading[$i]=''; }
		else { $heading[$i] = h($i); }
		$level[$i] = l($i);
		if ($heading[$i] == '') {
			if ($i==0) { $heading[$i]=uenc($GLOBALS['abdj_config_counter']['home_name']); }
			else { $heading[$i] = $tx['toc']['empty'].' '.$empty ++; }
			$heading[$i] = $tx['toc']['empty'].' '.$empty ++;
			$uri[$i] = $heading[$i];
		}
		if ($level[$i] == 1) {
			$l1 = uenc($heading[$i]);
			$uri[$i] = $l1;
		}
		if ($level[$i] == 2) {
			$l2 = uenc($heading[$i]);
			$uri[$i] = $l1.$cf['uri']['seperator'].$l2;
		}
		if ($level[$i] == 3) {
			$uri[$i] = $l1.$cf['uri']['seperator'].$l2.$cf['uri']['seperator'].uenc($heading[$i]);
		}

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$uri[$i]=".$uri[$i]." <br>";

		if (($pagename == $uri[$i]) OR (in_array($pagename, $GLOBALS['abdj_cmsimple_functions_uris']))) {
			$exists = TRUE;
			break;
		}
	}
	//$hl = count($hc);

	//if ($exists == TRUE) print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": page $pagename exists. <br>";
	//else print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": page $pagename does not exist! <br>";

	return $exists;
} // function abdj_ExistsPage()


/*
This function creates the JavaScipt code for a popup window
and a text link for the popup.
It returns the Javascript code for the popup window and the link code.

Arguments:
1: $window (ARRAY) - definitions for the popup window
2: $link (ARRAY) - defining the link text and it's appearance
3: $to_cmsimple (BOOLEAN) - add Javascript code to CMSimple

Indexes for $link:
link_text (STRING) - this text is shown as link text
css_class
css_id

Indexes for $window:
title (STRING) - title/name of window (Do not use spaces inside names!)
url (STRING) - file that is loaded by the popup window (http://www.domain.com/file.htm)
width (pixel) - width of window in pixels
height (pixel) - height of window in pixels
left (pixel) - left margin in pixels
top (pixel) - top margin in pixels
scrollbars (yes/no) - show or do not to show scrollbars
toolbar (yes/no) - show or do not to show scrollbars
status (yes/no) - show or do not to show scrollbars
menubar (yes/no) - show or do not to show the menubar
dependent (yes/no) - close or not to close the popup when the parent (originating) window is closed
hotkeys (yes/no) - enable or disable the use of hotkeys
innerHeight (pixel) - inner display area height
innerWidth (pixel) - inner display area width
location (yes/no) - show or do not to show the address bar
resizable (yes/no) - allow or not allow to resize the window
screenX (pixel) - left margin in pixels
screenY (pixel) - top margin in pixels

*/
function abdj_JsPopupWindow($window, $link, $to_cmsimple) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($window, $link, $to_cmsimple) <br>";
	$js_popup['js'] = "\n<script language=\"JavaScript\">\n<!--\nfunction abdjJsPopupWindow(url,title,options) {\nwindow.open(url,title,options);\n}\n-->\n</script>\n";
	$js_popup['link'] = "<a class=\"".$link['css_class']."\" id=\"".$link['css_id']."\" href=\"javascript:;\" onClick=\"abdjJsPopupWindow('".$window['url']."','".$window['title']."','width=".$window['width'].",height=".$window['height'].",left=".$window['left'].",top=".$window['top'].",scrollbars=".$window['scrollbars'].",toolbar=".$window['toolbar'].",menubar=".$window['menubar'].",status=".$window['status'].",dependent=".$window['dependent']."hotkeys=".$window['hotkeys'].",innerHeight=".$window['innerHeight'].",innerWidth=".$window['innerWidth'].",location=".$window['location'].",resizable=".$window['resizable'].",screenX=".$window['screenX'].",screenY=".$window['screenY']."')\">".$link['link_text']."</a>";
	if ($to_cmsimple == TRUE) {
		global $hjs;
		$hjs .= $js_popup['js'];
	}
	return $js_popup;
} // function abdj_JsPopupWindow()

/*
This function creates a JavaScript link, that may be used for closing popup windows.
It returns a link where the link text and stylesheet (class/id) my be attached to.

Arguments:
1: $link_text (STRING) - this text is shown as link text (if left empty, default will be used)
2: $css_class (STRING) - name of CSS class (or leave empty)
3: $css_id (STRING) - name of CSS id (or leave empty) 
*/
function abdj_JsCloseWindow($link_text, $css_class, $css_id) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$link_text=$link_text, \$css_class=$css_class, \$css_id=$css_id) <br>";
	//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$GLOBALS['abdj_lang_common']['close_window']=".$GLOBALS['abdj_lang_common']['close_window'].") <br>";
	if (empty ($link_text)) {
		$link_text = $GLOBALS['abdj_lang_common']['close_window'];
	}
	$js_close = "<a onclick=\"window.close();\" class=".$css_class." id=".$css_id." href=\"\">".$link_text."</a>";
	return $js_close;
} // function abdj_JsCloseWindow()


/*
This function generates a random ID (token).
If $length is given, the 32 character long token is cut down to the given length of characters.
*/
function abdj_GenerateToken($length=0) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": <br>";

	$token_random_data = md5(microtime()).uniqid(rand());
	$token = md5($token_random_data);
	if ($length > 0) { $token = substr($token, 0, $length);	}
	//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$token=".$token."<br>";

	return $token;
} // function abdj_GenerateToken()


/*
This function generates a random ID (token).
*/
function abdj_SpamProtection($text) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": <br>";

	$is_spam = FALSE;
	
		
	// Too many URLs?
	if ($GLOBALS['abdj_config']['feature_spam_urls'] == TRUE) {
			$urls_array = split(",", $GLOBALS['abdj_config']['spam_urls']);
			foreach ($urls_array AS $url) {
				$url = trim($url);
				$count_urls = substr_count($text, $url);
				if ($count_urls >= $GLOBALS['abdj_config']['spam_urls_count']) {
					$is_spam = TRUE;
					break;
				}
			} // foreach
	} // if ($GLOBALS['abdj_config_guestbook']['feature_spam_urls'] == TRUE)

	// badwords?
	if ($is_spam == FALSE) {
		if ($GLOBALS['abdj_config']['feature_spam_badwords'] == TRUE) {
			$badwords_array = split(",", $GLOBALS['abdj_config']['spam_badwords']);
			foreach ($badwords_array AS $badword) {
				$badword = trim($badword);
				$count_badwords = substr_count($text, $badword);
				if ($count_badwords >= 1) {
					$is_spam = TRUE;
					break;
				}
			} // foreach
		} // if ($GLOBALS['abdj_config']['feature_spam_badwords'] == TRUE)
	}
	
	// known spam IP?
	if ($is_spam == FALSE) {
		if ($GLOBALS['abdj_config']['feature_spam_ips'] == TRUE) {
			$ips_array = split(",", $GLOBALS['abdj_config']['spam_ips']);
			foreach ($ips_array AS $key => $value) {
				$ips_array[$key] = trim($value);
			}
			if (in_array(getenv("REMOTE_ADDR"), $ips_array)) {
				$is_spam = TRUE;
			}
		} // if ($GLOBALS['abdj_config']['feature_spam_ips'] == TRUE) {
	} // if ($is_spam == FALSE)


	// Too many breaks?
	if ($is_spam == FALSE) {
		if ($GLOBALS['abdj_config']['feature_spam_breaks'] == TRUE) {
			$spam_message = $text;
			$spam_message = str_replace("<br>", "\n", $spam_message);
			$spam_message = str_replace("\r\n", "\n", $spam_message);
			$str_count_n='';
			for ($i=1; $i<=$GLOBALS['abdj_config']['spam_breaks_count']; $i++) {
				$str_count_n .= "\n";
			}
			$count_n = substr_count($spam_message, $str_count_n);
			
			if ($count_n >= 1) {
				$is_spam = TRUE;
			} 
		} // if ($GLOBALS['abdj_config']['feature_spam_breaks'] == TRUE)
	} // if ($is_spam == FALSE)

	
	return $is_spam;

} // function abdj_SpamProtection()


function abdj_CMSimple_rfc($mode, $language = "", $show_hidden = FALSE) {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$mode=$mode, \$language=$language, \$show_hidden=$show_hidden) <br>";

	//global $c, $cf, $h, $l, $tx;
	global $c, $cf, $tx;

	$empty = 0;
	$heading = ARRAY ();
	$headings = ARRAY ();
	$level = ARRAY ();
	$uris = ARRAY ();

	if (!empty ($language) AND $language != $cf['language']['default']) {

		$file = "./".$language."/".$GLOBALS['abdj_dir_cmsimple_content'].$GLOBALS['abdj_filename_cmsimple_content'];
		$content = $GLOBALS['abdj_obj_common']->Read_File("STRING", TRUE, $file);
		$c = explode('', preg_replace("/(<h[1-3][^>]*>)/i", "\\1", str_replace('', '&#167;', $content)));
	}

	//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": var_dump() <br>";
	//var_dump($c); print '<hr>';

	$toc = $c;

	if ($show_hidden == FALSE) {
		// exclude hidden pages
		for ($i = 0; $i < count($toc); $i ++) {
			if (preg_match("/\#CMSimple hide\#/is", $toc[$i]))
				unset ($toc[$i]);
		}
	}

	//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": count(\$toc) = ".count($toc)." <br>";

	for ($i = 0; $i < count($toc)-1; $i ++) {

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": var_dump() <br>";
		//var_dump($i); print '<br>';
		if (!isset($c[$i])) { $heading[$i]=''; }
		else { $heading[$i] = h($i); }
		$level[$i] = l($i);

		//if ($i<2) { print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$heading[$i]=".$heading[$i]." - \$level[$i]=".$level[$i]." <br>"; }

		if ($heading[$i] == '') {
			if ($i==0) { $heading[$i]=uenc($GLOBALS['abdj_config_counter']['home_name']); }
			else { $heading[$i] = $tx['toc']['empty'].' '.$empty ++; }
			$uris[$i] = $heading[$i];
			$headings[$i] = $heading[$i];
		}
		if ($level[$i] == 1) {
			
			$heading1 = $heading[$i];
			$headings[$i] = $heading1;
			$uri1 = uenc($heading[$i]);
			$uris[$i] = $uri1;
		}
		if ($level[$i] == 2) {
			$heading2 = $heading[$i];
			$headings[$i] = $heading1.$cf['uri']['seperator'].$heading2;
			$uri2 = uenc($heading[$i]);
			$uris[$i] = $uri1.$cf['uri']['seperator'].$uri2;
		}
		if ($level[$i] == 3) {
			$heading3 = $heading[$i];
			$headings[$i] = $heading1.$cf['uri']['seperator'].$heading2.$cf['uri']['seperator'].$heading3;
			$uri3 = uenc($heading[$i]);
			$uris[$i] = $uri1.$cf['uri']['seperator'].$uri2.$cf['uri']['seperator'].$uri3;
		}

        //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$headings[$i]=".$headings[$i]." <br>";
		$index_last = $i;
	}

	$headings = array_merge($headings, $GLOBALS['abdj_cmsimple_functions_headings']);
	$uris = array_merge($uris, $GLOBALS['abdj_cmsimple_functions_uris']);

	if ($mode == "heading") {
		return $headings;
	} else {
		return $uris;
	}

} // function abdj_CMSimple_rfc()




function abdj_XHTML_endtags($output='') {
	//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$mode=$mode, \$language=$language, \$show_hidden=$show_hidden) <br>";

	if ($GLOBALS['abdj_config']['feature_xhtml_endtags'] == TRUE) {
		//$output = eregi_replace('(<br[^>]*)'.$GLOBALS['abdj_config']['feature_xhtml_endtag'].$GLOBALS['abdj_config']['feature_xhtml_endtag'].'>', '\\1'.$GLOBALS['abdj_config']['feature_xhtml_endtag'].'>', $output);

		$endtag_trimmed = trim($GLOBALS['abdj_config']['feature_xhtml_endtag']);
		
		$output = eregi_replace('(<meta[^>]?[ ]*)'.$endtag_trimmed.'>', '\\1>', $output);
		$output = eregi_replace('(<link[^>]?[ ]*)'.$endtag_trimmed.'>', '\\1>', $output);
		$output = eregi_replace('(<br[^>]?[ ]*)'.$endtag_trimmed.'>', '\\1>', $output);
		$output = eregi_replace('(<hr[^>]?[ ]*)'.$endtag_trimmed.'>', '\\1>', $output);
		$output = eregi_replace('(<input[^>]?[ ]*)'.$endtag_trimmed.'>', '\\1>', $output);

		$output = eregi_replace('(<meta[^>]*)>', '\\1'.$GLOBALS['abdj_config']['feature_xhtml_endtag'].'>', $output);
		$output = eregi_replace('(<link[^>]*)>', '\\1'.$GLOBALS['abdj_config']['feature_xhtml_endtag'].'>', $output);
		$output = eregi_replace('(<br[^>]*)>', '\\1'.$GLOBALS['abdj_config']['feature_xhtml_endtag'].'>', $output);
		$output = eregi_replace('(<hr[^>]*)>', '\\1'.$GLOBALS['abdj_config']['feature_xhtml_endtag'].'>', $output);
		$output = eregi_replace('(<input[^>]*)>', '\\1'.$GLOBALS['abdj_config']['feature_xhtml_endtag'].'>', $output);
	}
	return $output;
} // function abdj_XHTML_endtags()

?>