<?php

class Abdj_Mailform {

	function Abdj_Mailform() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";
	} // Abdj_Mailform()

	function Mailform() {

		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$error_msg='';
		$abdj_mailform='';

		if (isset ($_POST['abdj_mf'])) { $mailform = $_POST['abdj_mf']; }
		else { $mailform = ARRAY (); }

		$mailform_keys = ARRAY ('email', 'fax', 'message', 'name', 'firstname', 'subject', 'submit', 'telephone');

		if ($GLOBALS['abdj_config_mailform']['feature_captcha'] == TRUE) { array_push($mailform_keys, 'captcha', 'captcha_md5'); }			

		foreach ($mailform_keys AS $key) {
			if (isset ($mailform[$key])) { $mailform[$key] = trim($mailform[$key]); }
			else { $mailform[$key] = ''; }
		}

		// If mailform is submitted, check values entered by user
		if (!empty ($mailform['submit'])) {
			$showform = FALSE;

			if (($GLOBALS['abdj_config_mailform']['field_show_name'] == TRUE) AND ($GLOBALS['abdj_config_mailform']['field_mandatory_name'] == TRUE) AND (empty ($mailform['name']))) {
				$showform = TRUE;
				$error_msg .= '<dt class="abdjmfdterrormsg">'.$GLOBALS['abdj_lang']['g_field_name'].':</dt><dd class="abdjmfdderrormsg">'.$GLOBALS['abdj_lang']['g_error_empty_name'].'</dd>';
			}

			if ($GLOBALS['abdj_config_mailform']['field_show_email'] == TRUE) {
				if (($GLOBALS['abdj_config_mailform']['field_mandatory_email'] == TRUE) AND (empty ($mailform['email']))) {
					$showform = TRUE;
					$error_msg .= '<dt class="abdjmfdterrormsg">'.$GLOBALS['abdj_lang']['g_field_email'].':</dt><dd class="abdjmfdderrormsg">'.$GLOBALS['abdj_lang']['g_error_empty_email'].'</dd>';
				} else {
					$regex = '^([._a-z0-9-]+[._a-z0-9-]*)@(([a-z0-9-]+\.)*([a-z0-9-]+)(\.[a-z]{2,4}))$';
					if (!eregi($regex, $mailform['email'])) {
						$showform = TRUE;
						$error_msg .= '<dt class="abdjmfdterrormsg">'.$GLOBALS['abdj_lang']['g_field_email'].':</dt><dd class="abdjmfdderrormsg">'.$GLOBALS['abdj_lang']['g_error_format_email'].'</dd>';
					}
				}
			}


			if ($GLOBALS['abdj_config_mailform']['feature_captcha'] == TRUE) {
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": ".$mailform['captcha'].", ".$mailform['captcha_md5']." <br>";
				if (!isset($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_code'])) { $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_code']=''; }
				if (empty($mailform['captcha']) OR $mailform['captcha'] != $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_code']) {			
					$showform = TRUE;
					$error_msg .= '<dt class="abdjmfdterrormsg">'.$GLOBALS['abdj_lang']['g_field_captcha'].':</dt><dd class="abdjmfdderrormsg">'.$GLOBALS['abdj_lang']['g_error_captcha'].'</dd>';
				}
			}

			if (($GLOBALS['abdj_config_mailform']['field_show_message'] == TRUE) AND ($GLOBALS['abdj_config_mailform']['field_mandatory_message'] == TRUE) AND (empty ($mailform['message']))) {
				$showform = TRUE;
				$error_msg .= '<dt class="abdjmfdterrormsg">'.$GLOBALS['abdj_lang']['g_field_message'].':</dt><dd class="abdjmfdderrormsg">'.$GLOBALS['abdj_lang']['g_error_empty_message'].'</dd>';
			}
			
		} // if (!empty ($mailform['submit']))




		// If mailform is not submitted or entered values were incorrect, show form
		if ((empty ($mailform['submit'])) OR ($showform == TRUE)) {
			
			$mandatory_keys = ARRAY ("title", "name", "firstname", "telephone", "fax", "email", "subject", "message");
			
			if ($GLOBALS['abdj_config_mailform']['feature_captcha'] == TRUE) {
				array_push($mandatory_keys, 'captcha');
				$GLOBALS['abdj_config_mailform']['field_mandatory_captcha'] = TRUE;
			}			

			foreach ($mandatory_keys AS $key) {
				if ($GLOBALS['abdj_config_mailform']['field_mandatory_'.$key] == TRUE) {
					$GLOBALS['abdj_lang']['g_field_'.$key] = $GLOBALS['abdj_lang']['g_field_'.$key].'<div class="abdjmfmandatorysign">'.$GLOBALS['abdj_lang']['g_fieldtext_mandatory_sign'].'</div>';
				}
			} // foreach

			if (!empty ($GLOBALS['abdj_lang_mailform']['form_text_hint'])) {
				$abdj_mailform .= '<div class="abdjmfhint">'.$GLOBALS['abdj_lang_mailform']['form_text_hint'].'</div>';
			}


			$abdj_mailform .= '<div class="abdjmfdiv">';
			$abdj_mailform .= '<form class="abdjmfform" action="" method="post">';
			$abdj_mailform .= '<table class="abdjmftable" cellspacing="0" cellpadding="0" border="0">';

			if (!empty ($error_msg)) {
				$abdj_mailform .= '<tr><td class="abdjmftderrormsg" colspan="2"><dl compact><dt class="abdjmfdterrormsg">'.$GLOBALS['abdj_lang']['g_error_hint'].'</dt><dd class="abdjmfdderrormsg">&nbsp;</dd>'.$error_msg.'</dl></td></tr>';
			}

			if ($GLOBALS['abdj_config_mailform']['field_show_mandatory'] == TRUE) {
				$abdj_mailform .= '<tr><td class="abdjmftdmandatory" colspan="2"><div class="abdjmfmandatory">'.$GLOBALS['abdj_lang']['g_fieldtext_mandatory'].'</div><div class="abdjmfmandatorysign">'.$GLOBALS['abdj_lang']['g_fieldtext_mandatory_sign'].'</div></td></tr>';
			}
			

			if ($GLOBALS['abdj_config_mailform']['field_show_name'] == TRUE) {
				$abdj_mailform .= '<tr><td class="abdjmftdfieldname"><div class="abdjmffieldname">'.$GLOBALS['abdj_lang']['g_field_name'].'</div></td><td class="abdjmftdinputname"><input class="abdjmfinputname" type="text" name="abdj_mf[name]" value="'.$mailform['name'].'" alt="name" maxlength="80"></td></tr>';
			}

			if ($GLOBALS['abdj_config_mailform']['field_show_email'] == TRUE) {
				$abdj_mailform .= '<tr><td class="abdjmftdfieldemail"><div class="abdjmffieldemail">'.$GLOBALS['abdj_lang']['g_field_email'].'</div></td><td class="abdjmftdinputemail"><input class="abdjmfinputemail" type="text" name="abdj_mf[email]" value="'.$mailform['email'].'" alt="email" maxlength="80"></td></tr>';
			}

			if ($GLOBALS['abdj_config_mailform']['feature_captcha'] == TRUE) {			
				if (!isset($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_code'])) { $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_code']=''; }
				if (empty($mailform['captcha']) OR (!empty($mailform['captcha']) AND $mailform['captcha'] != $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_captcha_code'])) {
					require_once($GLOBALS['abdj_file_common_captcha']);				
					$lucky_bgcolor='';
					$lucky_fontcolor='';
					$obj_captcha = new MyCaptcha();
					$obj_captcha->SetImageSize($GLOBALS['abdj_config_mailform']['captcha_width'], $GLOBALS['abdj_config_mailform']['captcha_height']);
					$obj_captcha->CreateImage();
					//$lucky_color = $obj_captcha->GetRandomColor();
					$captcha_code = $obj_captcha->GetRandomCode($GLOBALS['abdj_config_mailform']['captcha_chars'], $GLOBALS['abdj_config_mailform']['captcha_amount']);
					
					if (strtoupper($GLOBALS['abdj_config_mailform']['captcha_background_mode']) == 'SINGLE') {
						$lucky_bgcolor = $GLOBALS['abdj_config_mailform']['captcha_background_color'];
						$lucky_fontcolor = $GLOBALS['abdj_config_mailform']['captcha_font_color'];
					}
					else {
						$obj_captcha->SetRandomColors($GLOBALS['abdj_config_mailform']['captcha_background_colors']);
						$lucky_bgcolor = $obj_captcha->GetRandomColor();
						$lucky_fontcolor = $obj_captcha->GetRandomColor($lucky_bgcolor);
					}


//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": var_dump() <br>";
//var_dump($captcha_code); print '<br>';
//var_dump($lucky_bgcolor); print '<br>';
//var_dump($lucky_fontcolor); print '<br>';

					if (strtoupper($GLOBALS['abdj_config_mailform']['captcha_background_mode']) == 'SINGLE' OR strtoupper($GLOBALS['abdj_config_mailform']['captcha_background_mode']) == 'RANDOMSINGLE') {
						$obj_captcha->FillBackground(0, 0, $lucky_bgcolor);
						$obj_captcha->AddText($GLOBALS['abdj_config_mailform']['captcha_fontsize'], $GLOBALS['abdj_config_mailform']['captcha_font_angle'], $GLOBALS['abdj_config_mailform']['captcha_font_position_x'], $GLOBALS['abdj_config_mailform']['captcha_font_position_y'], $lucky_fontcolor, $GLOBALS['abdj_path_common_data'].$GLOBALS['abdj_config_mailform']['captcha_fontfamily'], $captcha_code);
					}
					if (strtoupper($GLOBALS['abdj_config_mailform']['captcha_background_mode']) == 'RANDOM') {
						$obj_captcha->FillRandomBackground(10, 0);
						$obj_captcha->AddRandompositionText($GLOBALS['abdj_config_mailform']['captcha_fontsize'], $GLOBALS['abdj_config_mailform']['captcha_font_angle'], $lucky_fontcolor, $GLOBALS['abdj_path_common_data'].$GLOBALS['abdj_config_mailform']['captcha_fontfamily'], $captcha_code);	
					}
					
					$obj_captcha->ShowCaptcha();
				}
				else { $captcha_code = $mailform['captcha']; }

				$abdj_mailform .= '<tr><td class="abdjmftdfieldcode"><div class="abdjmffieldcode">'.$GLOBALS['abdj_lang']['g_field_captcha'].'</div></td><td class="abdjmftdinputcode"><div class="abdjmfdivinputcode"><input class="abdjmfinputcode" type="text" name="abdj_mf[captcha]" value="'.$mailform['captcha'].'" alt="captcha_code" maxlength="80"></div>';
				$abdj_mailform .= '<div class="abdjmfdivcodeimg"><img class="abdjmfcodeimg" src="'.$GLOBALS['abdj_url_captcha_show'].'" alt="captcha_code"></div>';
				$abdj_mailform .= '<div class="abdjmfdivcodehint">'.$GLOBALS['abdj_lang']['g_field_captcha_hint'].'</div>';
				$abdj_mailform .= '</td></tr>';

			} // if ($GLOBALS['abdj_config_mailform']['feature_captcha'] == TRUE) {			


			if ($GLOBALS['abdj_config_mailform']['field_show_message'] == TRUE) {
				$abdj_mailform .= '<tr><td class="abdjmftdfieldmsg" colspan="2"><div class="abdjmffieldmsg">'.$GLOBALS['abdj_lang']['g_field_message'].'</div></td></tr>';
				$abdj_mailform .= '<tr><td class="abdjmftdinputmsg" colspan="2"><textarea class="abdjmfinputmsg" name="abdj_mf[message]" rows="0" cols="0">'.$mailform['message'].'</textarea><p class="abdjvcba23mailform" style="display:inline;"></p></td></tr>';
			}


			$div_copyright='';
			/* Script.Copyright - START //COMMENT_VERSION_BASIC// */
			if (($GLOBALS['abdj_config']['version'] == 'basic') OR ($GLOBALS['abdj_config']['feature_script_ad'] == TRUE)) {
				$div_copyright = '<div class="abdjmfdivcopyright">'.$GLOBALS['abdj_url_copyright_dark'].'</div>';
			}
			/* END //COMMENT_VERSION_BASIC// Script.Copyright */
			$abdj_mailform .= '<tr><td class="abdjmftdsubmit" colspan="2">'.$div_copyright.'<div class="abdjmfdivreset"><input class="abdjmfreset" type="reset" value="'.$GLOBALS['abdj_lang']['g_action_reset'].'"></div><div class="abdjmfdivsubmit"><input class="abdjmfsubmit" type="submit" name="abdj_mf[submit]" value="'.$GLOBALS['abdj_lang']['g_action_send'].'"></div></td></tr>';


			$abdj_mailform .= '</table>';
			$abdj_mailform .= '</form>';
			$abdj_mailform .= '</div>';

		} // if ((empty ($mailform['submit'])) OR ($showform == TRUE))
		
		
		// If mailform was submitted and filled correctly, send formdata to admin
		if ((!empty ($mailform['submit'])) AND ($showform == FALSE)) {
			if ($GLOBALS['abdj_config_mailform']['feature_send'] == TRUE) {
				
				// --> Mail to admin
				$header_admin = "From: ".$mailform['email']."\n";
				$header_admin .= "X-Mailer: phpmail\n";
				$header_admin .= "Content-Type: text";

				// require mailform (admin) language
				$abdj_require = $GLOBALS['abdj_path_mailform'].$GLOBALS['abdj_dir_lang'].$GLOBALS['abdj_config']['language_admin'].'.php';
				abdj_ErrorRequire($abdj_require);			
				require($abdj_require);

				$mailform_message_admin = $this->Replace_Placeholders($GLOBALS['abdj_lang_mailform']['msg_admin'], $mailform);
				$email_recipient = $GLOBALS['abdj_config_mailform']['admin_email'];

				$GLOBALS['abdj_obj_common']->SimpleMailDebug($email_recipient, $GLOBALS['abdj_lang_mailform']['msg_admin_subject'], $mailform_message_admin, $header_admin);
				$GLOBALS['abdj_obj_common']->SimpleMail($email_recipient, $GLOBALS['abdj_lang_mailform']['msg_admin_subject'], $mailform_message_admin, $header_admin);
				// <-- Mail to admin
			} // if ($GLOBALS['abdj_config_mailform']['feature_send'] == TRUE)

			$abdj_mailform = $this->Replace_Placeholders($GLOBALS['abdj_lang_mailform']['msg_sent_hint'], $mailform);
		} // if ((!empty ($mailform['submit'])) AND ($showform == FALSE))

		return $abdj_mailform;
	} // function Mailform()

	function Replace_Placeholders($input, $mf) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$input=$input, \$mf=$mf) <br>";
		$output = $input;
		$output = str_replace("{{TITLE}}", $mf['title'], $output);
		$output = str_replace("{{NAME}}", $mf['name'], $output);
		$output = str_replace("{{FIRSTNAME}}", $mf['firstname'], $output);
		$output = str_replace("{{TELEPHONE}}", $mf['telephone'], $output);
		$output = str_replace("{{FAX}}", $mf['fax'], $output);
		$output = str_replace("{{EMAIL}}", $mf['email'], $output);
		$output = str_replace("{{SUBJECT}}", $mf['subject'], $output);
		$output = str_replace("{{MESSAGE}}", $mf['message'], $output);
		$output = str_replace("{{ADMINEMAIL}}", $GLOBALS['abdj_config_mailform']['admin_email'], $output);
		$output = str_replace("{{DATE}}", $GLOBALS['abdj_config']['date'], $output);
		$output = str_replace("{{TIME}}", $GLOBALS['abdj_config']['time'], $output);
		$output = str_replace("{{IP}}", getenv("REMOTE_ADDR"), $output);
		return $output;
	} // function Replace_Placeholders

} // class Abdj_Mailform

?>