<?php

class Abdj_Newsletter {

	function Abdj_Newsletter() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";
	} // function Abdj_Newsletter()

	function SetLanguage($language_array) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$language_array) <br>";
		$this->lang = $language_array;
	} // function SetLanguage()

	function SetParameter($parameter_array) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$parameter_array) <br>";

		foreach ($parameter_array AS $key => $value) {
			$this->parameter["$key"] = $value;
		}

	} // function SetParameter()

	function Format_Language($text, $replace) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$text=$text, \$replace=$replace) <br>";

		$isset_array=ARRAY('email','subject','subsdate','subsdatetime','subsemail','subsname','substoken');
		foreach ($isset_array AS $index) {
			if (!isset ($replace["$index"])) {
			$replace["$index"] = '';
			}
		}

		$text = eregi_replace("{{SUBSDATE}}", $replace['subsdate'], $text);
		$text = eregi_replace("{{SUBSDATETIME}}", $replace['subsdatetime'], $text);
		$text = eregi_replace("{{SUBSEMAIL}}", $replace['subsemail'], $text);
		$text = eregi_replace("{{SUBSNAME}}", $replace['subsname'], $text);

		$text = eregi_replace("{{SUBJECT}}", $replace['subject'], $text);
		$text = eregi_replace("{{SITENAME}}", $GLOBALS['abdj_config']['cmsimple_sitename'], $text);
		$text = eregi_replace("{{DOMAIN}}", $GLOBALS['abdj_config']['url_root'], $text);
		$text = eregi_replace("{{URLNEWSLETTER}}", $GLOBALS['abdj_config_newsletter']['url'], $text);
		$text = eregi_replace("{{EMAIL}}", $replace['email'], $text);
		$text = eregi_replace("{{DATE}}", $GLOBALS['abdj_config']['date'], $text);
		$text = eregi_replace("{{DATETIME}}", $GLOBALS['abdj_config']['datetime'], $text);
		return $text;
	} // function Format_Language()

	function Format_Error($error_msg) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$error_msg=$error_msg) <br>";

		if (is_array($error_msg)) {
			foreach ($error_msg AS $key => $value) {
				$error_msg[$key] = "<font class=\"abdjnewserror\">$value</font><br>";
			}
		} // if (is_array($error_msg))
		return $error_msg;
	} // function Format_Error()

	function Fill_Placeholders($data, $replace) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$replace_indexes = ARRAY ('subject', 'subsdate', 'subsdatetime', 'substoken', 'subsemail', 'subsname');
		foreach ($replace_indexes AS $index) {
			if (!isset ($replace[$index])) {
				$replace[$index] = '';
			}
		}

		if (is_array($data)) {
			foreach ($data AS $key => $value) {
				//echo "<font color=lime>$key => $value</font><br>";
				//$data[$key] = "<font color=lime>$value</font>";
				$data[$key] = str_replace("{{SUBSDATE}}", $replace['subsdate'], $data[$key]);
				$data[$key] = str_replace("{{SUBSDATETIME}}", $replace['subsdatetime'], $data[$key]);
				$data[$key] = str_replace("{{SUBSEMAIL}}", $replace['subsemail'], $data[$key]);
				$data[$key] = str_replace("{{SUBSNAME}}", $replace['subsname'], $data[$key]);
				
				$data[$key] = str_replace("{{SUBJECT}}", $replace['subject'], $data[$key]);
				$data[$key] = str_replace("{{SITENAME}}", $GLOBALS['abdj_config']['cmsimple_sitename'], $data[$key]);
				$data[$key] = str_replace("{{DOMAIN}}", $GLOBALS['abdj_config']['url_root'], $data[$key]);
				$data[$key] = str_replace("{{URLNEWSLETTER}}", $GLOBALS['abdj_config_newsletter']['url'], $data[$key]);
				$data[$key] = str_replace("{{EMAIL}}", $GLOBALS['abdj_config_newsletter']['admin_email'], $data[$key]);
				$data[$key] = str_replace("{{DATE}}", $GLOBALS['abdj_config']['date'], $data[$key]);
				$data[$key] = str_replace("{{DATETIME}}", $GLOBALS['abdj_config']['datetime'], $data[$key]);
				$data[$key] = str_replace("{{DATETIME}}", $GLOBALS['abdj_config']['datetime'], $data[$key]);
			}
		}

		return $data;

	} // function Fill_Placeholders($error_msg) {

	function Previous_Newsletters_Link($alias) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$error_msg=$error_msg) <br>";
		if ($GLOBALS['abdj_config_newsletter']['feature_link_previousnews'] == FALSE) {
			// Link to show previously sent newsletters is not shown
			$newsletter = FALSE;
		} else {

			/* Newsletter.Alias - START //COMMENT_VERSION_BASIC// */
			if ($GLOBALS['abdj_config']['version'] == 'basic') {
				$GLOBALS['news_alias'] = $GLOBALS['abdj_config_newsletter']['default_alias'];
			}
			/* END //COMMENT_VERSION_BASIC// Newsletter.Alias */

			global $sn, $su;
			$newsletter .= "<a href=\"".$sn."?".$su.amp()."abdj_get_showpreviousnewsletters=1".amp()."abdj_get_alias=".$GLOBALS['news_alias']."\">".$GLOBALS['abdj_lang_newsletter']['shownewsletter_link_previous']."</a>";
		}
		return $newsletter;
	} // function Previous_Newsletters_Link()

	function Subscribe_Form($mode, $subscribe, $error_msg) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$error_msg=$error_msg) <br>";

		$error_msg = $this->Fill_Placeholders($error_msg, $subscribe);
		$error_msg = $this->Format_Error($error_msg);
		$newsletter_copyright = '';
		$newsletter_copyright_subscribe = '';
		$newsletter_copyright_unsubscribe = '';

/* Script.Copyright - START //COMMENT_VERSION_BASIC// */

/* WARNING: Addonsbydjot - License
 * 
 * It is not allowed to remove the links from my Addonsbydjot-Script
 * unless you have a license for Addonsbydjot advanced.
 * (Owners of advanced license see Admin-Panel -> Addonsbydjot -> Settings for removing the link)!
 * 
 * It is hard work to program such a script. The script is free,
 * so it's not a tall order to leave the links intact.
 * 
 * If you illegaly remove the link,
 * I post your name, email and website on my website,
 * the CMSimple-Forum and other websites that are related to license violators.
 * Also I may contact your internet provider
 * and ask him to close your website using my script illegally.
 * 
 * I hope that has not to happen!
 *
 * WARNING: Addonsbydjot - License */

 		if (($GLOBALS['abdj_config']['version'] == 'basic') OR ($GLOBALS['abdj_config']['feature_script_ad'] == TRUE)) {
			$newsletter_copyright = $GLOBALS['abdj_url_copyright_dark'];
			if ($mode == "subscribe") {
				$newsletter_copyright_subscribe = "&nbsp;&nbsp;".$GLOBALS['abdj_url_copyright_dark'];
			}
			if ($mode == "unsubscribe") {
				$newsletter_copyright_unsubscribe = "&nbsp;&nbsp;&nbsp;&nbsp;".$GLOBALS['abdj_url_copyright_dark'];
			}
		}
/* END //COMMENT_VERSION_BASIC// Script.Copyright */



		$newsletter = '<br>';

		if ($mode == "subscribe") {
			$newsletter .= $GLOBALS['abdj_lang_newsletter']['subscribe_caption'];
		} else {
			$newsletter .= $GLOBALS['abdj_lang_newsletter']['unsubscribe_caption'];
		}


		$newsletter .= '<br><br><form METHOD="post" action="">';
		if (($mode == "subscribe") AND ($GLOBALS['abdj_config_newsletter']['feature_subscribername'] == TRUE)) {
			$newsletter .= '<font class="abdjnewsformfield">'.$GLOBALS['abdj_lang']['g_field_name'].'</font><br><input type="text" class="abdjnewsname" name="abdj_newsletter_name" maxlength="80" value="'.$subscribe['subsname'].'"><br>'.$error_msg['subsname'].'<br>';
		}
		$newsletter .= '<font class="abdjnewsformfield">'.$GLOBALS['abdj_lang']['g_field_email'].$newsletter_copyright_unsubscribe.'</font><br><p class="abdjvcba23newsletter" style="display:inline;"></p><input type="text" class="abdjnewsemail" name="abdj_newsletter_email" maxlength="80" value="'.$subscribe['subsemail'].'">';
		if (($mode == "subscribe") AND ($GLOBALS['abdj_config_newsletter']['feature_subscribername'] == TRUE)) {
			$newsletter .= '<br>';
		} else {
			$newsletter .= " ";
		}
		if ($mode == "subscribe") {
			$newsletter .= $error_msg['subsemail'].$error_msg['not_found'].'<br>';
		}

		$newsletter .= '<input type="submit" class="abdjnewssubmit" name="abdj_newsletter_submit" value="'.$GLOBALS['abdj_lang']['g_action_send'].'">'.$newsletter_copyright_subscribe;

		if ($mode == "unsubscribe") {
			$newsletter .= '<br>';
			if (!empty ($error_msg['subsemail']) OR !empty ($error_msg['not_found'])) {
				$newsletter .= $error_msg['subsemail'].$error_msg['not_found'];
			}
		}

		$newsletter .= "</form>";

		return $newsletter;
	} // function Subscribe_Form()

	function Newsletter_ID($mode, $action) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$mode=$mode, \$action=$action) <br>";

		$id = 0;

		if ($mode == "subscriber") {
			$file = $GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_subscribers_id'];
		} else {
			$file = $GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_newsletters_id'];
		}

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$file=$file <br>";
		$last_id = $GLOBALS['abdj_obj_common']->Read_File("STRING", FALSE, $file);
		if ($action == 'get') {
			$id = $last_id;
		}

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$last_id=$last_id <br>";

		if ($action == "add") {
			$new_id = $last_id +1;
			$GLOBALS['abdj_obj_common']->Write_File($file, FALSE, "begin", "STRING", $new_id);
			$id = $new_id;
		}
		trim($id);

		return $id;
	} // function Newsletter_ID()

	function Newsletter_Alias($action, $mode, $alias) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action, \$mode=$mode, \$alias=$alias) <br>";

		/* Newsletter.Alias - START //COMMENT_VERSION_BASIC// */
		if ($GLOBALS['abdj_config']['version'] == 'basic') {
			$return_alias = $GLOBALS['abdj_lang_newsletter']['sendnews_alias_all'];
		} 
		/* END //COMMENT_VERSION_BASIC// Newsletter.Alias */

		return $return_alias;
	} // function Newsletter_Alias()

	function Subscribe($alias, $action, $mode = '', $token='') {
			//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias, \$action=$action, \$mode=$mode) <br>";

		$subscribe['subsname'] = '';
		$subscribe['subsemail'] = '';
		$newsletter='';
		$error_msg_writing_file='';

		if (isset ($_POST['abdj_newsletter_submit'])) {
			$subscribe['submit'] = $_POST['abdj_newsletter_submit'];
		} else {
			$subscribe['submit'] = '';
		}

		if (empty ($alias)) {
			$GLOBALS['news_alias'] = $GLOBALS['abdj_config_newsletter']['default_alias'];
		}

		if (empty ($subscribe['submit'])) {
				// form not submitted
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": form not submitted <br>";
				$newsletter = $this->Subscribe_Form($action, '', '');
			} else {
				$proof_form = TRUE;

				if (isset ($_POST['abdj_newsletter_email'])) {
					$subscribe['subsemail'] = $_POST['abdj_newsletter_email'];
				}

				if (isset ($_POST['abdj_newsletter_name'])) {
					$subscribe['subsname'] = $_POST['abdj_newsletter_name'];
				}

				if (($action == "subscribe") AND ($GLOBALS['abdj_config_newsletter']['feature_subscribername'] == TRUE) AND (empty ($subscribe['subsname']))) {
					$proof_form = FALSE;
					$error_msg['subsname'] = $GLOBALS['abdj_lang']['g_error_empty_name'];
				}
				$regex = '^([._a-z0-9-]+[._a-z0-9-]*)@(([a-z0-9-]+\.)*([a-z0-9-]+)(\.[a-z]{2,4}))$';
				if (!eregi($regex, $subscribe['subsemail'])) {
					$proof_form = FALSE;
					$error_msg['subsemail'] = $GLOBALS['abdj_lang']['g_error_format_email'];
				}
			} // else if (empty($subscribe['submit']))
		
		
		if ($proof_form == FALSE) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": errors in subscribe form, show form again <br>";
			$newsletter = $this->Subscribe_Form($action, $subscribe, $error_msg);
		} // if ($proof_form == FALSE)
		else {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": no errors in subscribe form, save/delete subscriber <br>";

			//replace placeholders in lang vars
			$replace = ARRAY ('subsname' => $subscribe['subsname'], 'subsemail' => $subscribe['subsemail'], 'subsdate' => '', 'subsdatetime' => '', 'subject' => '');

			if ($action == "subscribe") {
				$find_subscriber = $this->Find_Subscriber($GLOBALS['news_alias'], $subscribe['subsemail']);
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$find_subscriber['success'] <br>";
				//var_dump($find_subscriber['success']); print '<br>';

				if ($find_subscriber['success'] == TRUE) { 
					$return_subscribe['success'] = TRUE;
					$subscribe = $find_subscriber['subscriber'];
					//replace placeholders in lang vars
					$replace = ARRAY ('subsname' => $subscribe['subsname'], 'subsemail' => $subscribe['subsemail'], 'subsdate' => $subscribe['subsdate'], 'subsdatetime' => $subscribe['subsdatetime'], 'subject' => '');
				}

				if ($find_subscriber['success'] == FALSE) {
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": subscriber does not exist <br>";

					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$action == subscribe <br>";
					$return_subscribe = $this->Subscribe_File($subscribe);
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": var_dump() <br>";
					//var_dump($return_subscribe); echo '<br>';

					$subscribe['subsid']='';
					if (isset($return_subscribe['subsid'])) { $subscribe['subsid'] = $return_subscribe['subsid']; }

				} // if ($find_subscriber['success'] == FALSE)
				

				if ($return_subscribe['success'] == FALSE) {
					$newsletter = '<br><br><i>'.$GLOBALS['abdj_lang_newsletter']['subscribe_err_not_subscribed'].'<br>'.$GLOBALS['abdj_lang_common']['status_file_write_no'].'<br></i>';
				}
				else {
					$GLOBALS['abdj_lang_newsletter']['subscribe_msg'] = $this->Format_Language($GLOBALS['abdj_lang_newsletter']['subscribe_msg'], $replace);
	
					$newsletter = "<br><br>".$GLOBALS['abdj_lang_newsletter']['subscribe_msg'];
				
				} // else if ($return_subscribe['success'] == FALSE) {
				
				$newsletter .= "<br><br>";
			} // if ($action == "subscribe")
			

			if ($action == "unsubscribe") {
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$action=$action <br>";

				if (($GLOBALS['abdj_config_newsletter']['feature_validatelink'] == TRUE) AND ($mode == "token")) {
					$return_unsubscribe_file = $this->Unsubscribe_File("token", $token);
					$unsubscriber = $return_unsubscribe_file['data'];
				} else {
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Unsubscribe_File() - do <br>";
					$return_unsubscribe_file = $this->Unsubscribe_File("email", $subscribe['subsemail']);
					$unsubscriber = $return_unsubscribe_file['data'];
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Unsubscribe_File() - done <br>";
					//var_dump($return_unsubscribe_file);
				}

				if ($return_unsubscribe_file['success'] == TRUE) {
					if ($return_unsubscribe_file['file_success'] == TRUE) {
						$GLOBALS['abdj_lang_newsletter']['unsubscribe_msg'] = $this->Format_Language($GLOBALS['abdj_lang_newsletter']['unsubscribe_msg'], $replace);
						$newsletter = $GLOBALS['abdj_lang_newsletter']['unsubscribe_msg'].'<br>'.$GLOBALS['abdj_lang_newsletter']['unsubscribe_joinagain'].'<br>';
					}
					else {
						$newsletter = $GLOBALS['abdj_lang_newsletter']['unsubscribe_err_not_unsubscribed'].'<br>'.$GLOBALS['abdj_lang_common']['status_file_write_no'].'<br>';
						$newsletter = $this->Format_Language($newsletter, $replace);
					}

				} // if ($return_unsubscribe_file['success'] == TRUE)
				else {
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": subscriber not found for unsubscription <br>";
					
					if ($mode != "token") {
						//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$subscribe['subsemail']=".$subscribe['subsemail']." <br>";
						//$error_msg['not_found'] = $GLOBALS['abdj_lang_newsletter']['unsubscribe_err_notfound'];
						$error_msg_temp['subsemail'] = $GLOBALS['abdj_lang_newsletter']['unsubscribe_err_notfound'];
						$error_msg_temp = $this->Fill_Placeholders($error_msg_temp, $subscribe);
						$error_msg['not_found'] = $error_msg_temp['subsemail'];
						//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$error_msg['not_found']=".$error_msg['not_found']." <br>";
						$newsletter = $this->Subscribe_Form($action, $subscribe, $error_msg);
					} // if ($mode != "token")
					
				} // else if ($return_unsubscribe_file['success'] == TRUE)
			} // if ($action == "unsubscribe") {
		} // else if ($proof_form == FALSE)

		return $newsletter;

	} //function Subscribe()

	function Subscribe_File($subscribe) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$subscribe=$subscribe) <br>";

		$file_array=ARRAY ();
		$token='';
		
		//get new ID
		$subscribe['id'] = $this->Newsletter_ID("subscriber", "add");

		$file_array = $GLOBALS['abdj_obj_common']->Read_File("DATAARRAY", FALSE, $GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_subscribers']);

		$validated = TRUE;

		$new_subscriber = $subscribe['id'].$GLOBALS['abdj_config']['data_spacer'].$GLOBALS['news_alias'].$GLOBALS['abdj_config']['data_spacer'].$validated.$GLOBALS['abdj_config']['data_spacer'].$subscribe['subsname'].$GLOBALS['abdj_config']['data_spacer'].$subscribe['subsemail'].$GLOBALS['abdj_config']['data_spacer'].$GLOBALS['abdj_config']['timestamp'].$GLOBALS['abdj_config']['data_spacer'].$token;
		// if subscribers exist, then add to array, else create new array;
		if (is_array($file_array)) {
			array_push($file_array, $new_subscriber);
		} else {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": no subscriber-array, add subscriber as first index. <br>";
			$file_array=ARRAY($new_subscriber);
		}
		$give_back = $GLOBALS['abdj_obj_common']->Write_File($GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_subscribers'], FALSE, "begin", "DATAARRAY", $file_array);

		$give_back['subsid'] = $subscribe['id'];
		$give_back['substoken'] = $token;

		return $give_back;

	} //function Subscribe_File()

	function Unsubscribe_File($mode, $unsubscribe_data) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$mode=$mode, \$unsubscribe_data=$unsubscribe_data) <br>";

		$subscriber_exists = FALSE;
		$write_data = '';
		$unsubscribe = ARRAY ();
		$unsubscriber = ARRAY ();
		$unsubscriber['subsemail'] = '';

		if (($mode == "id") OR ($mode == "token")) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": unsubscribe this: \$mode=$mode, \$unsubscribe_data=$unsubscribe_data <br>";
			$read_subscriber_array = $this->Read_Subscriber_Array($GLOBALS['abdj_lang_newsletter']['sendnews_alias_all']);
		} else {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Read_Subscriber_Array() - do <br>";
			$read_subscriber_array = $this->Read_Subscriber_Array($GLOBALS['news_alias']);
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Read_Subscriber_Array() - done <br>";
		}
		$subscriber_array = $read_subscriber_array['array'];

		foreach ($subscriber_array AS $subscriber) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$subscriber['subsid']=".$subscriber['subsid']." == \$unsubscribe_data=".$unsubscribe_data.'<br>';

			if ((($mode == "email") AND ($subscriber['subsemail'] == $unsubscribe_data)) OR (($mode == "id") AND ($subscriber['subsid'] == $unsubscribe_data)) OR (($mode == "token") AND ($subscriber['substoken'] == $unsubscribe_data))) {
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": subscriber found, will be unsubscribed<br>";
				// subscriber found, will be unsubscribed
				$subscriber_exists = TRUE;
				$unsubscriber = $subscriber;
				$success_delete_subscriber = $this->Delete_Subscriber($subscriber['subsid']);
				$unsubscribe['file_success'] = $success_delete_subscriber['success'];
			}
		} // foreach

		$unsubscribe['data'] = $unsubscriber;
		$unsubscribe['success'] = $subscriber_exists;
		
		return $unsubscribe;

	} //function Unsubscribe_File()

	function Delete_Subscriber($subsid) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$mode=$mode, \$unsubscribe_data=$unsubscribe_data) <br>";

		$subscriber_exists = FALSE;
		$write_data = ARRAY ();
		$unsubscriber = ARRAY ();
		$unsubscriber['subsemail'] = '';

		$read_subscriber_array = $this->Read_Subscriber_Array($GLOBALS['abdj_lang_newsletter']['sendnews_alias_all']);
		$subscriber_array = $read_subscriber_array['array'];

		foreach ($subscriber_array AS $subscriber) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$subscriber['subsid']=".$subscriber['subsid']." == \$unsubscribe_data=".$unsubscribe_data.'<br>';

			if ($subscriber['subsid'] == $subsid) {
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": subscriber found, will be unsubscribed<br>";
				// subscriber found, will be unsubscribed
				$subscriber_exists = TRUE;
				$unsubscriber = $subscriber;
			} else {
				$write_data[] = $subscriber['subsid'].$GLOBALS['abdj_config']['data_spacer'].$subscriber['subsalias'].$GLOBALS['abdj_config']['data_spacer'].$subscriber['subsvalidated'].$GLOBALS['abdj_config']['data_spacer'].$subscriber['subsname'].$GLOBALS['abdj_config']['data_spacer'].$subscriber['subsemail'].$GLOBALS['abdj_config']['data_spacer'].$subscriber['substimestamp'].$GLOBALS['abdj_config']['data_spacer'].$subscriber['substoken'];
			}
		} // foreach

		if ($subscriber_exists == TRUE) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Write_File() - do <br>";
			$success_writing_file = $GLOBALS['abdj_obj_common']->Write_File($GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_subscribers'], FALSE, "begin", "DATAARRAY", $write_data);
			$unsubscribe['file_success'] = $success_writing_file['success'];
			$unsubscribe['file_msg'] = $success_writing_file['msg'];
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Write_File() - done <br>";
		} // if ($subscriber_exists == TRUE)

		$unsubscribe = ARRAY ();
		$unsubscribe['data'] = $unsubscriber['subsemail'];
		$unsubscribe['success'] = $subscriber_exists;

		return $unsubscribe;

	} //function Delete_Subscriber()

	function Read_Subscriber_Array($alias) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias) <br>";

		$count_all = 0;
		$count_validated = 0;
		$subscriber_array = ARRAY ();

		$file = $GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_subscribers'];
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$file=$file <br>";
		$file_array = $GLOBALS['abdj_obj_common']->Read_File("DATAARRAY", FALSE, $file);

		if (is_array($file_array)) {
			foreach ($file_array AS $row) {
				$row_array = split($GLOBALS['abdj_config']['data_spacer'], $row);
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$row_array[1]=$row_array[1] - \$alias=$alias <br>";
				if ((!empty ($row_array[1])) AND (($row_array[1] == $alias) OR ($alias == 'all') OR ($alias == $GLOBALS['abdj_lang_newsletter']['sendnews_alias_all']) OR ($alias == "countall"))) {
					$subscriber['subsid'] = trim($row_array[0]);
					$subscriber['subsalias'] = trim($row_array[1]);
					$subscriber['subsvalidated'] = trim($row_array[2]);
					$subscriber['subsname'] = trim($row_array[3]);
					$subscriber['subsemail'] = trim($row_array[4]);
					$subscriber['substimestamp'] = trim($row_array[5]);
					$subscriber['substoken'] = trim($row_array[6]);
					array_push($subscriber_array, $subscriber);

					$count_all ++;
					if ($subscriber['subsvalidated'] == TRUE) {
						$count_validated ++;
					}
				}
			} // foreach
		}
		$return_array = ARRAY ("count" => $count_all, "count_validated" => $count_validated, "array" => $subscriber_array);
		return $return_array;
	} // function Read_Subscriber_Array()

	function Read_Subscriber($alias, $subsid) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias, \$subsid=$subsid) <br>";

		$subscriber = FALSE;
		$subscriber_array = $this->Read_Subscriber_Array($alias);

		foreach ($subscriber_array['array'] as $subscriber_row) {
			if ($subscriber_row['subsid'] == $subsid) {
				$subscriber = $subscriber_row;
				break;
			}
		}

		return $subscriber;
	} // function Read_Subscriber()

	function Read_Subscriber_Paged($alias, $current_page, $show_amount) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias, \$current_page=$current_page, \$show_amount=$show_amount) <br>";

		$row_count = 0;
		$subscriber = FALSE;
		$subscriber_array = $this->Read_Subscriber_Array($alias);

		foreach ($subscriber_array['array'] as $subscriber_row) {
			$row_count ++;

			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$row_count=$row_count <br>";

			if (($row_count >= $current_page * $show_amount - $show_amount +1) AND ($row_count <= $current_page * $show_amount)) {
				$subscriber[] = $subscriber_row;
			}

			// stop reading through data, if current_page is fully read
			// if ($row_count > $current_page * $show_amount - $show_amount +1) {
			if ($row_count > $current_page * $show_amount) {
				break;
			}
		} // foreach

		return $subscriber;
	} // function Read_Subscriber_Paged()

	function Update_Subscriber($action, $subsid, $subscriber) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action, \$subsid=$subsid) <br>";

		$update_subscriber=ARRAY();
		$update_subscriber['success']=FALSE;
		$update_subscriber['msg']='';
		
		$subscriber_file = ARRAY();
		$subscriber_array = $this->Read_Subscriber_Array('all');

		if (is_array($subscriber_array['array'])) {
			foreach ($subscriber_array['array'] AS $subscriber_row) {
				if ($subscriber_row['subsid'] == $subsid) {
					$subscribers = $subscriber;
				} else {
					$subscribers = $subscriber_row;
				}
				$subscriber_file[] = $subscribers['subsid'].$GLOBALS['abdj_config']['data_spacer'].$subscribers['subsalias'].$GLOBALS['abdj_config']['data_spacer'].$subscribers['subsvalidated'].$GLOBALS['abdj_config']['data_spacer'].$subscribers['subsname'].$GLOBALS['abdj_config']['data_spacer'].$subscribers['subsemail'].$GLOBALS['abdj_config']['data_spacer'].$subscribers['substimestamp'].$GLOBALS['abdj_config']['data_spacer'].$subscribers['substoken'];

				//if ($subscriber_row['subsid'] == $subsid) {
				//	print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$subscribers['subsvalidated']=".$subscribers['subsvalidated']." <br>";
				//}

			} // foreach

			$update_subscriber = $GLOBALS['abdj_obj_common']->Write_File($GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_subscribers'], FALSE, "begin", "DATAARRAY", $subscriber_file);
		} // if (is_array($subscriber_array['array']))
		
		return $update_subscriber;

	} // function Update_Subscriber()

	function Read_Newsletter_Array() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$row_count=0;
		$newsletter_array = ARRAY ();

		$file = $GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_newsletters'];
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$file=$file <br>";
		$file_array = $GLOBALS['abdj_obj_common']->Read_File("DATAARRAY", FALSE, $file);

		foreach ($file_array AS $row) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$row_array[1]=".$row_array[1]." <br>";
			$row_array = split($GLOBALS['abdj_config']['data_spacer'], $row);
			if (!empty ($row_array[1])) {
				$newsletter['newsid'] = trim($row_array[0]);
				$newsletter['newsalias'] = trim($row_array[1]);
				$newsletter['newssubject'] = trim($row_array[2]);
				$newsletter['newstimestamp'] = trim($row_array[3]);
				$newsletter['newsmessage'] = trim($row_array[4]);
				array_push($newsletter_array, $newsletter);
				$row_count ++;
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$newsletter['newssubject']=".$newsletter['newssubject']." <br>";
			}
		} // foreach
		return $newsletter_array;
	} // function Read_Newsletter_Array()

	function Find_Subscriber($alias, $email) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias, \$email=$email) <br>";

		$subscriber_exists = FALSE;
		$subscriber_data = FALSE;
		$row_index = 0;

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Read_Subscriber_Array($alias); <br>";
		$read_subscriber_array = $this->Read_Subscriber_Array($alias);
		$subscriber_array = $read_subscriber_array['array'];
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$subscriber_array <br>";
		//var_dump($subscriber_array); print '<br>';

		foreach ($subscriber_array AS $subscriber) {
			if ($subscriber['subsalias'] == $alias AND $subscriber['subsemail'] == $email) {
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": subscriber already exists <br>";
				$subscriber_exists = TRUE;
				$subscriber_data = $subscriber;
				break;
			}
			$row_index ++;
		}

		$subscriber['success'] = ARRAY();
		$subscriber['success'] = $subscriber_exists;
		$subscriber['subscriber'] = $subscriber_data;
		
		return $subscriber; 
	} // function Find_Subscriber()

	function Get_Edit_Subscriber_Pager($alias, $url, $items_per_page, $current_page, $type, $url_para) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para($alias, $url, $items_per_page, $current_page, $type, $url_para) <br>";

		$subscriber_pager = FALSE;
		$subscriber_count = '';

		$subscriber_array = $this->Read_Subscriber_Array($alias);
		$subscriber_count = $subscriber_array['count'];

		if ($subscriber_count > 0) {
			$pager_css=ARRAY();
			$pager_css['div'] = ' class="'.$GLOBALS['abdj_config_newsletter']['feature_show_pages_cssclass'].'div" ';
			$pager_css['a'] = ' class="'.$GLOBALS['abdj_config_newsletter']['feature_show_pages_cssclass'].'a" ';
			$pager_css['a_current'] = ' class="'.$GLOBALS['abdj_config_newsletter']['feature_show_pages_cssclass'].'acurrent" ';
			$pager_css['a_next'] = ' class="'.$GLOBALS['abdj_config_newsletter']['feature_show_pages_cssclass'].'anext" ';
			$pager_css['a_prev'] = ' class="'.$GLOBALS['abdj_config_newsletter']['feature_show_pages_cssclass'].'aprev" ';
			$subscriber_pager = $GLOBALS['abdj_obj_pager']->GetPager($url.$url_para, $subscriber_count, $items_per_page, $current_page, $type, $pager_css);
		}

		return $subscriber_pager;

	} // function Get_Edit_Subscriber_Pager()

	function Edit_Subscriber($action, $subsid) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\action=".$action.", \$subsid=".$subsid.") <br>";
		
		$giveback_editsubscribers = '';

		$file_subscribers = $GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_subscribers'];
		$check_filepermission = $GLOBALS['abdj_obj_common']->Check_Filepermissions('WRITEABLE', $file_subscribers);

		if (empty ($form_alias)) {
			$form_alias = $GLOBALS['abdj_lang_newsletter']['sendnews_alias_all'];
		}

		if (!empty ($subsid)) {
			$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_subsid'] = $subsid;
		}
		else {
			if (!empty ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_subsid'])) {
				$subsid = $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_subsid'];
			}
		}

		if (!empty ($action) AND !empty ($subsid) AND $check_filepermission['success']==TRUE) {

			if ($action == "delete") {
				$this->Delete_Subscriber($subsid);
			}

			// if edit form is canceled, jump section "edit"
			// and show subscriber list instead
			if (isset ($_POST['abdj_post_newsletter_editsubscribers_cancel'])) {
				$action = "cancel_edit";
				$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_subsid']='';
			}

			if ($action == "edit") {

				$editsubscribers_form_checked_subsvalidated = '';

				if (isset ($_POST['abdj_post_newsletter_editsubscribers_submit'])) {
					$subscriber['submit'] = $_POST['abdj_post_newsletter_editsubscribers_submit'];
				} // if (isset ($_POST['abdj_post_newsletter_editsubscribers_submit']))
				else {
					$subscriber['submit'] = '';
				}

				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$action=$action - \$subscriber['submit']=".$subscriber['submit']." <br>";

				if (empty ($subscriber['submit'])) {
					$subscriber = $this->Read_Subscriber($form_alias, $subsid);
				} // if (!isset($subscriber['submit']))

				if (!empty ($subscriber['submit'])) {

					if (isset ($_POST['abdj_post_newsletter_editsubscribers_subsalias'])) {
						$subscriber['subsalias'] = $_POST['abdj_post_newsletter_editsubscribers_subsalias'];
					} else {
						$subscriber['subsalias'] = '';
					}

					if (isset ($_POST['abdj_post_newsletter_editsubscribers_subsvalidated'])) {
						$subscriber['subsvalidated'] = $_POST['abdj_post_newsletter_editsubscribers_subsvalidated'];
					} else {
						$subscriber['subsvalidated'] = '';
					}
						if (isset ($_POST['abdj_post_newsletter_editsubscribers_subsvalidated_old'])) {
							$subscriber['subsvalidated_old'] = $_POST['abdj_post_newsletter_editsubscribers_subsvalidated_old'];
						} else {
							$subscriber['subsvalidated_old'] = '';
						}

					if (isset ($_POST['abdj_post_newsletter_editsubscribers_subsname'])) {
						$subscriber['subsname'] = $_POST['abdj_post_newsletter_editsubscribers_subsname'];
					} else {
						$subscriber['subsname'] = '';
					}

					if (isset ($_POST['abdj_post_newsletter_editsubscribers_subsemail'])) {
						$subscriber['subsemail'] = $_POST['abdj_post_newsletter_editsubscribers_subsemail'];
					} else {
						$subscriber['subsemail'] = '';
					}

					if (isset ($_POST['abdj_post_newsletter_editsubscribers_substimestamp'])) {
						$subscriber['substimestamp'] = $_POST['abdj_post_newsletter_editsubscribers_substimestamp'];
					} else {
						$subscriber['substimestamp'] = '';
					}

					if (isset ($_POST['abdj_post_newsletter_editsubscribers_substoken'])) {
						$subscriber['substoken'] = $_POST['abdj_post_newsletter_editsubscribers_substoken'];
					} else {
						$subscriber['substoken'] = '';
					}

				} // if (!empty($subscriber['submit']))

				if (empty ($subscriber['submit'])) {

					if ($subscriber['subsvalidated'] == TRUE) {
						$editsubscribers_form_checked_subsvalidated = "checked";
					}
					$editsubscribers_form = "<form method=\"post\" action=\"\">";

					$alias_readonly='';

					/* Newsletter.ValidateSubscriber - START //COMMENT_VERSION_BASIC// */
					if ($GLOBALS['abdj_config']['version'] == 'basic') {
						$alias_readonly = 'readonly';
						$editsubscribers_form .= '<input type="hidden" name="abdj_post_newsletter_editsubscribers_subsvalidated" value="'.$subscriber['subsvalidated'].'">';
						$editsubscribers_form .= '<input type="hidden" name="abdj_post_newsletter_editsubscribers_subsvalidated_old" value="'.$subscriber['subsvalidated'].'">';
						$editsubscribers_form .= '<input type="hidden" name="abdj_post_newsletter_editsubscribers_substoken" value="'.$subscriber['substoken'].'">';
					}
					/* END //COMMENT_VERSION_BASIC// Newsletter.ValidateSubscriber */


					$editsubscribers_form .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang']['alias'].':</font><br><input class="abdjcfg" type="text" name="abdj_post_newsletter_editsubscribers_subsalias" value="'.$subscriber['subsalias'].'" '.$alias_readonly.'><br><br>';

					$editsubscribers_form .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang']['g_field_name'].':</font><br><input class="abdjcfg" type="text" name="abdj_post_newsletter_editsubscribers_subsname" value="'.$subscriber['subsname'].'"><br><br>';
					$editsubscribers_form .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang']['g_field_email'].':</font><br><input class="abdjcfg" type="text" name="abdj_post_newsletter_editsubscribers_subsemail" value="'.$subscriber['subsemail'].'"><br><br>';
					$editsubscribers_form .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang']['g_field_date'].': (';
					$timestamptohumanreadable = $GLOBALS['abdj_obj_common']->TimestampToHumanReadable($subscriber['substimestamp']);
					$editsubscribers_form .= $timestamptohumanreadable['datetime'];
					$editsubscribers_form .= ')</font><br><input class="abdjcfg" type="text" name="abdj_post_newsletter_editsubscribers_substimestamp" value="'.$subscriber['substimestamp'].'"><br><br>';
				
					$editsubscribers_form .= '<br><input type="submit" name="abdj_post_newsletter_editsubscribers_submit" value="'.$GLOBALS['abdj_lang']['g_action_edit'].'"><input type="submit" name="abdj_post_newsletter_editsubscribers_cancel" value="'.$GLOBALS['abdj_lang']['g_action_cancel'].'"><br>';
					$editsubscribers_form .= '</form>';

					$giveback_editsubscribers = $editsubscribers_form;

				} // if (empty($subscriber['submit']))
				else {
					$editsubscribers_summary='';

					$subscriber['subsid'] = $subsid;

					$update_success = $this->Update_Subscriber($action, $subsid, $subscriber);
					if ($update_success['success'] == FALSE) { 
						$editsubscribers_summary .= '<font class="abdjerror"><u>'.$GLOBALS['abdj_lang']['g_error'].':</u><br><br>'.$update_success['msg'].'<br><br></font>';
					}
					else {
						$editsubscribers_summary .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang']['g_cap_id'].": </font><font class=\"abdjadminform\">".$subscriber['subsid']."<br><br></font>";
						$editsubscribers_summary .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang']['alias'].": </font><font class=\"abdjadminform\">".$subscriber['subsalias']."<br><br></font>";
						$editsubscribers_summary .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang_newsletter']['showsubscribers_table_activated'].": </font>";
	
						$editsubscribers_summary .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang']['g_field_name'].": </font><font class=\"abdjadminform\">".$subscriber['subsname']."<br><br></font>";
						$editsubscribers_summary .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang']['g_field_email'].": </font><font class=\"abdjadminform\">".$subscriber['subsemail']."<br><br></font>";
						$editsubscribers_summary .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang']['g_field_date'].": </font><font class=\"abdjadminform\">";
						$timestamptohumanreadable = $GLOBALS['abdj_obj_common']->TimestampToHumanReadable($subscriber['substimestamp']);
						$editsubscribers_summary .= $timestamptohumanreadable['datetime'];
						$editsubscribers_summary .="<br><br></font>";
	
					}

					$editsubscribers_summary .= "<hr><a href=\"".$GLOBALS['abdj_url']['admin_newsletter_editsubscribers']."\">".$GLOBALS['abdj_config']['url_link_prefix'].$GLOBALS['abdj_lang']['g_action_back_link']."</a><br>";

					$giveback_editsubscribers = $editsubscribers_summary;

				} // else if (empty($subscriber['submit']))

			} // if ($action=="edit")

		} // if (!empty($action) AND !empty($subsid))

		if ($action != 'edit' OR
		($action=='edit' AND $check_filepermission['success']==FALSE)
		)
		{
			$pager_current_page = 0;

			if (isset ($_GET['abdj_cpage'])) {
				$pager_current_page = $_GET['abdj_cpage'];
			}

			if ($pager_current_page == 0) {
				if ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage'] > 0) {
					$pager_current_page = $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_cpage'];
				} else {
					$pager_current_page = 1;
				}
			}

			$edit_link_para = $GLOBALS['abdj_url_amp']."abdj_cpage=".$pager_current_page;

			$edit_link = $GLOBALS['abdj_url']['admin_newsletter_editsubscribers'];

			$obj_addonsbydjot = new Addonsbydjot();
			$abdj_kernel_para['alias'] = $form_alias;
			$abdj_kernel_para['url'] = $edit_link;
			$abdj_kernel_para['items_per_page'] = $GLOBALS['abdj_config_newsletter']['editsubscribers_show_pages_count'];
			$abdj_kernel_para['current_page'] = $pager_current_page;
			$abdj_kernel_para['type'] = $GLOBALS['abdj_config_newsletter']['editsubscribers_show_pages_type'];
			$abdj_kernel_para['url_para'] = $edit_link_para;
			$editsubscribers_pager = $obj_addonsbydjot->abdj_kernel('function', 'newsletter', 'pager', $abdj_kernel_para);

			$subscriber_array = $this->Read_Subscriber_Paged($form_alias, $pager_current_page, $GLOBALS['abdj_config_newsletter']['editsubscribers_show_pages_count']);
			//$read_subscriber_array = $this->Read_Subscriber_Paged($form_alias, $pager_current_page, $GLOBALS['abdj_config_newsletter']['editsubscribers_show_pages_count']);
			//$subscriber_array = $read_subscriber_array['array'];

			// If no subscriber is found for current alias,
			// read all subscribers
			if ($form_alias != $GLOBALS['abdj_lang_newsletter']['sendnews_alias_all'] AND (!is_array($subscriber_array) OR empty ($subscriber_array[0]))) {
				$read_subscriber_array = $this->Read_Subscriber_Array($GLOBALS['abdj_lang_newsletter']['sendnews_alias_all']);
				$subscriber_array = $read_subscriber_array['array'];
				if (is_array($subscriber_array) OR !empty ($subscriber_array[0])) {
					$form_alias = $GLOBALS['abdj_lang_newsletter']['sendnews_alias_all'];
				}
			}

			if ((!is_array($subscriber_array)) OR (empty ($subscriber_array[0]))) {
				$giveback_editsubscribers = $GLOBALS['abdj_lang_newsletter']['showsubscribers_no_subscribers'];

			} else {

				$giveback_editsubscribers = "<center><table width=\"95%\" cellpadding=\"2\" cellspacing=\"0\" border=\"0\"><tr><td align=\"left\"><p class=\"abdjsmall\" >"."&#149;".$GLOBALS['abdj_lang_newsletter']['showsubscribers_hint_delete'];
								
				$giveback_editsubscribers .= "</p>";

				$giveback_editsubscribers .= "</td></tr></table><table width=\"95%\" cellpadding=\"4\" cellspacing=\"0\" border=\"0\"><tr class=\"abdjcaption\"><td class=\"abdjcaption\">".$GLOBALS['abdj_lang']['g_cap_lfd']."</td><td class=\"abdjcaption\">".$GLOBALS['abdj_lang']['g_cap_id']."</td><td class=\"abdjcaption\">".$GLOBALS['abdj_lang_newsletter']['showsubscribers_table_alias']."</td>";

				$giveback_editsubscribers .= "<td class=\"abdjcaption\">".$GLOBALS['abdj_lang']['g_field_name']."</td><td class=\"abdjcaption\" align=center>".$GLOBALS['abdj_lang']['g_field_email']."</td><td class=\"abdjcaption\" align=center>".$GLOBALS['abdj_lang']['g_field_date']."</td><td class=\"abdjcaption\" align=right>".$GLOBALS['abdj_lang']['g_cap_action']."</td></tr>";

				$row_count = 0;
				$style_tr = '';

				foreach ($subscriber_array AS $subscriber) {
					if ($style_tr == "class=\"abdjdlight\"") {
						$style_tr = "class=\"abdjddark\"";
					} else {
						$style_tr = "class=\"abdjdlight\"";
					}

					if (!empty ($subscriber['subsemail'])) {
						$edit_links='';
						$validated='';
						$row_count ++;

						//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$row_count=".$row_count.", \$subscriber['subsid']=".$subscriber['subsid'].", \$subscriber['subsemail']=".$subscriber['subsemail']." <br>";

						$lfd = $pager_current_page * $GLOBALS['abdj_config_newsletter']['editsubscribers_show_pages_count'] - $GLOBALS['abdj_config_newsletter']['editsubscribers_show_pages_count'] + $row_count;

						$timestamptohumanreadable = $GLOBALS['abdj_obj_common']->TimestampToHumanReadable($subscriber['substimestamp']);
						$datetime = $timestamptohumanreadable['datetime'];

						$edit_link_url = $edit_link.$edit_link_para.$GLOBALS['abdj_url_amp']."abdj_get_admin_newsletter_subsid=".$subscriber['subsid'].$GLOBALS['abdj_url_amp']."abdj_get_admin_newsletter_action=";

						$edit_links .= "<a href=\"".$edit_link_url."edit\"><font class=\"abdjnewsadminedit\">".$GLOBALS['abdj_config']['url_link_prefix'].$GLOBALS['abdj_lang']['g_action_edit']."</font></a><br>";
						$edit_links .= "<a href=\"".$edit_link_url."delete\"><font class=\"abdjnewsadmindelete\">".$GLOBALS['abdj_config']['url_link_prefix'].$GLOBALS['abdj_lang']['g_action_delete']."</font></a><br>";

						$giveback_editsubscribers .= "<tr ".$style_tr."><td ".$style_tr.">".$lfd."</td><td ".$style_tr.">".$subscriber['subsid']."</td><td ".$style_tr.">".$subscriber['subsalias']."</td>";

						$giveback_editsubscribers .= "<td ".$style_tr.">".$subscriber['subsname']."</td><td ".$style_tr.">".$subscriber['subsemail']."</td><td ".$style_tr.">".$datetime."</td><td ".$style_tr." align=\"left\" >".$edit_links."</td></tr>";
					}
				} // foreach

				if ($GLOBALS['abdj_config']['version'] == 'basic') { $td_colspan = 'colspan="7"'; }
				else { $td_colspan = 'colspan="8"'; }

				$giveback_editsubscribers .= "<tr class=\"abdjdark\"><td class=\"abdjdark\" ".$td_colspan." >&nbsp;</td></tr>";
				$giveback_editsubscribers .= "</table></center><br>";
				if (!empty($editsubscribers_pager)) {
					$giveback_editsubscribers .= $editsubscribers_pager;
				}

			} // if ( (!is_array($subscriber_array)) OR (empty($subscriber_array[0])) )

		} // if ($action!="edit")

		return $check_filepermission['msg'].$giveback_editsubscribers;

	} // function Edit_Subscriber()

	function Newsletter_Form($message, $error_msg) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$message=$message, \$error_msg=$error_msg) <br>";
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$message['from']=$message['from'] <br>";

		// width of fields in newsletter form
		$form_size_input = 65;
		$form_size_textarea = 50;
		$form_attachments = '';
		$form_attachments_files = '';
		$checkbox_feature_attachments_send_checked = '';
		$checkbox_feature_attachments_delete_checked = '';
		$checkbox_feature_copytoadmin_yes = '';
		$checkbox_feature_copytoadmin_no = '';
		$checkbox_feature_savenewsletter_yes = '';
		$checkbox_feature_savenewsletter_no = '';
		
		$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent']=FALSE;

		if (!isset ($error_msg['alias'])) {
			$error_msg['alias'] = '';
		}
		if (!isset ($error_msg['attachments'])) {
			$error_msg['attachments'] = '';
		}
		if (!isset ($error_msg['subsemail'])) {
			$error_msg['subsemail'] = '';
		}
		if (!isset ($error_msg['subject'])) {
			$error_msg['subject'] = '';
		}
		if (!isset ($error_msg['message'])) {
			$error_msg['message'] = '';
		}
		//if (!isset($error_msg[''])) { $error_msg['']=''; }

		if (empty ($message['from'])) {
			$message['from'] = $GLOBALS['abdj_config_newsletter']['admin_email'];
		}

		if (isset ($_POST['abdj_newsletter_alias'])) {
			$form_alias = $_POST['abdj_newsletter_alias'];
		} else {
			$form_alias = '';
		}
		$select_aliases = $this->Newsletter_Alias("select", "send", $form_alias);

		$popup_link['link_text'] = $GLOBALS['abdj_config']['url_link_prefix'].$GLOBALS['abdj_lang_newsletter']['sendnews_placeholders_desc_link'];
		$popup_link['css_class'] = "";
		$popup_link['css_id'] = "";

		$popup_window['title'] = "NewsletterPlaceholders";
		$popup_window['url'] = $GLOBALS['abdj_url_admin_newsletter_placeholders'];
		$popup_window['width'] = "640";
		$popup_window['height'] = "480";
		$popup_window['left'] = "100";
		$popup_window['top'] = "100";
		$popup_window['scrollbars'] = "yes";
		$popup_window['toolbar'] = "no";
		$popup_window['menubar'] = "no";
		$popup_window['status'] = "no";
		$popup_window['dependent'] = "yes";
		$popup_window['hotkeys'] = "yes";
		$popup_window['innerHeight'] = "20";
		$popup_window['innerWidth'] = "300";
		$popup_window['location'] = "no";
		$popup_window['resizable'] = "yes";
		$popup_window['screenX'] = "120";
		$popup_window['screenY'] = "200";

		$popup = abdj_JsPopupWindow($popup_window, $popup_link, TRUE);

		$newsletter = "<table width=100% cellpadding=0 cellspacing=20 border=0><tr><td valign=top>";

		/*
		$regex = '^([._a-z0-9-]+[._a-z0-9-]*)@(([a-z0-9-]+\.)*([a-z0-9-]+)(\.[a-z]{2,4}))$';
		if (!eregi($regex, $GLOBALS['abdj_config_newsletter']['admin_email'])) {
			$error_msg_missing_admin_email['missing_admin_email'] = $GLOBALS['abdj_lang']['admin_title_config']." ".$GLOBALS['abdj_lang']['admin_title_newsletter'].":<br>".$GLOBALS['abdj_lang']['g_error_format_email']."<br><br>";
			$error_msg_missing_admin_email = $this->Format_Error($error_msg_missing_admin_email);
			$newsletter .= $error_msg_missing_admin_email['missing_admin_email']; 
		}
		*/

		$newsletter .= "<fieldset class=\"abdjadminform\"><legend class=\"abdjadminform\">".$GLOBALS['abdj_lang_newsletter']['sendnews_caption']."</legend><div class=\"abdjadminform\">";
		$newsletter .= '<form enctype="multipart/form-data" action="" method="post">';
		
		$newsletter .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang_newsletter']['sendnews_field_from'].'</font><br><input type="text" name="abdj_newsletter_msg_from" size="'.$form_size_input.'" maxlength="60" value="'.$message['from'].'"><br>'.$error_msg['subsemail'].'<br>';
		$newsletter .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang']['g_field_subject']."</font><br><input type=\"text\" name=\"abdj_newsletter_msg_subject\" size=\"".$form_size_input."\" maxlength=\"60\" value=\"".$message['subject']."\"><br>".$error_msg['subject'].'<br>';
		$newsletter .= '<font class="abdjadminformfield">'.$GLOBALS['abdj_lang_newsletter']['sendnews_field_news']."</font><br><textarea name=\"abdj_newsletter_msg_message\" cols=\"".$form_size_textarea."\" rows=\"15\">".$message['message']."</textarea><br>".$error_msg['message'].$form_attachments.'<br>';
		$newsletter .= '<input type="submit" name="abdj_newsletter_submit_preview" value="'.$GLOBALS['abdj_lang_newsletter']['sendnews_submit_preview'].'"><input type="submit" name="abdj_newsletter_submit" value="'.$GLOBALS['abdj_lang']['g_action_send'].'"><br>';
		$newsletter .= "</form></div></fieldset><br><hr>".$popup['link']."<br><br>";
		$newsletter .= "<table cellpadding=4 cellspacing=0 border=0><tr><td valign=top colspan=2><b>".$GLOBALS['abdj_lang_newsletter']['sendnews_hint_placeholder_default_message_caption'].":</b><br>".$GLOBALS['abdj_lang_newsletter']['sendnews_hint_placeholder_default_message_hint']."</td></tr>";

		$newsletter .= "</table></td></tr></table><br>";
		return $newsletter;
	} // CMS_Newsletter_Form()

	function Newsletter_Queue() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$html_queue = ARRAY ('msg' => '', 'meta_refresh' => '');
		$html_queue_sent_count = 0;
		$html_queue_sent_items = '';
		$sent_count = 0;
		$foreach_count = 0;
		

		if (!isset ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['alias'])) {
			$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['alias'] = '';
		}
		
		if (!isset ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['from'])) {
			$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['from'] = '';
		}
		if (!isset ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['subject'])) {
			$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['subject'] = '';
		}
		if (!isset ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['message'])) {
			$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['message'] = '';
		}

		if (!isset ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count'])) {
			$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count'] = 0;
		}
		if (!isset ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['last_index_sent'])) {
			$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['last_index_sent'] = 0;
		}
		if (!isset ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent'])) {
			$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent'] = FALSE;
		}

		if (!isset ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_copytoadmin'])) {
			$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_copytoadmin'] = FALSE;
		}
		
		if (!isset ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_attachments_send'])) {
			$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_attachments_send'] = FALSE;
		}
		if (!isset ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_attachments_delete'])) {
			$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_attachments_delete'] = FALSE;
		}
        //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_attachments_delete']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_attachments_delete']." <br>";

		/*
		if (!isset ()) {
			 = FALSE;
		}
		*/

        /*
        print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['lang_current_editlanguage']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['lang_current_editlanguage']." <br>";
        print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['alias']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['alias']." <br>";
        print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['from']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['from']." <br>";
        print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['subject']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['subject']." <br>";
        print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['message']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['message']." <br>";
        print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count']." <br>";
        print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['last_index_sent']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['last_index_sent']." <br>";
        print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent']." <br>";
        print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_copytoadmin']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_copytoadmin']." <br>";
        print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_attachments_send']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_attachments_send']." <br>";
        print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_attachments_delete']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_attachments_delete']." <br>";
        */


		if ($GLOBALS['abdj_config_newsletter']['feature_send_newsletter'] == TRUE) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$GLOBALS['abdj_config_newsletter']['feature_send_newsletter']=".$GLOBALS['abdj_config_newsletter']['feature_send_newsletter'].'<br>';
			// send newsletter

			$read_subscriber_array = $this->Read_Subscriber_Array($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['alias']);
			$subscriber_array_count = $read_subscriber_array['count_validated'];
			$subscriber_array = $read_subscriber_array['array'];



			if ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent'] == FALSE) {
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['subject']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['subject']." <br>";

				// header for mail() with no files attached
				$header = "From: ".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['from']."\n";
				$header .= "Reply-To: ".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['from']."\n";
				$header .= "X-Mailer: PHP\n";
				$header .= "Content-Type: text/plain; charset=iso-8859-1;\n";
				//$header .= "Content-Type: text/html\n";
				$header .= "Content-Transfer-Encoding: 8bit\n\n";


				foreach ($subscriber_array AS $subscriber) {
					$foreach_count ++;
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$foreach_count=$foreach_count<br>";
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$subscriber['subsemail']=".$subscriber['subsemail']."<br>";
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[".$GLOBALS['abdj_config']['session_name']."]['abdj_newsletter_queue']['alias']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['alias']."<br>";
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$GLOBALS['abdj_config_newsletter']['feature_send']=".$GLOBALS['abdj_config_newsletter']['feature_send']."<br>";

					$regex = '^([._a-z0-9-]+[._a-z0-9-]*)@(([a-z0-9-]+\.)*([a-z0-9-]+)(\.[a-z]{2,4}))$';
					if ((eregi($regex, $subscriber['subsemail'])) AND ($subscriber['subsvalidated'] == TRUE)) {
						//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": correct email format and validated!<br>";

						$html_queue_sent_count ++;
						$html_queue_sent_items .= $html_queue_sent_count.": ".$subscriber['subsname']." - ".$subscriber['subsemail']."\n";

						//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$sent_count=".$sent_count." == \$GLOBALS['abdj_config_newsletter']['queue_amount']=".$GLOBALS['abdj_config_newsletter']['queue_amount']."?? <br>";
						if ($sent_count == $GLOBALS['abdj_config_newsletter']['queue_amount']) {
							//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$sent_count=$sent_count == \$GLOBALS['abdj_config_newsletter']['queue_amount']==".$GLOBALS['abdj_config_newsletter']['queue_amount']."!! <br>";
							$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count'] = $GLOBALS['abdj_obj_common']->ZeroToString($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count']);
							$subscriber_array_count = $GLOBALS['abdj_obj_common']->ZeroToString($subscriber_array_count);

							$queue_url_refresh = $GLOBALS['abdj_url_admin_newsletter_queue'];

							if ($GLOBALS['abdj_config_newsletter']['queue_refresh'] < $GLOBALS['abdj_config_newsletter']['queue_refresh_minimum']) {
								$html_queue_refresh_seconds = $GLOBALS['abdj_config_newsletter']['queue_refresh_minimum'];
							} else {
								$html_queue_refresh_seconds = $GLOBALS['abdj_config_newsletter']['queue_refresh'];
							}

							$html_queue['meta_refresh'] = "\n".'<meta http-equiv="refresh" content="'.$html_queue_refresh_seconds.'; URL='.$queue_url_refresh.'">'."\n";

							$html_queue['msg'] .= "<fieldset class=\"abdjadminform\"><legend class=\"abdjadminform\">".$GLOBALS['abdj_lang_newsletter']['sendnews_queue_caption']."</legend><div class=\"abdjadminform\">";
							$html_queue['msg'] .= $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count']." ".$GLOBALS['abdj_lang_newsletter']['sendnews_queue_range_of']." ".$subscriber_array_count." ".$GLOBALS['abdj_lang_newsletter']['sendnews_queue_range_sent'].".<br><br>".$GLOBALS['abdj_lang_newsletter']['sendnews_queue_desc_redirect'];
							$html_queue['msg'] .= "<br><br><br><div style=\"text-align:center;\"><a href=\"".$queue_url_refresh."\">".$GLOBALS['abdj_config']['url_link_prefix'].$GLOBALS['abdj_lang_newsletter']['sendnews_queue_send_next']." ".$GLOBALS['abdj_config_newsletter']['queue_amount']."</a></div>";
							$html_queue['msg'] .= "</div></fieldset>";
							break;
						} else {
							//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$foreach_count=".$foreach_count." > \$_SESSION[".$GLOBALS['abdj_config']['session_name']."]['abdj_newsletter_queue']['sent_count']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count']." ??<br>";
							if ($foreach_count > $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['last_index_sent']) {
								$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['last_index_sent'] = $foreach_count;
								$sent_count ++;
								$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count']++;
								//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$sent_count=".$sent_count.'<br>';
								//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[".$GLOBALS['abdj_config']['session_name']."]['abdj_newsletter_queue']['sent_count']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count'].'<br>';

								if ($GLOBALS['abdj_config_newsletter']['feature_subscribername'] == FALSE) {
									$subscriber['subsname'] = "subscriber";
								}
								$subscriber['subsdate'] = date($GLOBALS['abdj_config']['date_format_numbers'], $subscriber['substimestamp']);
								$subscriber['subsdatetime'] = date($GLOBALS['abdj_config']['date_format_numbers']." ".$GLOBALS['abdj_config']['time_format_numbers'], $subscriber['substimestamp']);
								$format_message['subject'] = $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['subject'];
								$format_message['message'] = $_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['message'];

								$format_newsletter = $this->Format_Newsletter("mail", $format_message, $subscriber);
								$message_text=$format_newsletter['message']['message'];
								$message_subject=$format_newsletter['message']['subject'];
								if ($GLOBALS['abdj_config_newsletter']['feature_send'] == TRUE) {
									$GLOBALS['abdj_obj_common']->SimpleMailDebug($subscriber['subsemail'], $message_subject, $message_text, $header);
									$GLOBALS['abdj_obj_common']->SimpleMail($subscriber['subsemail'], $message_subject, $message_text, $header);
								}

							} // if ($subscriber['subsid'] < $queue['count'])
						} // else if ($sent_count == $GLOBALS['abdj_config_newsletter']['queue_amount'])

					} // if ( (eregi($regex, $subscriber['subsemail'])) AND ($subscriber['subsvalidated'] == TRUE) )
				} // foreach



			} // if ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent'] == FALSE)

			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$sent_count=".$sent_count." <br>";
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$GLOBALS['abdj_config_newsletter']['queue_amount']=".$GLOBALS['abdj_config_newsletter']['queue_amount']." <br>";
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count']=".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count']." <br>";
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$subscriber_array_count=".$subscriber_array_count." <br>";

			if ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent'] == TRUE) {
				
				// If queue was sent, delete queue related session data
				foreach ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue'] AS $key => $value) {
					$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue'][$key]='';
				}

				// newsletters already have been sent.
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Newsletters already have been sent. <br>";
				$js_closewindow = abdj_JsCloseWindow($GLOBALS['abdj_config']['url_link_prefix'].$GLOBALS['abdj_lang_common']['close_window'], "", "");
				$html_queue['msg'] .= "<fieldset class=\"abdjadminform\"><legend class=\"abdjadminform\">".$GLOBALS['abdj_lang_newsletter']['sendnews_queue_caption']."</legend><div class=\"abdjadminform\">";
				$html_queue['msg'] .= $GLOBALS['abdj_lang_newsletter']['sendnews_queue_sent']."<br><br><br><div style=\"text-align:center;\">".$js_closewindow."</div>";
				$html_queue['msg'] .= "</div></fieldset>";
			} //if ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent'] == TRUE)
			else {
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": if (($sent_count != ".$GLOBALS['abdj_config_newsletter']['queue_amount'].") OR (".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count']." == ".$subscriber_array_count.")) <br>";
				if ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count'] >= $subscriber_array_count) {
					// All newsletters have been sent.
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": All newsletters have been sent. <br>";

					$js_closewindow = abdj_JsCloseWindow($GLOBALS['abdj_config']['url_link_prefix'].$GLOBALS['abdj_lang_common']['close_window'], "", "");

					// delete (unlink) attachment files after sending the newsletter.
					if ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_attachments_delete'] == "yes") {
						$attachments_deleted = $GLOBALS['abdj_obj_common']->Delete_DirectoryContent($GLOBALS['abdj_path_newsletter_attachments']);
						//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$attachments_deleted['msg_all']=".$attachments_deleted['msg_all']." <br>";
						//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$attachments_deleted['msg']=".$attachments_deleted['msg']." <br>";
					}

					$html_queue['msg'] .= "<fieldset class=\"abdjadminform\"><legend class=\"abdjadminform\">".$GLOBALS['abdj_lang_newsletter']['sendnews_queue_caption']."</legend><div class=\"abdjadminform\">";
					$html_queue['msg'] .= $GLOBALS['abdj_lang_newsletter']['sendnews_queue_sent']."<br><br>".$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent_count']." ".$GLOBALS['abdj_lang_newsletter']['sendnews']."<br><br><form><textarea style=\"width:100%; height:80px;\" rows=\"0\" cols=\"0\">".$html_queue_sent_items."</textarea></form><br><br><div style=\"text-align:center;\">".$js_closewindow."</div>";
					$html_queue['msg'] .= "</div></fieldset>";

					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": All newsletters have been sent. Set sent=TRUE <br>";
					$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent'] = TRUE;
				}
			} // else if ($_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['sent'] == TRUE)

		} // if ($GLOBALS['abdj_config_newsletter']['feature_send_newsletter'] == TRUE)

		return $html_queue;
	} // function Newsletter_Queue()

	function Read_Template_File() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		if (@ file_exists($GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_template_news'])) {
			$file_template_data = $GLOBALS['abdj_obj_common']->Read_File("string", TRUE, $GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_template_news']);
		} else {
			$file_template_data = $GLOBALS['abdj_obj_common']->Read_File("string", TRUE, $GLOBALS['abdj_path_newsletter_data'].$GLOBALS['abdj_config_newsletter']['filename_data_template_news_default']);
		}

		$template_array = split($GLOBALS['abdj_config']['data_spacer'], $file_template_data);
		$newsletters_template = trim($template_array[0]);
		return $newsletters_template;
	} // function Read_Template_File()

	function Show_Newsletter($alias='', $linked=FALSE) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$alias=$alias) <br>";

		/* Newsletter.Alias - START //COMMENT_VERSION_BASIC// */
		if ($GLOBALS['abdj_config']['version'] == 'basic') {
			$GLOBALS['news_alias'] = $GLOBALS['abdj_config_newsletter']['default_alias'];
		}
		/* END //COMMENT_VERSION_BASIC// Newsletter.Alias */

		$show_newsletter = "";
		$newsletter_count = 0;
		$newsletters_template = $this->Read_Template_File();
		$newsletter_array = $this->Read_Newsletter_Array();
		$newsletter_array = array_reverse($newsletter_array);

		foreach ($newsletter_array AS $newsletter) {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$newsletter['newssubject']=".$newsletter['newssubject']." <br>";

			if (!empty ($newsletter['newsalias'])) {
				if (($newsletter['newsalias'] == $GLOBALS['news_alias']) OR ($GLOBALS['news_alias'] == "all")) {
					$newsletter_count ++;
					$newsletter_no = strval($newsletter_count);

					$work_newsletter = $newsletters_template;

					$newsletter['newsdate'] = date($GLOBALS['abdj_config']['date_format_numbers'], $newsletter['newstimestamp']);
					$newsletter['newsdatetime'] = date($GLOBALS['abdj_config']['date_format_numbers']." ".$GLOBALS['abdj_config']['time_format_numbers'], $newsletter['newstimestamp']);
					$newsletter['newstime'] = date($GLOBALS['abdj_config']['time_format_numbers'], $newsletter['newstimestamp']);

					$newsletter['newsmessage'] = $GLOBALS['abdj_obj_common']->CarriageReturnToHTML($newsletter['newsmessage']);
					$newsletter['newsmessage'] = $GLOBALS['abdj_obj_common']->SpacestoHTML($newsletter['newsmessage']);

					$work_newsletter = eregi_replace("{{COUNT}}", $newsletter_no, $work_newsletter);
					$work_newsletter = eregi_replace("{{ID}}", $newsletter['newsid'], $work_newsletter);
					$work_newsletter = eregi_replace("{{ALIAS}}", $newsletter['newsalias'], $work_newsletter);
					$work_newsletter = eregi_replace("{{DATE}}", $newsletter['newsdate'], $work_newsletter);
					$work_newsletter = eregi_replace("{{DATETIME}}", $newsletter['newsdatetime'], $work_newsletter);
					$work_newsletter = eregi_replace("{{TIME}}", $newsletter['newstime'], $work_newsletter);
					$work_newsletter = eregi_replace("{{SUBJECT}}", $newsletter['newssubject'], $work_newsletter);
					$work_newsletter = eregi_replace("{{NEWSLETTER}}", $newsletter['newsmessage'], $work_newsletter);

					//$work_newsletter = $GLOBALS['abdj_obj_common']->CarriageReturnToHTML($work_newsletter);
					//$work_newsletter = $GLOBALS['abdj_obj_common']->SpacestoHTML($work_newsletter);

					//$work_newsletter = eregi_replace("qqreturn", '<br>', $work_newsletter);
					//$work_newsletter = eregi_replace("qqspace", "&nbsp;", $work_newsletter);
					
					$work_newsletter .= '<p class="abdjvcba23newsletter" style="display:inline;"></p>';


					if ($GLOBALS['abdj_config_newsletter']['feature_previousnews_menu'] == TRUE) {
						$show_newsletter_anchors .= $GLOBALS['abdj_config']['url_link_prefix']."<a class=\"abdjnewssubj\" href=\"#news".$newsletter_count."\">".$newsletter_count.". ".$newsletter['newssubject']."</a><a class=\"abdjnewssubjtime\" href=\"#news".$newsletter_count."\"> (".$newsletter['newsdatetime'].")</a><br>";
						$work_newsletter = "<a name=\"news".$newsletter_count."\"></a>".$work_newsletter;
					}
					$show_newsletter .= $work_newsletter;
				} // if (($newsletter['newsalias'] == $GLOBALS['news_alias']) OR ($GLOBALS['news_alias'] == "all"))
			} // if (!empty($newsletter['newsalias']))
		} // foreach

		if ($newsletter_count == 0) {
			$show_newsletter = $GLOBALS['abdj_lang_newsletter']['shownewsletter_previous_none'];
		}
		if ($GLOBALS['abdj_config_newsletter']['feature_previousnews_menu'] == TRUE) {
			$show_newsletter_anchors_spacer = "<br><br>";
			/* Script.Copyright - START //COMMENT_VERSION_BASIC// */
			if (($GLOBALS['abdj_config']['version'] == 'basic') OR ($GLOBALS['abdj_config']['feature_script_ad'] == TRUE)) {
				$newsletter_copyright = '<br>'.$GLOBALS['abdj_url_copyright_dark'].'<br>';
			}
			/* END //COMMENT_VERSION_BASIC// Script.Copyright */
		}
		$show_newsletter = $show_newsletter_anchors.$newsletter_copyright.$show_newsletter_anchors_spacer.$show_newsletter.'<br>';

		//$show_newsletter = "previous news ...";
		return $show_newsletter;
	} // Show_Newsletter()

	function Format_Newsletter($action, $message, $subscriber) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action) <br>";

		if (!isset ($subscriber['substoken'])) {
			$subscriber['substoken'] = '';
		}

		$message['message'] = str_replace("\\'", "'", $message['message']);
		$message['subject'] = str_replace("\\'", "'", $message['subject']);
		$message['message'] = str_replace("\\\"", "\"", $message['message']);
		$message['subject'] = str_replace("\\\"", "\"", $message['subject']);

		if ($action == "preview") {
			$message['message'] = $GLOBALS['abdj_obj_common']->CarriageReturnToHTML($message['message']);
			$message['message'] = $GLOBALS['abdj_obj_common']->SpacestoHTML($message['message']);
			/*
			$message['message'] = str_replace("\r\n", '<br>', $message['message']);
			$message['message'] = str_replace("\n", '<br>', $message['message']);
			$message['message'] = str_replace("   ", "&nbsp;&nbsp;&nbsp;", $message['message']);
			$message['message'] = str_replace("  ", "&nbsp;&nbsp;", $message['message']);
			*/
		}
		if ($action == "save") {
			/*
			$message['message'] = str_replace("\r\n", "qqreturn", $message['message']);
			$message['message'] = str_replace("\n", "qqreturn", $message['message']);
			$message['message'] = str_replace("   ", "qqspaceqqspaceqqspace", $message['message']);
			$message['message'] = str_replace("  ", "qqspaceqqspace", $message['message']);
			*/
		}

		if (($action == "preview") OR ($action == "save") OR ($action == "mail")) {
			global $cf;

			if ($action == "save") {
				$subscriber['subsname'] = "subscriber";
				$subscriber['subsemail'] = "subscriber@default.com";
				$subscriber['subsdate'] = "(subscriber date)";
				$subscriber['subsdatetime'] = "(subscriber datetime)";
			}

			foreach ($message AS $key => $value) {
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": $key => $value <br>";
				$message[$key] = eregi_replace("{{SUBSNAME}}", $subscriber['subsname'], $message[$key]);
				$message[$key] = eregi_replace("{{SUBSEMAIL}}", $subscriber['subsemail'], $message[$key]);
				$message[$key] = eregi_replace("{{SUBSDATE}}", $subscriber['subsdate'], $message[$key]);
				$message[$key] = eregi_replace("{{SUBSDATETIME}}", $subscriber['subsdatetime'], $message[$key]);
				
				$message[$key] = eregi_replace("{{SUBJECT}}", $message['subject'], $message[$key]);
				$message[$key] = eregi_replace("{{SITENAME}}", $cf['site']['title'], $message[$key]);
				$message[$key] = eregi_replace("{{DOMAIN}}", $GLOBALS['abdj_config']['url_root'], $message[$key]);
				$message[$key] = eregi_replace("{{URLNEWSLETTER}}", $GLOBALS['abdj_config_newsletter']['url'], $message[$key]);
				$message[$key] = eregi_replace("{{EMAIL}}", $GLOBALS['abdj_config_newsletter']['admin_email'], $message[$key]);
				$message[$key] = eregi_replace("{{DATE}}", $GLOBALS['abdj_config']['date'], $message[$key]);
				$message[$key] = eregi_replace("{{DATETIME}}", $GLOBALS['abdj_config']['datetime'], $message[$key]);

			} // foreach
		} //if ( ($action == "preview") OR ($action == "save") OR ($action == "mail") )
		
		if ($action == "preview") {
			//$format['newsletter'] = "<br><br><b>".$GLOBALS['abdj_lang_newsletter']['sendnews_caption_preview']." ".$message['alias']."</b><hr><b>".$message['subject']." (".date($GLOBALS['abdj_config']['date_format_numbers']." - ".$GLOBALS['abdj_config']['time_format_numbers']).")</b><hr><div style=\"width:80%;\" >".$message['message']."</div><hr>";

			$format['newsletter'] = "<fieldset class=\"abdjadminform\"><legend class=\"abdjadminform\">";
			$format['newsletter'] .= $GLOBALS['abdj_lang_newsletter']['sendnews_caption_preview']." '".$message['alias']."'";
			$format['newsletter'] .= "</legend>";
			$format['newsletter'] .= "<div class=\"abdjadminform\">";
			$format['newsletter'] .= "<b>".$message['subject']." (".date($GLOBALS['abdj_config']['date_format_numbers']." - ".$GLOBALS['abdj_config']['time_format_numbers']).")</b><hr><div style=\"width:80%;\" >".$message['message']."</div>";
			$format['newsletter'] .= "</div>";
			$format['newsletter'] .= "</fieldset>";

		}
		if ($action == "save") {
			$format['newsletter'] = $message['id'].$GLOBALS['abdj_config']['data_spacer'].$message['alias'].$GLOBALS['abdj_config']['data_spacer'].$message['subject'].$GLOBALS['abdj_config']['data_spacer'].$GLOBALS['abdj_config']['timestamp'].$GLOBALS['abdj_config']['data_spacer'].$message['message']."\n";
		}

		$format['message'] = $message;
		return $format;
	} // function Format_Newsletter)

	function Save_Newsletter($message, $subscriber) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$message['feature_savenewsletter']=".$message['feature_savenewsletter']." <br>";
		if ( ($message['feature_savenewsletter'] == "no" OR $message['feature_savenewsletter'] == FALSE) AND ($GLOBALS['abdj_config']['version'] != "basic")) {
			// newsletter will not be stored in file
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": newsletter will not be stored in file <br>";
		} else {
			$message['id'] = $this->Newsletter_ID("newsletter", "add");

			$format_newsletter = $this->Format_Newsletter("save", $message, $subscriber);
			$newsletter[] = $format_newsletter['newsletter'];

			//$previous_newsletters = $GLOBALS['abdj_obj_common']->Read_File("STRING", FALSE, $GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_newsletters']);
			$GLOBALS['abdj_obj_common']->Write_File($GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_newsletters'], FALSE, "APPEND", "DATAARRAY", $newsletter);
			//$GLOBALS['abdj_obj_common']->Write_File($GLOBALS['abdj_path_newsletter_data_2lang'].$GLOBALS['abdj_config_newsletter']['filename_data_newsletters'], FALSE, "APPEND", "STRING", $newsletter);
		}
	} // function Save_Newsletter()

	function Send_Newsletter($action) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$action=$action) <br>";

		$error_msg = ARRAY ();
		$form = ARRAY ();
		$newsletter = '';
		$attachment_move_success = FALSE;
		$subscriber = ARRAY ('subsname' => '', 'subsemail' => '', 'subsdate' => '', 'subsdatetime' => '');

		if (isset ($_POST['abdj_newsletter_feature_copytoadmin'])) {
			$form['feature_copytoadmin'] = $_POST['abdj_newsletter_feature_copytoadmin'];
		} else {
			$form['feature_copytoadmin'] = FALSE;
		}
        //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$form['feature_copytoadmin']=".$form['feature_copytoadmin']." <br>";

		if (isset ($_POST['abdj_newsletter_feature_savenewsletter'])) {
			$form['feature_savenewsletter'] = $_POST['abdj_newsletter_feature_savenewsletter'];
		} else {
			$form['feature_savenewsletter'] = FALSE;
		}
        //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$form['feature_savenewsletter']=".$form['feature_savenewsletter']." <br>";

		if (isset ($_POST['abdj_newsletter_alias'])) {
			$form['alias'] = $_POST['abdj_newsletter_alias'];
		} else {
			$form['alias'] = '';
		}

		if (empty ($form['alias'])) {
			$form['alias'] = $GLOBALS['news_alias'] = $GLOBALS['abdj_config_newsletter']['default_alias'];
		}

		if (isset ($_POST['abdj_newsletter_msg_subject'])) {
			$form['subject'] = $_POST['abdj_newsletter_msg_subject'];
		} else {
			$form['subject'] = '';
		}
		if (isset ($_POST['abdj_newsletter_msg_message'])) {
			$form['message'] = $_POST['abdj_newsletter_msg_message'];
		} else {
			$form['message'] = '';
		}
		if (isset ($_POST['abdj_newsletter_msg_from'])) {
			$form['from'] = $_POST['abdj_newsletter_msg_from'];
		} else {
			$form['from'] = '';
		}
		if (isset ($_POST['abdj_newsletter_msg_feature_attachments_send'])) {
			$form['feature_attachments_send'] = $_POST['abdj_newsletter_msg_feature_attachments_send'];
		} else {
			$form['feature_attachments_send'] = FALSE;
		}
		if (isset ($_POST['abdj_newsletter_msg_feature_attachments_delete'])) {
			$form['feature_attachments_delete'] = $_POST['abdj_newsletter_msg_feature_attachments_delete'];
		} else {
			$form['feature_attachments_delete'] = FALSE;
		}
		if (isset ($_POST['abdj_newsletter_submit_preview'])) {
			$form['submit_preview'] = $_POST['abdj_newsletter_submit_preview'];
		} else {
			$form['submit_preview'] = '';
		}

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$form['feature_attachments_delete']=".$form['feature_attachments_delete']." <br>";
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$form['alias']=".$form['alias']." <br>";

		if ($action == "queue") {
			$newsletter .= $this->CMS_Newsletter_Queue();
		}

		if ($action == "message") {
			if (empty ($_POST['abdj_newsletter_submit']) AND empty ($form['submit_preview'])) {
				
				// Reset session_queue variables, if starting to write a new (an other) newsletter. 
				$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']=ARRAY();
				
				$msg_admin = ARRAY ();
				$msg_admin['from'] = $GLOBALS['abdj_config_newsletter']['admin_email'];
				$msg_admin['subject'] = $GLOBALS['abdj_lang_newsletter']['sendnews_default_subject'];
				
				$msg_admin['message'] = $GLOBALS['abdj_lang_newsletter']['sendnews_default_message'];
				
				$msg_admin['message'] .= $GLOBALS['abdj_lang_newsletter']['sendnews_default_title'];
				$newsletter .= $this->Newsletter_Form($msg_admin, $error_msg);
			} // if (empty ($_POST['abdj_newsletter_submit']) AND empty ($form['submit_preview']))
			else {

				$proof_message = TRUE;

				$regex = '^([._a-z0-9-]+[._a-z0-9-]*)@(([a-z0-9-]+\.)*([a-z0-9-]+)(\.[a-z]{2,4}))$';
				if (!eregi($regex, $form['from'])) {
					$proof_message = FALSE;
					$error_msg['subsemail'] = $GLOBALS['abdj_lang']['g_error_format_email'];
				}

				if (empty ($form['subject'])) {
					$proof_message = FALSE;
					$error_msg['subject'] = $GLOBALS['abdj_lang']['g_error_empty_subject'];
				}
				if (empty ($form['message'])) {
					$proof_message = FALSE;
					$error_msg['message'] = $GLOBALS['abdj_lang']['g_error_empty_message'];
				}
				$error_msg = $this->Format_Error($error_msg);

				// if errors in form or if a file was uploaded sucessfully, show form again
				if (($proof_message == FALSE) OR ($attachment_move_success == TRUE)) {
					$newsletter .= $this->Newsletter_Form($form, $error_msg);
				} else {
					if (!empty ($form['submit_preview'])) {
						// replace placeholders and slashes
						$subscriber['subsname'] = $GLOBALS['abdj_lang_newsletter']['sendnews_field_subscriber'];
						$subscriber['subsemail'] = "{".$GLOBALS['abdj_lang_newsletter']['sendnews_hint_placeholder_subscriber_email']."}";
						$subscriber['subsdate'] = "{".$GLOBALS['abdj_lang_newsletter']['sendnews_hint_placeholder_subscriber_subscription_date']."}";
						$subscriber['subsdatetime'] = "{".$GLOBALS['abdj_lang_newsletter']['sendnews_hint_placeholder_subscriber_subscription_datetime']."}";

						$format_newsletter = $this->Format_Newsletter("preview", $form, $subscriber);
						$preview = $format_newsletter['newsletter'];

						$form = $this->Newsletter_Form($form, $error_msg);
						$newsletter .= $preview."<br><br>".$form;
					} // if (!empty ($form['submit_preview']))
					if (!empty ($_POST['abdj_newsletter_submit'])) {
						//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": SUBMIT <br>";
						if (($form['feature_savenewsletter'] == "yes") OR ($GLOBALS['abdj_config']['version'] == 'basic')) {
							$save_form = $form;

							$msg_header = $GLOBALS['abdj_lang_newsletter']['sendnews_default_message'];
							$msg_header = str_replace("\n", "\r\n", $msg_header);

							$save_form['message'] = str_replace($msg_header, '', $save_form['message']);

							// Save sent newsletter to file.
							$this->Save_Newsletter($save_form, $subscriber);
						} // if ($form['feature_savenewsletter'] == "yes")


						$form['subject'] = $GLOBALS['abdj_obj_common']->PostStringTofileString($form['subject']);
						$form['message'] = $GLOBALS['abdj_obj_common']->PostStringTofileString($form['message']);
						
						$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['alias']=$form['alias'];
						$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_attachments_send']=$form['feature_attachments_send'];
						$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_attachments_delete']=$form['feature_attachments_delete'];
						$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['feature_copytoadmin']=$form['feature_copytoadmin'];
						$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['from']=$form['from'];
						$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['subject']=$form['subject'];
						$_SESSION[$GLOBALS['abdj_config']['session_name']]['abdj_newsletter_queue']['message']=$form['message'];

						if ($GLOBALS['abdj_config_newsletter']['feature_send_newsletter'] == TRUE) {
							$popup_link['link_text'] = $GLOBALS['abdj_config']['url_link_prefix'].$GLOBALS['abdj_lang_newsletter']['sendnews_queue_desc_link'];
							$popup_link['css_class'] = "";
							$popup_link['css_id'] = "";

							$popup_window['title'] = "NewsletterQueue";
							$popup_window['url'] = $GLOBALS['abdj_url_admin_newsletter_queue'].$GLOBALS['abdj_url_amp']."abdj_get_queue_start=1";
							$popup_window['width'] = "400";
							$popup_window['height'] = "300";
							$popup_window['left'] = "100";
							$popup_window['top'] = "100";
							$popup_window['scrollbars'] = "auto";
							$popup_window['toolbar'] = "no";
							$popup_window['menubar'] = "no";
							$popup_window['status'] = "no";
							$popup_window['dependent'] = "yes";
							$popup_window['hotkeys'] = "yes";
							$popup_window['innerHeight'] = "20";
							$popup_window['innerWidth'] = "300";
							$popup_window['location'] = "no";
							$popup_window['resizable'] = "yes";
							$popup_window['screenX'] = "120";
							$popup_window['screenY'] = "200";

							$popup = abdj_JsPopupWindow($popup_window, $popup_link, TRUE);

							//$hjs .= "\n<script language=\"JavaScript\">\n<!--\nfunction AbdjJsWindow(url,name,options)\n\n{window.open(url,name,options);\n}\n-->\n</script>\n";
							$newsletter .= "<fieldset class=\"abdjadminform\"><legend class=\"abdjadminform\">".$GLOBALS['abdj_lang_newsletter']['sendnews_queue_caption']."</legend><div class=\"abdjadminform\">";
							$newsletter .= $GLOBALS['abdj_lang_newsletter']['sendnews_queue_desc']."<br><br>";
							$newsletter .= $popup['link'];
							$newsletter .= "</div></fieldset>";
						} // if ($GLOBALS['abdj_config_newsletter']['feature_send_newsletter'] == TRUE)
						else {
							// newsletters will not be send
							$newsletter .= "<fieldset class=\"abdjadminform\"><legend class=\"abdjadminform\">".$GLOBALS['abdj_lang_newsletter']['sendnews_queue_caption']."</legend><div class=\"abdjadminform\">";
							$newsletter .= $GLOBALS['abdj_lang_newsletter']['sendnews_queue_feature_sent_off'];
							$newsletter .= "</div></fieldset>";
						}

					}
				}

			}
		} // if ($action == "message")
		return $newsletter;
	} // function Send_Newsletter()

} // class Abdj_Newsletter

?>